#====================================================================
#
#               Winim - Nim's Windows API Module
#                 (c) Copyright 2016-2021 Ward
#
#====================================================================

import windef
#include <error.h>
#include <winerror.h>
#include <fltwinerror.h>
const
  NO_ERROR* = 0
  ERROR_INVALID_FUNCTION* = 1
  ERROR_FILE_NOT_FOUND* = 2
  ERROR_PATH_NOT_FOUND* = 3
  ERROR_TOO_MANY_OPEN_FILES* = 4
  ERROR_ACCESS_DENIED* = 5
  ERROR_INVALID_HANDLE* = 6
  ERROR_ARENA_TRASHED* = 7
  ERROR_NOT_ENOUGH_MEMORY* = 8
  ERROR_INVALID_BLOCK* = 9
  ERROR_BAD_ENVIRONMENT* = 10
  ERROR_BAD_FORMAT* = 11
  ERROR_INVALID_ACCESS* = 12
  ERROR_INVALID_DATA* = 13
  ERROR_INVALID_DRIVE* = 15
  ERROR_CURRENT_DIRECTORY* = 16
  ERROR_NOT_SAME_DEVICE* = 17
  ERROR_NO_MORE_FILES* = 18
  ERROR_WRITE_PROTECT* = 19
  ERROR_BAD_UNIT* = 20
  ERROR_NOT_READY* = 21
  ERROR_BAD_COMMAND* = 22
  ERROR_CRC* = 23
  ERROR_BAD_LENGTH* = 24
  ERROR_SEEK* = 25
  ERROR_NOT_DOS_DISK* = 26
  ERROR_SECTOR_NOT_FOUND* = 27
  ERROR_OUT_OF_PAPER* = 28
  ERROR_WRITE_FAULT* = 29
  ERROR_READ_FAULT* = 30
  ERROR_GEN_FAILURE* = 31
  ERROR_SHARING_VIOLATION* = 32
  ERROR_LOCK_VIOLATION* = 33
  ERROR_WRONG_DISK* = 34
  ERROR_FCB_UNAVAILABLE* = 35
  ERROR_SHARING_BUFFER_EXCEEDED* = 36
  ERROR_NOT_SUPPORTED* = 50
  ERROR_FILE_EXISTS* = 80
  ERROR_DUP_FCB* = 81
  ERROR_CANNOT_MAKE* = 82
  ERROR_FAIL_I24* = 83
  ERROR_OUT_OF_STRUCTURES* = 84
  ERROR_ALREADY_ASSIGNED* = 85
  ERROR_INVALID_PASSWORD* = 86
  ERROR_INVALID_PARAMETER* = 87
  ERROR_NET_WRITE_FAULT* = 88
  ERROR_NO_PROC_SLOTS* = 89
  ERROR_NOT_FROZEN* = 90
  ERR_TSTOVFL* = 91
  ERR_TSTDUP* = 92
  ERROR_NO_ITEMS* = 93
  ERROR_INTERRUPT* = 95
  ERROR_TOO_MANY_SEMAPHORES* = 100
  ERROR_EXCL_SEM_ALREADY_OWNED* = 101
  ERROR_SEM_IS_SET* = 102
  ERROR_TOO_MANY_SEM_REQUESTS* = 103
  ERROR_INVALID_AT_INTERRUPT_TIME* = 104
  ERROR_SEM_OWNER_DIED* = 105
  ERROR_SEM_USER_LIMIT* = 106
  ERROR_DISK_CHANGE* = 107
  ERROR_DRIVE_LOCKED* = 108
  ERROR_BROKEN_PIPE* = 109
  ERROR_OPEN_FAILED* = 110
  ERROR_BUFFER_OVERFLOW* = 111
  ERROR_DISK_FULL* = 112
  ERROR_NO_MORE_SEARCH_HANDLES* = 113
  ERROR_INVALID_TARGET_HANDLE* = 114
  ERROR_PROTECTION_VIOLATION* = 115
  ERROR_VIOKBD_REQUEST* = 116
  ERROR_INVALID_CATEGORY* = 117
  ERROR_INVALID_VERIFY_SWITCH* = 118
  ERROR_BAD_DRIVER_LEVEL* = 119
  ERROR_CALL_NOT_IMPLEMENTED* = 120
  ERROR_SEM_TIMEOUT* = 121
  ERROR_INSUFFICIENT_BUFFER* = 122
  ERROR_INVALID_NAME* = 123
  ERROR_INVALID_LEVEL* = 124
  ERROR_NO_VOLUME_LABEL* = 125
  ERROR_MOD_NOT_FOUND* = 126
  ERROR_PROC_NOT_FOUND* = 127
  ERROR_WAIT_NO_CHILDREN* = 128
  ERROR_CHILD_NOT_COMPLETE* = 129
  ERROR_DIRECT_ACCESS_HANDLE* = 130
  ERROR_NEGATIVE_SEEK* = 131
  ERROR_SEEK_ON_DEVICE* = 132
  ERROR_IS_JOIN_TARGET* = 133
  ERROR_IS_JOINED* = 134
  ERROR_IS_SUBSTED* = 135
  ERROR_NOT_JOINED* = 136
  ERROR_NOT_SUBSTED* = 137
  ERROR_JOIN_TO_JOIN* = 138
  ERROR_SUBST_TO_SUBST* = 139
  ERROR_JOIN_TO_SUBST* = 140
  ERROR_SUBST_TO_JOIN* = 141
  ERROR_BUSY_DRIVE* = 142
  ERROR_SAME_DRIVE* = 143
  ERROR_DIR_NOT_ROOT* = 144
  ERROR_DIR_NOT_EMPTY* = 145
  ERROR_IS_SUBST_PATH* = 146
  ERROR_IS_JOIN_PATH* = 147
  ERROR_PATH_BUSY* = 148
  ERROR_IS_SUBST_TARGET* = 149
  ERROR_SYSTEM_TRACE* = 150
  ERROR_INVALID_EVENT_COUNT* = 151
  ERROR_TOO_MANY_MUXWAITERS* = 152
  ERROR_INVALID_LIST_FORMAT* = 153
  ERROR_LABEL_TOO_LONG* = 154
  ERROR_TOO_MANY_TCBS* = 155
  ERROR_SIGNAL_REFUSED* = 156
  ERROR_DISCARDED* = 157
  ERROR_NOT_LOCKED* = 158
  ERROR_BAD_THREADID_ADDR* = 159
  ERROR_BAD_ARGUMENTS* = 160
  ERROR_BAD_PATHNAME* = 161
  ERROR_SIGNAL_PENDING* = 162
  ERROR_UNCERTAIN_MEDIA* = 163
  ERROR_MAX_THRDS_REACHED* = 164
  ERROR_MONITORS_NOT_SUPPORTED* = 165
  ERROR_INVALID_SEGMENT_NUMBER* = 180
  ERROR_INVALID_CALLGATE* = 181
  ERROR_INVALID_ORDINAL* = 182
  ERROR_ALREADY_EXISTS* = 183
  ERROR_NO_CHILD_PROCESS* = 184
  ERROR_CHILD_ALIVE_NOWAIT* = 185
  ERROR_INVALID_FLAG_NUMBER* = 186
  ERROR_SEM_NOT_FOUND* = 187
  ERROR_INVALID_STARTING_CODESEG* = 188
  ERROR_INVALID_STACKSEG* = 189
  ERROR_INVALID_MODULETYPE* = 190
  ERROR_INVALID_EXE_SIGNATURE* = 191
  ERROR_EXE_MARKED_INVALID* = 192
  ERROR_BAD_EXE_FORMAT* = 193
  ERROR_ITERATED_DATA_EXCEEDS_64k* = 194
  ERROR_INVALID_MINALLOCSIZE* = 195
  ERROR_DYNLINK_FROM_INVALID_RING* = 196
  ERROR_IOPL_NOT_ENABLED* = 197
  ERROR_INVALID_SEGDPL* = 198
  ERROR_AUTODATASEG_EXCEEDS_64k* = 199
  ERROR_RING2SEG_MUST_BE_MOVABLE* = 200
  ERROR_RELOC_CHAIN_XEEDS_SEGLIM* = 201
  ERROR_INFLOOP_IN_RELOC_CHAIN* = 202
  ERROR_ENVVAR_NOT_FOUND* = 203
  ERROR_NOT_CURRENT_CTRY* = 204
  ERROR_NO_SIGNAL_SENT* = 205
  ERROR_FILENAME_EXCED_RANGE* = 206
  ERROR_RING2_STACK_IN_USE* = 207
  ERROR_META_EXPANSION_TOO_LONG* = 208
  ERROR_INVALID_SIGNAL_NUMBER* = 209
  ERROR_THREAD_1_INACTIVE* = 210
  ERROR_INFO_NOT_AVAIL* = 211
  ERROR_LOCKED* = 212
  ERROR_BAD_DYNALINK* = 213
  ERROR_TOO_MANY_MODULES* = 214
  ERROR_NESTING_NOT_ALLOWED* = 215
  ERROR_USER_DEFINED_BASE* = 0xF000
  ERROR_I24_WRITE_PROTECT* = 0
  ERROR_I24_BAD_UNIT* = 1
  ERROR_I24_NOT_READY* = 2
  ERROR_I24_BAD_COMMAND* = 3
  ERROR_I24_CRC* = 4
  ERROR_I24_BAD_LENGTH* = 5
  ERROR_I24_SEEK* = 6
  ERROR_I24_NOT_DOS_DISK* = 7
  ERROR_I24_SECTOR_NOT_FOUND* = 8
  ERROR_I24_OUT_OF_PAPER* = 9
  ERROR_I24_WRITE_FAULT* = 0x0A
  ERROR_I24_READ_FAULT* = 0x0B
  ERROR_I24_GEN_FAILURE* = 0x0C
  ERROR_I24_DISK_CHANGE* = 0x0D
  ERROR_I24_WRONG_DISK* = 0x0F
  ERROR_I24_UNCERTAIN_MEDIA* = 0x10
  ERROR_I24_CHAR_CALL_INTERRUPTED* = 0x11
  ERROR_I24_NO_MONITOR_SUPPORT* = 0x12
  ERROR_I24_INVALID_PARAMETER* = 0x13
  ALLOWED_FAIL* = 0x0001
  ALLOWED_ABORT* = 0x0002
  ALLOWED_RETRY* = 0x0004
  ALLOWED_IGNORE* = 0x0008
  I24_OPERATION* = 0x1
  I24_AREA* = 0x6
  I24_CLASS* = 0x80
  ERRCLASS_OUTRES* = 1
  ERRCLASS_TEMPSIT* = 2
  ERRCLASS_AUTH* = 3
  ERRCLASS_INTRN* = 4
  ERRCLASS_HRDFAIL* = 5
  ERRCLASS_SYSFAIL* = 6
  ERRCLASS_APPERR* = 7
  ERRCLASS_NOTFND* = 8
  ERRCLASS_BADFMT* = 9
  ERRCLASS_LOCKED* = 10
  ERRCLASS_MEDIA* = 11
  ERRCLASS_ALREADY* = 12
  ERRCLASS_UNK* = 13
  ERRCLASS_CANT* = 14
  ERRCLASS_TIME* = 15
  ERRACT_RETRY* = 1
  ERRACT_DLYRET* = 2
  ERRACT_USER* = 3
  ERRACT_ABORT* = 4
  ERRACT_PANIC* = 5
  ERRACT_IGNORE* = 6
  ERRACT_INTRET* = 7
  ERRLOC_UNK* = 1
  ERRLOC_DISK* = 2
  ERRLOC_NET* = 3
  ERRLOC_SERDEV* = 4
  ERRLOC_MEM* = 5
  TC_NORMAL* = 0
  TC_HARDERR* = 1
  TC_GP_TRAP* = 2
  TC_SIGNAL* = 3
  IN_WINERROR* = 1
  FACILITY_WINDOWSUPDATE* = 36
  FACILITY_WINDOWS_CE* = 24
  FACILITY_WINDOWS* = 8
  FACILITY_URT* = 19
  FACILITY_UMI* = 22
  FACILITY_SXS* = 23
  FACILITY_STORAGE* = 3
  FACILITY_STATE_MANAGEMENT* = 34
  FACILITY_SSPI* = 9
  FACILITY_SCARD* = 16
  FACILITY_SETUPAPI* = 15
  FACILITY_SECURITY* = 9
  FACILITY_RPC* = 1
  FACILITY_WIN32* = 7
  FACILITY_CONTROL* = 10
  FACILITY_NULL* = 0
  FACILITY_METADIRECTORY* = 35
  FACILITY_MSMQ* = 14
  FACILITY_MEDIASERVER* = 13
  FACILITY_INTERNET* = 12
  FACILITY_ITF* = 4
  FACILITY_HTTP* = 25
  FACILITY_DPLAY* = 21
  FACILITY_DISPATCH* = 2
  FACILITY_DIRECTORYSERVICE* = 37
  FACILITY_CONFIGURATION* = 33
  FACILITY_COMPLUS* = 17
  FACILITY_CERT* = 11
  FACILITY_BACKGROUNDCOPY* = 32
  FACILITY_ACS* = 20
  FACILITY_AAF* = 18
  FACILITY_AUDCLNT* = 2185
  ERROR_SUCCESS* = 0
  SEC_E_OK* = HRESULT 0x00000000
  ERROR_OUTOFMEMORY* = 14
  ERROR_HANDLE_EOF* = 38
  ERROR_HANDLE_DISK_FULL* = 39
  ERROR_REM_NOT_LIST* = 51
  ERROR_DUP_NAME* = 52
  ERROR_BAD_NETPATH* = 53
  ERROR_NETWORK_BUSY* = 54
  ERROR_DEV_NOT_EXIST* = 55
  ERROR_TOO_MANY_CMDS* = 56
  ERROR_ADAP_HDW_ERR* = 57
  ERROR_BAD_NET_RESP* = 58
  ERROR_UNEXP_NET_ERR* = 59
  ERROR_BAD_REM_ADAP* = 60
  ERROR_PRINTQ_FULL* = 61
  ERROR_NO_SPOOL_SPACE* = 62
  ERROR_PRINT_CANCELLED* = 63
  ERROR_NETNAME_DELETED* = 64
  ERROR_NETWORK_ACCESS_DENIED* = 65
  ERROR_BAD_DEV_TYPE* = 66
  ERROR_BAD_NET_NAME* = 67
  ERROR_TOO_MANY_NAMES* = 68
  ERROR_TOO_MANY_SESS* = 69
  ERROR_SHARING_PAUSED* = 70
  ERROR_REQ_NOT_ACCEP* = 71
  ERROR_REDIR_PAUSED* = 72
  ERROR_LOCK_FAILED* = 167
  ERROR_BUSY* = 170
  ERROR_CANCEL_VIOLATION* = 173
  ERROR_ATOMIC_LOCKS_NOT_SUPPORTED* = 174
  ERROR_EXE_MACHINE_TYPE_MISMATCH* = 216
  ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY* = 217
  ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY* = 218
  ERROR_FILE_CHECKED_OUT* = 220
  ERROR_CHECKOUT_REQUIRED* = 221
  ERROR_BAD_FILE_TYPE* = 222
  ERROR_FILE_TOO_LARGE* = 223
  ERROR_FORMS_AUTH_REQUIRED* = 224
  ERROR_PIPE_LOCAL* = 229
  ERROR_BAD_PIPE* = 230
  ERROR_PIPE_BUSY* = 231
  ERROR_NO_DATA* = 232
  ERROR_PIPE_NOT_CONNECTED* = 233
  ERROR_MORE_DATA* = 234
  ERROR_VC_DISCONNECTED* = 240
  ERROR_INVALID_EA_NAME* = 254
  ERROR_EA_LIST_INCONSISTENT* = 255
  WAIT_TIMEOUT* = 258
  ERROR_NO_MORE_ITEMS* = 259
  ERROR_CANNOT_COPY* = 266
  ERROR_DIRECTORY* = 267
  ERROR_EAS_DIDNT_FIT* = 275
  ERROR_EA_FILE_CORRUPT* = 276
  ERROR_EA_TABLE_FULL* = 277
  ERROR_INVALID_EA_HANDLE* = 278
  ERROR_EAS_NOT_SUPPORTED* = 282
  ERROR_NOT_OWNER* = 288
  ERROR_TOO_MANY_POSTS* = 298
  ERROR_PARTIAL_COPY* = 299
  ERROR_OPLOCK_NOT_GRANTED* = 300
  ERROR_INVALID_OPLOCK_PROTOCOL* = 301
  ERROR_DISK_TOO_FRAGMENTED* = 302
  ERROR_DELETE_PENDING* = 303
  ERROR_MR_MID_NOT_FOUND* = 317
  ERROR_SCOPE_NOT_FOUND* = 318
  ERROR_INVALID_ADDRESS* = 487
  ERROR_ARITHMETIC_OVERFLOW* = 534
  ERROR_PIPE_CONNECTED* = 535
  ERROR_PIPE_LISTENING* = 536
  ERROR_WAKE_SYSTEM* = 730
  ERROR_WAIT_1* = 731
  ERROR_WAIT_2* = 732
  ERROR_WAIT_3* = 733
  ERROR_WAIT_63* = 734
  ERROR_ABANDONED_WAIT_0* = 735
  ERROR_ABANDONED_WAIT_63* = 736
  ERROR_USER_APC* = 737
  ERROR_KERNEL_APC* = 738
  ERROR_ALERTED* = 739
  ERROR_EA_ACCESS_DENIED* = 994
  ERROR_OPERATION_ABORTED* = 995
  ERROR_IO_INCOMPLETE* = 996
  ERROR_IO_PENDING* = 997
  ERROR_NOACCESS* = 998
  ERROR_SWAPERROR* = 999
  ERROR_STACK_OVERFLOW* = 1001
  ERROR_INVALID_MESSAGE* = 1002
  ERROR_CAN_NOT_COMPLETE* = 1003
  ERROR_INVALID_FLAGS* = 1004
  ERROR_UNRECOGNIZED_VOLUME* = 1005
  ERROR_FILE_INVALID* = 1006
  ERROR_FULLSCREEN_MODE* = 1007
  ERROR_NO_TOKEN* = 1008
  ERROR_BADDB* = 1009
  ERROR_BADKEY* = 1010
  ERROR_CANTOPEN* = 1011
  ERROR_CANTREAD* = 1012
  ERROR_CANTWRITE* = 1013
  ERROR_REGISTRY_RECOVERED* = 1014
  ERROR_REGISTRY_CORRUPT* = 1015
  ERROR_REGISTRY_IO_FAILED* = 1016
  ERROR_NOT_REGISTRY_FILE* = 1017
  ERROR_KEY_DELETED* = 1018
  ERROR_NO_LOG_SPACE* = 1019
  ERROR_KEY_HAS_CHILDREN* = 1020
  ERROR_CHILD_MUST_BE_VOLATILE* = 1021
  ERROR_NOTIFY_ENUM_DIR* = 1022
  ERROR_DEPENDENT_SERVICES_RUNNING* = 1051
  ERROR_INVALID_SERVICE_CONTROL* = 1052
  ERROR_SERVICE_REQUEST_TIMEOUT* = 1053
  ERROR_SERVICE_NO_THREAD* = 1054
  ERROR_SERVICE_DATABASE_LOCKED* = 1055
  ERROR_SERVICE_ALREADY_RUNNING* = 1056
  ERROR_INVALID_SERVICE_ACCOUNT* = 1057
  ERROR_SERVICE_DISABLED* = 1058
  ERROR_CIRCULAR_DEPENDENCY* = 1059
  ERROR_SERVICE_DOES_NOT_EXIST* = 1060
  ERROR_SERVICE_CANNOT_ACCEPT_CTRL* = 1061
  ERROR_SERVICE_NOT_ACTIVE* = 1062
  ERROR_FAILED_SERVICE_CONTROLLER_CONNECT* = 1063
  ERROR_EXCEPTION_IN_SERVICE* = 1064
  ERROR_DATABASE_DOES_NOT_EXIST* = 1065
  ERROR_SERVICE_SPECIFIC_ERROR* = 1066
  ERROR_PROCESS_ABORTED* = 1067
  ERROR_SERVICE_DEPENDENCY_FAIL* = 1068
  ERROR_SERVICE_LOGON_FAILED* = 1069
  ERROR_SERVICE_START_HANG* = 1070
  ERROR_INVALID_SERVICE_LOCK* = 1071
  ERROR_SERVICE_MARKED_FOR_DELETE* = 1072
  ERROR_SERVICE_EXISTS* = 1073
  ERROR_ALREADY_RUNNING_LKG* = 1074
  ERROR_SERVICE_DEPENDENCY_DELETED* = 1075
  ERROR_BOOT_ALREADY_ACCEPTED* = 1076
  ERROR_SERVICE_NEVER_STARTED* = 1077
  ERROR_DUPLICATE_SERVICE_NAME* = 1078
  ERROR_DIFFERENT_SERVICE_ACCOUNT* = 1079
  ERROR_CANNOT_DETECT_DRIVER_FAILURE* = 1080
  ERROR_CANNOT_DETECT_PROCESS_ABORT* = 1081
  ERROR_NO_RECOVERY_PROGRAM* = 1082
  ERROR_SERVICE_NOT_IN_EXE* = 1083
  ERROR_NOT_SAFEBOOT_SERVICE* = 1084
  ERROR_END_OF_MEDIA* = 1100
  ERROR_FILEMARK_DETECTED* = 1101
  ERROR_BEGINNING_OF_MEDIA* = 1102
  ERROR_SETMARK_DETECTED* = 1103
  ERROR_NO_DATA_DETECTED* = 1104
  ERROR_PARTITION_FAILURE* = 1105
  ERROR_INVALID_BLOCK_LENGTH* = 1106
  ERROR_DEVICE_NOT_PARTITIONED* = 1107
  ERROR_UNABLE_TO_LOCK_MEDIA* = 1108
  ERROR_UNABLE_TO_UNLOAD_MEDIA* = 1109
  ERROR_MEDIA_CHANGED* = 1110
  ERROR_BUS_RESET* = 1111
  ERROR_NO_MEDIA_IN_DRIVE* = 1112
  ERROR_NO_UNICODE_TRANSLATION* = 1113
  ERROR_DLL_INIT_FAILED* = 1114
  ERROR_SHUTDOWN_IN_PROGRESS* = 1115
  ERROR_NO_SHUTDOWN_IN_PROGRESS* = 1116
  ERROR_IO_DEVICE* = 1117
  ERROR_SERIAL_NO_DEVICE* = 1118
  ERROR_IRQ_BUSY* = 1119
  ERROR_MORE_WRITES* = 1120
  ERROR_COUNTER_TIMEOUT* = 1121
  ERROR_FLOPPY_ID_MARK_NOT_FOUND* = 1122
  ERROR_FLOPPY_WRONG_CYLINDER* = 1123
  ERROR_FLOPPY_UNKNOWN_ERROR* = 1124
  ERROR_FLOPPY_BAD_REGISTERS* = 1125
  ERROR_DISK_RECALIBRATE_FAILED* = 1126
  ERROR_DISK_OPERATION_FAILED* = 1127
  ERROR_DISK_RESET_FAILED* = 1128
  ERROR_EOM_OVERFLOW* = 1129
  ERROR_NOT_ENOUGH_SERVER_MEMORY* = 1130
  ERROR_POSSIBLE_DEADLOCK* = 1131
  ERROR_MAPPED_ALIGNMENT* = 1132
  ERROR_SET_POWER_STATE_VETOED* = 1140
  ERROR_SET_POWER_STATE_FAILED* = 1141
  ERROR_TOO_MANY_LINKS* = 1142
  ERROR_OLD_WIN_VERSION* = 1150
  ERROR_APP_WRONG_OS* = 1151
  ERROR_SINGLE_INSTANCE_APP* = 1152
  ERROR_RMODE_APP* = 1153
  ERROR_INVALID_DLL* = 1154
  ERROR_NO_ASSOCIATION* = 1155
  ERROR_DDE_FAIL* = 1156
  ERROR_DLL_NOT_FOUND* = 1157
  ERROR_NO_MORE_USER_HANDLES* = 1158
  ERROR_MESSAGE_SYNC_ONLY* = 1159
  ERROR_SOURCE_ELEMENT_EMPTY* = 1160
  ERROR_DESTINATION_ELEMENT_FULL* = 1161
  ERROR_ILLEGAL_ELEMENT_ADDRESS* = 1162
  ERROR_MAGAZINE_NOT_PRESENT* = 1163
  ERROR_DEVICE_REINITIALIZATION_NEEDED* = 1164
  ERROR_DEVICE_REQUIRES_CLEANING* = 1165
  ERROR_DEVICE_DOOR_OPEN* = 1166
  ERROR_DEVICE_NOT_CONNECTED* = 1167
  ERROR_NOT_FOUND* = 1168
  ERROR_NO_MATCH* = 1169
  ERROR_SET_NOT_FOUND* = 1170
  ERROR_POINT_NOT_FOUND* = 1171
  ERROR_NO_TRACKING_SERVICE* = 1172
  ERROR_NO_VOLUME_ID* = 1173
  ERROR_UNABLE_TO_REMOVE_REPLACED* = 1175
  ERROR_UNABLE_TO_MOVE_REPLACEMENT* = 1176
  ERROR_UNABLE_TO_MOVE_REPLACEMENT_2* = 1177
  ERROR_JOURNAL_DELETE_IN_PROGRESS* = 1178
  ERROR_JOURNAL_NOT_ACTIVE* = 1179
  ERROR_POTENTIAL_FILE_FOUND* = 1180
  ERROR_JOURNAL_ENTRY_DELETED* = 1181
  ERROR_BAD_DEVICE* = 1200
  ERROR_CONNECTION_UNAVAIL* = 1201
  ERROR_DEVICE_ALREADY_REMEMBERED* = 1202
  ERROR_NO_NET_OR_BAD_PATH* = 1203
  ERROR_BAD_PROVIDER* = 1204
  ERROR_CANNOT_OPEN_PROFILE* = 1205
  ERROR_BAD_PROFILE* = 1206
  ERROR_NOT_CONTAINER* = 1207
  ERROR_EXTENDED_ERROR* = 1208
  ERROR_INVALID_GROUPNAME* = 1209
  ERROR_INVALID_COMPUTERNAME* = 1210
  ERROR_INVALID_EVENTNAME* = 1211
  ERROR_INVALID_DOMAINNAME* = 1212
  ERROR_INVALID_SERVICENAME* = 1213
  ERROR_INVALID_NETNAME* = 1214
  ERROR_INVALID_SHARENAME* = 1215
  ERROR_INVALID_PASSWORDNAME* = 1216
  ERROR_INVALID_MESSAGENAME* = 1217
  ERROR_INVALID_MESSAGEDEST* = 1218
  ERROR_SESSION_CREDENTIAL_CONFLICT* = 1219
  ERROR_REMOTE_SESSION_LIMIT_EXCEEDED* = 1220
  ERROR_DUP_DOMAINNAME* = 1221
  ERROR_NO_NETWORK* = 1222
  ERROR_CANCELLED* = 1223
  ERROR_USER_MAPPED_FILE* = 1224
  ERROR_CONNECTION_REFUSED* = 1225
  ERROR_GRACEFUL_DISCONNECT* = 1226
  ERROR_ADDRESS_ALREADY_ASSOCIATED* = 1227
  ERROR_ADDRESS_NOT_ASSOCIATED* = 1228
  ERROR_CONNECTION_INVALID* = 1229
  ERROR_CONNECTION_ACTIVE* = 1230
  ERROR_NETWORK_UNREACHABLE* = 1231
  ERROR_HOST_UNREACHABLE* = 1232
  ERROR_PROTOCOL_UNREACHABLE* = 1233
  ERROR_PORT_UNREACHABLE* = 1234
  ERROR_REQUEST_ABORTED* = 1235
  ERROR_CONNECTION_ABORTED* = 1236
  ERROR_RETRY* = 1237
  ERROR_CONNECTION_COUNT_LIMIT* = 1238
  ERROR_LOGIN_TIME_RESTRICTION* = 1239
  ERROR_LOGIN_WKSTA_RESTRICTION* = 1240
  ERROR_INCORRECT_ADDRESS* = 1241
  ERROR_ALREADY_REGISTERED* = 1242
  ERROR_SERVICE_NOT_FOUND* = 1243
  ERROR_NOT_AUTHENTICATED* = 1244
  ERROR_NOT_LOGGED_ON* = 1245
  ERROR_CONTINUE* = 1246
  ERROR_ALREADY_INITIALIZED* = 1247
  ERROR_NO_MORE_DEVICES* = 1248
  ERROR_NO_SUCH_SITE* = 1249
  ERROR_DOMAIN_CONTROLLER_EXISTS* = 1250
  ERROR_ONLY_IF_CONNECTED* = 1251
  ERROR_OVERRIDE_NOCHANGES* = 1252
  ERROR_BAD_USER_PROFILE* = 1253
  ERROR_NOT_SUPPORTED_ON_SBS* = 1254
  ERROR_SERVER_SHUTDOWN_IN_PROGRESS* = 1255
  ERROR_HOST_DOWN* = 1256
  ERROR_NON_ACCOUNT_SID* = 1257
  ERROR_NON_DOMAIN_SID* = 1258
  ERROR_APPHELP_BLOCK* = 1259
  ERROR_ACCESS_DISABLED_BY_POLICY* = 1260
  ERROR_REG_NAT_CONSUMPTION* = 1261
  ERROR_CSCSHARE_OFFLINE* = 1262
  ERROR_PKINIT_FAILURE* = 1263
  ERROR_SMARTCARD_SUBSYSTEM_FAILURE* = 1264
  ERROR_DOWNGRADE_DETECTED* = 1265
  ERROR_MACHINE_LOCKED* = 1271
  ERROR_CALLBACK_SUPPLIED_INVALID_DATA* = 1273
  ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED* = 1274
  ERROR_DRIVER_BLOCKED* = 1275
  ERROR_INVALID_IMPORT_OF_NON_DLL* = 1276
  ERROR_ACCESS_DISABLED_WEBBLADE* = 1277
  ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER* = 1278
  ERROR_RECOVERY_FAILURE* = 1279
  ERROR_ALREADY_FIBER* = 1280
  ERROR_ALREADY_THREAD* = 1281
  ERROR_STACK_BUFFER_OVERRUN* = 1282
  ERROR_PARAMETER_QUOTA_EXCEEDED* = 1283
  ERROR_DEBUGGER_INACTIVE* = 1284
  ERROR_DELAY_LOAD_FAILED* = 1285
  ERROR_VDM_DISALLOWED* = 1286
  ERROR_UNIDENTIFIED_ERROR* = 1287
  ERROR_NOT_ALL_ASSIGNED* = 1300
  ERROR_SOME_NOT_MAPPED* = 1301
  ERROR_NO_QUOTAS_FOR_ACCOUNT* = 1302
  ERROR_LOCAL_USER_SESSION_KEY* = 1303
  ERROR_NULL_LM_PASSWORD* = 1304
  ERROR_UNKNOWN_REVISION* = 1305
  ERROR_REVISION_MISMATCH* = 1306
  ERROR_INVALID_OWNER* = 1307
  ERROR_INVALID_PRIMARY_GROUP* = 1308
  ERROR_NO_IMPERSONATION_TOKEN* = 1309
  ERROR_CANT_DISABLE_MANDATORY* = 1310
  ERROR_NO_LOGON_SERVERS* = 1311
  ERROR_NO_SUCH_LOGON_SESSION* = 1312
  ERROR_NO_SUCH_PRIVILEGE* = 1313
  ERROR_PRIVILEGE_NOT_HELD* = 1314
  ERROR_INVALID_ACCOUNT_NAME* = 1315
  ERROR_USER_EXISTS* = 1316
  ERROR_NO_SUCH_USER* = 1317
  ERROR_GROUP_EXISTS* = 1318
  ERROR_NO_SUCH_GROUP* = 1319
  ERROR_MEMBER_IN_GROUP* = 1320
  ERROR_MEMBER_NOT_IN_GROUP* = 1321
  ERROR_LAST_ADMIN* = 1322
  ERROR_WRONG_PASSWORD* = 1323
  ERROR_ILL_FORMED_PASSWORD* = 1324
  ERROR_PASSWORD_RESTRICTION* = 1325
  ERROR_LOGON_FAILURE* = 1326
  ERROR_ACCOUNT_RESTRICTION* = 1327
  ERROR_INVALID_LOGON_HOURS* = 1328
  ERROR_INVALID_WORKSTATION* = 1329
  ERROR_PASSWORD_EXPIRED* = 1330
  ERROR_ACCOUNT_DISABLED* = 1331
  ERROR_NONE_MAPPED* = 1332
  ERROR_TOO_MANY_LUIDS_REQUESTED* = 1333
  ERROR_LUIDS_EXHAUSTED* = 1334
  ERROR_INVALID_SUB_AUTHORITY* = 1335
  ERROR_INVALID_ACL* = 1336
  ERROR_INVALID_SID* = 1337
  ERROR_INVALID_SECURITY_DESCR* = 1338
  ERROR_BAD_INHERITANCE_ACL* = 1340
  ERROR_SERVER_DISABLED* = 1341
  ERROR_SERVER_NOT_DISABLED* = 1342
  ERROR_INVALID_ID_AUTHORITY* = 1343
  ERROR_ALLOTTED_SPACE_EXCEEDED* = 1344
  ERROR_INVALID_GROUP_ATTRIBUTES* = 1345
  ERROR_BAD_IMPERSONATION_LEVEL* = 1346
  ERROR_CANT_OPEN_ANONYMOUS* = 1347
  ERROR_BAD_VALIDATION_CLASS* = 1348
  ERROR_BAD_TOKEN_TYPE* = 1349
  ERROR_NO_SECURITY_ON_OBJECT* = 1350
  ERROR_CANT_ACCESS_DOMAIN_INFO* = 1351
  ERROR_INVALID_SERVER_STATE* = 1352
  ERROR_INVALID_DOMAIN_STATE* = 1353
  ERROR_INVALID_DOMAIN_ROLE* = 1354
  ERROR_NO_SUCH_DOMAIN* = 1355
  ERROR_DOMAIN_EXISTS* = 1356
  ERROR_DOMAIN_LIMIT_EXCEEDED* = 1357
  ERROR_INTERNAL_DB_CORRUPTION* = 1358
  ERROR_INTERNAL_ERROR* = 1359
  ERROR_GENERIC_NOT_MAPPED* = 1360
  ERROR_BAD_DESCRIPTOR_FORMAT* = 1361
  ERROR_NOT_LOGON_PROCESS* = 1362
  ERROR_LOGON_SESSION_EXISTS* = 1363
  ERROR_NO_SUCH_PACKAGE* = 1364
  ERROR_BAD_LOGON_SESSION_STATE* = 1365
  ERROR_LOGON_SESSION_COLLISION* = 1366
  ERROR_INVALID_LOGON_TYPE* = 1367
  ERROR_CANNOT_IMPERSONATE* = 1368
  ERROR_RXACT_INVALID_STATE* = 1369
  ERROR_RXACT_COMMIT_FAILURE* = 1370
  ERROR_SPECIAL_ACCOUNT* = 1371
  ERROR_SPECIAL_GROUP* = 1372
  ERROR_SPECIAL_USER* = 1373
  ERROR_MEMBERS_PRIMARY_GROUP* = 1374
  ERROR_TOKEN_ALREADY_IN_USE* = 1375
  ERROR_NO_SUCH_ALIAS* = 1376
  ERROR_MEMBER_NOT_IN_ALIAS* = 1377
  ERROR_MEMBER_IN_ALIAS* = 1378
  ERROR_ALIAS_EXISTS* = 1379
  ERROR_LOGON_NOT_GRANTED* = 1380
  ERROR_TOO_MANY_SECRETS* = 1381
  ERROR_SECRET_TOO_LONG* = 1382
  ERROR_INTERNAL_DB_ERROR* = 1383
  ERROR_TOO_MANY_CONTEXT_IDS* = 1384
  ERROR_LOGON_TYPE_NOT_GRANTED* = 1385
  ERROR_NT_CROSS_ENCRYPTION_REQUIRED* = 1386
  ERROR_NO_SUCH_MEMBER* = 1387
  ERROR_INVALID_MEMBER* = 1388
  ERROR_TOO_MANY_SIDS* = 1389
  ERROR_LM_CROSS_ENCRYPTION_REQUIRED* = 1390
  ERROR_NO_INHERITANCE* = 1391
  ERROR_FILE_CORRUPT* = 1392
  ERROR_DISK_CORRUPT* = 1393
  ERROR_NO_USER_SESSION_KEY* = 1394
  ERROR_LICENSE_QUOTA_EXCEEDED* = 1395
  ERROR_WRONG_TARGET_NAME* = 1396
  ERROR_MUTUAL_AUTH_FAILED* = 1397
  ERROR_TIME_SKEW* = 1398
  ERROR_CURRENT_DOMAIN_NOT_ALLOWED* = 1399
  ERROR_INVALID_WINDOW_HANDLE* = 1400
  ERROR_INVALID_MENU_HANDLE* = 1401
  ERROR_INVALID_CURSOR_HANDLE* = 1402
  ERROR_INVALID_ACCEL_HANDLE* = 1403
  ERROR_INVALID_HOOK_HANDLE* = 1404
  ERROR_INVALID_DWP_HANDLE* = 1405
  ERROR_TLW_WITH_WSCHILD* = 1406
  ERROR_CANNOT_FIND_WND_CLASS* = 1407
  ERROR_WINDOW_OF_OTHER_THREAD* = 1408
  ERROR_HOTKEY_ALREADY_REGISTERED* = 1409
  ERROR_CLASS_ALREADY_EXISTS* = 1410
  ERROR_CLASS_DOES_NOT_EXIST* = 1411
  ERROR_CLASS_HAS_WINDOWS* = 1412
  ERROR_INVALID_INDEX* = 1413
  ERROR_INVALID_ICON_HANDLE* = 1414
  ERROR_PRIVATE_DIALOG_INDEX* = 1415
  ERROR_LISTBOX_ID_NOT_FOUND* = 1416
  ERROR_NO_WILDCARD_CHARACTERS* = 1417
  ERROR_CLIPBOARD_NOT_OPEN* = 1418
  ERROR_HOTKEY_NOT_REGISTERED* = 1419
  ERROR_WINDOW_NOT_DIALOG* = 1420
  ERROR_CONTROL_ID_NOT_FOUND* = 1421
  ERROR_INVALID_COMBOBOX_MESSAGE* = 1422
  ERROR_WINDOW_NOT_COMBOBOX* = 1423
  ERROR_INVALID_EDIT_HEIGHT* = 1424
  ERROR_DC_NOT_FOUND* = 1425
  ERROR_INVALID_HOOK_FILTER* = 1426
  ERROR_INVALID_FILTER_PROC* = 1427
  ERROR_HOOK_NEEDS_HMOD* = 1428
  ERROR_GLOBAL_ONLY_HOOK* = 1429
  ERROR_JOURNAL_HOOK_SET* = 1430
  ERROR_HOOK_NOT_INSTALLED* = 1431
  ERROR_INVALID_LB_MESSAGE* = 1432
  ERROR_SETCOUNT_ON_BAD_LB* = 1433
  ERROR_LB_WITHOUT_TABSTOPS* = 1434
  ERROR_DESTROY_OBJECT_OF_OTHER_THREAD* = 1435
  ERROR_CHILD_WINDOW_MENU* = 1436
  ERROR_NO_SYSTEM_MENU* = 1437
  ERROR_INVALID_MSGBOX_STYLE* = 1438
  ERROR_INVALID_SPI_VALUE* = 1439
  ERROR_SCREEN_ALREADY_LOCKED* = 1440
  ERROR_HWNDS_HAVE_DIFF_PARENT* = 1441
  ERROR_NOT_CHILD_WINDOW* = 1442
  ERROR_INVALID_GW_COMMAND* = 1443
  ERROR_INVALID_THREAD_ID* = 1444
  ERROR_NON_MDICHILD_WINDOW* = 1445
  ERROR_POPUP_ALREADY_ACTIVE* = 1446
  ERROR_NO_SCROLLBARS* = 1447
  ERROR_INVALID_SCROLLBAR_RANGE* = 1448
  ERROR_INVALID_SHOWWIN_COMMAND* = 1449
  ERROR_NO_SYSTEM_RESOURCES* = 1450
  ERROR_NONPAGED_SYSTEM_RESOURCES* = 1451
  ERROR_PAGED_SYSTEM_RESOURCES* = 1452
  ERROR_WORKING_SET_QUOTA* = 1453
  ERROR_PAGEFILE_QUOTA* = 1454
  ERROR_COMMITMENT_LIMIT* = 1455
  ERROR_MENU_ITEM_NOT_FOUND* = 1456
  ERROR_INVALID_KEYBOARD_HANDLE* = 1457
  ERROR_HOOK_TYPE_NOT_ALLOWED* = 1458
  ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION* = 1459
  ERROR_TIMEOUT* = 1460
  ERROR_INVALID_MONITOR_HANDLE* = 1461
  ERROR_INCORRECT_SIZE* = 1462
  ERROR_EVENTLOG_FILE_CORRUPT* = 1500
  ERROR_EVENTLOG_CANT_START* = 1501
  ERROR_LOG_FILE_FULL* = 1502
  ERROR_EVENTLOG_FILE_CHANGED* = 1503
  ERROR_INSTALL_SERVICE_FAILURE* = 1601
  ERROR_INSTALL_USEREXIT* = 1602
  ERROR_INSTALL_FAILURE* = 1603
  ERROR_INSTALL_SUSPEND* = 1604
  ERROR_UNKNOWN_PRODUCT* = 1605
  ERROR_UNKNOWN_FEATURE* = 1606
  ERROR_UNKNOWN_COMPONENT* = 1607
  ERROR_UNKNOWN_PROPERTY* = 1608
  ERROR_INVALID_HANDLE_STATE* = 1609
  ERROR_BAD_CONFIGURATION* = 1610
  ERROR_INDEX_ABSENT* = 1611
  ERROR_INSTALL_SOURCE_ABSENT* = 1612
  ERROR_INSTALL_PACKAGE_VERSION* = 1613
  ERROR_PRODUCT_UNINSTALLED* = 1614
  ERROR_BAD_QUERY_SYNTAX* = 1615
  ERROR_INVALID_FIELD* = 1616
  ERROR_DEVICE_REMOVED* = 1617
  ERROR_INSTALL_ALREADY_RUNNING* = 1618
  ERROR_INSTALL_PACKAGE_OPEN_FAILED* = 1619
  ERROR_INSTALL_PACKAGE_INVALID* = 1620
  ERROR_INSTALL_UI_FAILURE* = 1621
  ERROR_INSTALL_LOG_FAILURE* = 1622
  ERROR_INSTALL_LANGUAGE_UNSUPPORTED* = 1623
  ERROR_INSTALL_TRANSFORM_FAILURE* = 1624
  ERROR_INSTALL_PACKAGE_REJECTED* = 1625
  ERROR_FUNCTION_NOT_CALLED* = 1626
  ERROR_FUNCTION_FAILED* = 1627
  ERROR_INVALID_TABLE* = 1628
  ERROR_DATATYPE_MISMATCH* = 1629
  ERROR_UNSUPPORTED_TYPE* = 1630
  ERROR_CREATE_FAILED* = 1631
  ERROR_INSTALL_TEMP_UNWRITABLE* = 1632
  ERROR_INSTALL_PLATFORM_UNSUPPORTED* = 1633
  ERROR_INSTALL_NOTUSED* = 1634
  ERROR_PATCH_PACKAGE_OPEN_FAILED* = 1635
  ERROR_PATCH_PACKAGE_INVALID* = 1636
  ERROR_PATCH_PACKAGE_UNSUPPORTED* = 1637
  ERROR_PRODUCT_VERSION* = 1638
  ERROR_INVALID_COMMAND_LINE* = 1639
  ERROR_INSTALL_REMOTE_DISALLOWED* = 1640
  ERROR_SUCCESS_REBOOT_INITIATED* = 1641
  ERROR_PATCH_TARGET_NOT_FOUND* = 1642
  ERROR_PATCH_PACKAGE_REJECTED* = 1643
  ERROR_INSTALL_TRANSFORM_REJECTED* = 1644
  ERROR_INSTALL_REMOTE_PROHIBITED* = 1645
  RPC_S_INVALID_STRING_BINDING* = 1700
  RPC_S_WRONG_KIND_OF_BINDING* = 1701
  RPC_S_INVALID_BINDING* = 1702
  RPC_S_PROTSEQ_NOT_SUPPORTED* = 1703
  RPC_S_INVALID_RPC_PROTSEQ* = 1704
  RPC_S_INVALID_STRING_UUID* = 1705
  RPC_S_INVALID_ENDPOINT_FORMAT* = 1706
  RPC_S_INVALID_NET_ADDR* = 1707
  RPC_S_NO_ENDPOINT_FOUND* = 1708
  RPC_S_INVALID_TIMEOUT* = 1709
  RPC_S_OBJECT_NOT_FOUND* = 1710
  RPC_S_ALREADY_REGISTERED* = 1711
  RPC_S_TYPE_ALREADY_REGISTERED* = 1712
  RPC_S_ALREADY_LISTENING* = 1713
  RPC_S_NO_PROTSEQS_REGISTERED* = 1714
  RPC_S_NOT_LISTENING* = 1715
  RPC_S_UNKNOWN_MGR_TYPE* = 1716
  RPC_S_UNKNOWN_IF* = 1717
  RPC_S_NO_BINDINGS* = 1718
  RPC_S_NO_PROTSEQS* = 1719
  RPC_S_CANT_CREATE_ENDPOINT* = 1720
  RPC_S_OUT_OF_RESOURCES* = 1721
  RPC_S_SERVER_UNAVAILABLE* = 1722
  RPC_S_SERVER_TOO_BUSY* = 1723
  RPC_S_INVALID_NETWORK_OPTIONS* = 1724
  RPC_S_NO_CALL_ACTIVE* = 1725
  RPC_S_CALL_FAILED* = 1726
  RPC_S_CALL_FAILED_DNE* = 1727
  RPC_S_PROTOCOL_ERROR* = 1728
  RPC_S_UNSUPPORTED_TRANS_SYN* = 1730
  RPC_S_UNSUPPORTED_TYPE* = 1732
  RPC_S_INVALID_TAG* = 1733
  RPC_S_INVALID_BOUND* = 1734
  RPC_S_NO_ENTRY_NAME* = 1735
  RPC_S_INVALID_NAME_SYNTAX* = 1736
  RPC_S_UNSUPPORTED_NAME_SYNTAX* = 1737
  RPC_S_UUID_NO_ADDRESS* = 1739
  RPC_S_DUPLICATE_ENDPOINT* = 1740
  RPC_S_UNKNOWN_AUTHN_TYPE* = 1741
  RPC_S_MAX_CALLS_TOO_SMALL* = 1742
  RPC_S_STRING_TOO_LONG* = 1743
  RPC_S_PROTSEQ_NOT_FOUND* = 1744
  RPC_S_PROCNUM_OUT_OF_RANGE* = 1745
  RPC_S_BINDING_HAS_NO_AUTH* = 1746
  RPC_S_UNKNOWN_AUTHN_SERVICE* = 1747
  RPC_S_UNKNOWN_AUTHN_LEVEL* = 1748
  RPC_S_INVALID_AUTH_IDENTITY* = 1749
  RPC_S_UNKNOWN_AUTHZ_SERVICE* = 1750
  EPT_S_INVALID_ENTRY* = 1751
  EPT_S_CANT_PERFORM_OP* = 1752
  EPT_S_NOT_REGISTERED* = 1753
  RPC_S_NOTHING_TO_EXPORT* = 1754
  RPC_S_INCOMPLETE_NAME* = 1755
  RPC_S_INVALID_VERS_OPTION* = 1756
  RPC_S_NO_MORE_MEMBERS* = 1757
  RPC_S_NOT_ALL_OBJS_UNEXPORTED* = 1758
  RPC_S_INTERFACE_NOT_FOUND* = 1759
  RPC_S_ENTRY_ALREADY_EXISTS* = 1760
  RPC_S_ENTRY_NOT_FOUND* = 1761
  RPC_S_NAME_SERVICE_UNAVAILABLE* = 1762
  RPC_S_INVALID_NAF_ID* = 1763
  RPC_S_CANNOT_SUPPORT* = 1764
  RPC_S_NO_CONTEXT_AVAILABLE* = 1765
  RPC_S_INTERNAL_ERROR* = 1766
  RPC_S_ZERO_DIVIDE* = 1767
  RPC_S_ADDRESS_ERROR* = 1768
  RPC_S_FP_DIV_ZERO* = 1769
  RPC_S_FP_UNDERFLOW* = 1770
  RPC_S_FP_OVERFLOW* = 1771
  RPC_X_NO_MORE_ENTRIES* = 1772
  RPC_X_SS_CHAR_TRANS_OPEN_FAIL* = 1773
  RPC_X_SS_CHAR_TRANS_SHORT_FILE* = 1774
  RPC_X_SS_IN_NULL_CONTEXT* = 1775
  RPC_X_SS_CONTEXT_DAMAGED* = 1777
  RPC_X_SS_HANDLES_MISMATCH* = 1778
  RPC_X_SS_CANNOT_GET_CALL_HANDLE* = 1779
  RPC_X_NULL_REF_POINTER* = 1780
  RPC_X_ENUM_VALUE_OUT_OF_RANGE* = 1781
  RPC_X_BYTE_COUNT_TOO_SMALL* = 1782
  RPC_X_BAD_STUB_DATA* = 1783
  ERROR_INVALID_USER_BUFFER* = 1784
  ERROR_UNRECOGNIZED_MEDIA* = 1785
  ERROR_NO_TRUST_LSA_SECRET* = 1786
  ERROR_NO_TRUST_SAM_ACCOUNT* = 1787
  ERROR_TRUSTED_DOMAIN_FAILURE* = 1788
  ERROR_TRUSTED_RELATIONSHIP_FAILURE* = 1789
  ERROR_TRUST_FAILURE* = 1790
  RPC_S_CALL_IN_PROGRESS* = 1791
  ERROR_NETLOGON_NOT_STARTED* = 1792
  ERROR_ACCOUNT_EXPIRED* = 1793
  ERROR_REDIRECTOR_HAS_OPEN_HANDLES* = 1794
  ERROR_PRINTER_DRIVER_ALREADY_INSTALLED* = 1795
  ERROR_UNKNOWN_PORT* = 1796
  ERROR_UNKNOWN_PRINTER_DRIVER* = 1797
  ERROR_UNKNOWN_PRINTPROCESSOR* = 1798
  ERROR_INVALID_SEPARATOR_FILE* = 1799
  ERROR_INVALID_PRIORITY* = 1800
  ERROR_INVALID_PRINTER_NAME* = 1801
  ERROR_PRINTER_ALREADY_EXISTS* = 1802
  ERROR_INVALID_PRINTER_COMMAND* = 1803
  ERROR_INVALID_DATATYPE* = 1804
  ERROR_INVALID_ENVIRONMENT* = 1805
  RPC_S_NO_MORE_BINDINGS* = 1806
  ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT* = 1807
  ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT* = 1808
  ERROR_NOLOGON_SERVER_TRUST_ACCOUNT* = 1809
  ERROR_DOMAIN_TRUST_INCONSISTENT* = 1810
  ERROR_SERVER_HAS_OPEN_HANDLES* = 1811
  ERROR_RESOURCE_DATA_NOT_FOUND* = 1812
  ERROR_RESOURCE_TYPE_NOT_FOUND* = 1813
  ERROR_RESOURCE_NAME_NOT_FOUND* = 1814
  ERROR_RESOURCE_LANG_NOT_FOUND* = 1815
  ERROR_NOT_ENOUGH_QUOTA* = 1816
  RPC_S_NO_INTERFACES* = 1817
  RPC_S_CALL_CANCELLED* = 1818
  RPC_S_BINDING_INCOMPLETE* = 1819
  RPC_S_COMM_FAILURE* = 1820
  RPC_S_UNSUPPORTED_AUTHN_LEVEL* = 1821
  RPC_S_NO_PRINC_NAME* = 1822
  RPC_S_NOT_RPC_ERROR* = 1823
  RPC_S_UUID_LOCAL_ONLY* = 1824
  RPC_S_SEC_PKG_ERROR* = 1825
  RPC_S_NOT_CANCELLED* = 1826
  RPC_X_INVALID_ES_ACTION* = 1827
  RPC_X_WRONG_ES_VERSION* = 1828
  RPC_X_WRONG_STUB_VERSION* = 1829
  RPC_X_INVALID_PIPE_OBJECT* = 1830
  RPC_X_WRONG_PIPE_ORDER* = 1831
  RPC_X_WRONG_PIPE_VERSION* = 1832
  RPC_S_GROUP_MEMBER_NOT_FOUND* = 1898
  EPT_S_CANT_CREATE* = 1899
  RPC_S_INVALID_OBJECT* = 1900
  ERROR_INVALID_TIME* = 1901
  ERROR_INVALID_FORM_NAME* = 1902
  ERROR_INVALID_FORM_SIZE* = 1903
  ERROR_ALREADY_WAITING* = 1904
  ERROR_PRINTER_DELETED* = 1905
  ERROR_INVALID_PRINTER_STATE* = 1906
  ERROR_PASSWORD_MUST_CHANGE* = 1907
  ERROR_DOMAIN_CONTROLLER_NOT_FOUND* = 1908
  ERROR_ACCOUNT_LOCKED_OUT* = 1909
  OR_INVALID_OXID* = 1910
  OR_INVALID_OID* = 1911
  OR_INVALID_SET* = 1912
  RPC_S_SEND_INCOMPLETE* = 1913
  RPC_S_INVALID_ASYNC_HANDLE* = 1914
  RPC_S_INVALID_ASYNC_CALL* = 1915
  RPC_X_PIPE_CLOSED* = 1916
  RPC_X_PIPE_DISCIPLINE_ERROR* = 1917
  RPC_X_PIPE_EMPTY* = 1918
  ERROR_NO_SITENAME* = 1919
  ERROR_CANT_ACCESS_FILE* = 1920
  ERROR_CANT_RESOLVE_FILENAME* = 1921
  RPC_S_ENTRY_TYPE_MISMATCH* = 1922
  RPC_S_NOT_ALL_OBJS_EXPORTED* = 1923
  RPC_S_INTERFACE_NOT_EXPORTED* = 1924
  RPC_S_PROFILE_NOT_ADDED* = 1925
  RPC_S_PRF_ELT_NOT_ADDED* = 1926
  RPC_S_PRF_ELT_NOT_REMOVED* = 1927
  RPC_S_GRP_ELT_NOT_ADDED* = 1928
  RPC_S_GRP_ELT_NOT_REMOVED* = 1929
  ERROR_KM_DRIVER_BLOCKED* = 1930
  ERROR_CONTEXT_EXPIRED* = 1931
  ERROR_PER_USER_TRUST_QUOTA_EXCEEDED* = 1932
  ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED* = 1933
  ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED* = 1934
  ERROR_AUTHENTICATION_FIREWALL_FAILED* = 1935
  ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED* = 1936
  ERROR_INVALID_PIXEL_FORMAT* = 2000
  ERROR_BAD_DRIVER* = 2001
  ERROR_INVALID_WINDOW_STYLE* = 2002
  ERROR_METAFILE_NOT_SUPPORTED* = 2003
  ERROR_TRANSFORM_NOT_SUPPORTED* = 2004
  ERROR_CLIPPING_NOT_SUPPORTED* = 2005
  ERROR_INVALID_CMM* = 2010
  ERROR_INVALID_PROFILE* = 2011
  ERROR_TAG_NOT_FOUND* = 2012
  ERROR_TAG_NOT_PRESENT* = 2013
  ERROR_DUPLICATE_TAG* = 2014
  ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE* = 2015
  ERROR_PROFILE_NOT_FOUND* = 2016
  ERROR_INVALID_COLORSPACE* = 2017
  ERROR_ICM_NOT_ENABLED* = 2018
  ERROR_DELETING_ICM_XFORM* = 2019
  ERROR_INVALID_TRANSFORM* = 2020
  ERROR_COLORSPACE_MISMATCH* = 2021
  ERROR_INVALID_COLORINDEX* = 2022
  ERROR_CONNECTED_OTHER_PASSWORD* = 2108
  ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT* = 2109
  ERROR_BAD_USERNAME* = 2202
  ERROR_NOT_CONNECTED* = 2250
  ERROR_OPEN_FILES* = 2401
  ERROR_ACTIVE_CONNECTIONS* = 2402
  ERROR_DEVICE_IN_USE* = 2404
  ERROR_UNKNOWN_PRINT_MONITOR* = 3000
  ERROR_PRINTER_DRIVER_IN_USE* = 3001
  ERROR_SPOOL_FILE_NOT_FOUND* = 3002
  ERROR_SPL_NO_STARTDOC* = 3003
  ERROR_SPL_NO_ADDJOB* = 3004
  ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED* = 3005
  ERROR_PRINT_MONITOR_ALREADY_INSTALLED* = 3006
  ERROR_INVALID_PRINT_MONITOR* = 3007
  ERROR_PRINT_MONITOR_IN_USE* = 3008
  ERROR_PRINTER_HAS_JOBS_QUEUED* = 3009
  ERROR_SUCCESS_REBOOT_REQUIRED* = 3010
  ERROR_SUCCESS_RESTART_REQUIRED* = 3011
  ERROR_PRINTER_NOT_FOUND* = 3012
  ERROR_PRINTER_DRIVER_WARNED* = 3013
  ERROR_PRINTER_DRIVER_BLOCKED* = 3014
  ERROR_WINS_INTERNAL* = 4000
  ERROR_CAN_NOT_DEL_LOCAL_WINS* = 4001
  ERROR_STATIC_INIT* = 4002
  ERROR_INC_BACKUP* = 4003
  ERROR_FULL_BACKUP* = 4004
  ERROR_REC_NON_EXISTENT* = 4005
  ERROR_RPL_NOT_ALLOWED* = 4006
  ERROR_DHCP_ADDRESS_CONFLICT* = 4100
  ERROR_WMI_GUID_NOT_FOUND* = 4200
  ERROR_WMI_INSTANCE_NOT_FOUND* = 4201
  ERROR_WMI_ITEMID_NOT_FOUND* = 4202
  ERROR_WMI_TRY_AGAIN* = 4203
  ERROR_WMI_DP_NOT_FOUND* = 4204
  ERROR_WMI_UNRESOLVED_INSTANCE_REF* = 4205
  ERROR_WMI_ALREADY_ENABLED* = 4206
  ERROR_WMI_GUID_DISCONNECTED* = 4207
  ERROR_WMI_SERVER_UNAVAILABLE* = 4208
  ERROR_WMI_DP_FAILED* = 4209
  ERROR_WMI_INVALID_MOF* = 4210
  ERROR_WMI_INVALID_REGINFO* = 4211
  ERROR_WMI_ALREADY_DISABLED* = 4212
  ERROR_WMI_READ_ONLY* = 4213
  ERROR_WMI_SET_FAILURE* = 4214
  ERROR_INVALID_MEDIA* = 4300
  ERROR_INVALID_LIBRARY* = 4301
  ERROR_INVALID_MEDIA_POOL* = 4302
  ERROR_DRIVE_MEDIA_MISMATCH* = 4303
  ERROR_MEDIA_OFFLINE* = 4304
  ERROR_LIBRARY_OFFLINE* = 4305
  ERROR_EMPTY* = 4306
  ERROR_NOT_EMPTY* = 4307
  ERROR_MEDIA_UNAVAILABLE* = 4308
  ERROR_RESOURCE_DISABLED* = 4309
  ERROR_INVALID_CLEANER* = 4310
  ERROR_UNABLE_TO_CLEAN* = 4311
  ERROR_OBJECT_NOT_FOUND* = 4312
  ERROR_DATABASE_FAILURE* = 4313
  ERROR_DATABASE_FULL* = 4314
  ERROR_MEDIA_INCOMPATIBLE* = 4315
  ERROR_RESOURCE_NOT_PRESENT* = 4316
  ERROR_INVALID_OPERATION* = 4317
  ERROR_MEDIA_NOT_AVAILABLE* = 4318
  ERROR_DEVICE_NOT_AVAILABLE* = 4319
  ERROR_REQUEST_REFUSED* = 4320
  ERROR_INVALID_DRIVE_OBJECT* = 4321
  ERROR_LIBRARY_FULL* = 4322
  ERROR_MEDIUM_NOT_ACCESSIBLE* = 4323
  ERROR_UNABLE_TO_LOAD_MEDIUM* = 4324
  ERROR_UNABLE_TO_INVENTORY_DRIVE* = 4325
  ERROR_UNABLE_TO_INVENTORY_SLOT* = 4326
  ERROR_UNABLE_TO_INVENTORY_TRANSPORT* = 4327
  ERROR_TRANSPORT_FULL* = 4328
  ERROR_CONTROLLING_IEPORT* = 4329
  ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA* = 4330
  ERROR_CLEANER_SLOT_SET* = 4331
  ERROR_CLEANER_SLOT_NOT_SET* = 4332
  ERROR_CLEANER_CARTRIDGE_SPENT* = 4333
  ERROR_UNEXPECTED_OMID* = 4334
  ERROR_CANT_DELETE_LAST_ITEM* = 4335
  ERROR_MESSAGE_EXCEEDS_MAX_SIZE* = 4336
  ERROR_VOLUME_CONTAINS_SYS_FILES* = 4337
  ERROR_INDIGENOUS_TYPE* = 4338
  ERROR_NO_SUPPORTING_DRIVES* = 4339
  ERROR_CLEANER_CARTRIDGE_INSTALLED* = 4340
  ERROR_IEPORT_FULL* = 4341
  ERROR_FILE_OFFLINE* = 4350
  ERROR_REMOTE_STORAGE_NOT_ACTIVE* = 4351
  ERROR_REMOTE_STORAGE_MEDIA_ERROR* = 4352
  ERROR_NOT_A_REPARSE_POINT* = 4390
  ERROR_REPARSE_ATTRIBUTE_CONFLICT* = 4391
  ERROR_INVALID_REPARSE_DATA* = 4392
  ERROR_REPARSE_TAG_INVALID* = 4393
  ERROR_REPARSE_TAG_MISMATCH* = 4394
  ERROR_VOLUME_NOT_SIS_ENABLED* = 4500
  ERROR_DEPENDENT_RESOURCE_EXISTS* = 5001
  ERROR_DEPENDENCY_NOT_FOUND* = 5002
  ERROR_DEPENDENCY_ALREADY_EXISTS* = 5003
  ERROR_RESOURCE_NOT_ONLINE* = 5004
  ERROR_HOST_NODE_NOT_AVAILABLE* = 5005
  ERROR_RESOURCE_NOT_AVAILABLE* = 5006
  ERROR_RESOURCE_NOT_FOUND* = 5007
  ERROR_SHUTDOWN_CLUSTER* = 5008
  ERROR_CANT_EVICT_ACTIVE_NODE* = 5009
  ERROR_OBJECT_ALREADY_EXISTS* = 5010
  ERROR_OBJECT_IN_LIST* = 5011
  ERROR_GROUP_NOT_AVAILABLE* = 5012
  ERROR_GROUP_NOT_FOUND* = 5013
  ERROR_GROUP_NOT_ONLINE* = 5014
  ERROR_HOST_NODE_NOT_RESOURCE_OWNER* = 5015
  ERROR_HOST_NODE_NOT_GROUP_OWNER* = 5016
  ERROR_RESMON_CREATE_FAILED* = 5017
  ERROR_RESMON_ONLINE_FAILED* = 5018
  ERROR_RESOURCE_ONLINE* = 5019
  ERROR_QUORUM_RESOURCE* = 5020
  ERROR_NOT_QUORUM_CAPABLE* = 5021
  ERROR_CLUSTER_SHUTTING_DOWN* = 5022
  ERROR_INVALID_STATE* = 5023
  ERROR_RESOURCE_PROPERTIES_STORED* = 5024
  ERROR_NOT_QUORUM_CLASS* = 5025
  ERROR_CORE_RESOURCE* = 5026
  ERROR_QUORUM_RESOURCE_ONLINE_FAILED* = 5027
  ERROR_QUORUMLOG_OPEN_FAILED* = 5028
  ERROR_CLUSTERLOG_CORRUPT* = 5029
  ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE* = 5030
  ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE* = 5031
  ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND* = 5032
  ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE* = 5033
  ERROR_QUORUM_OWNER_ALIVE* = 5034
  ERROR_NETWORK_NOT_AVAILABLE* = 5035
  ERROR_NODE_NOT_AVAILABLE* = 5036
  ERROR_ALL_NODES_NOT_AVAILABLE* = 5037
  ERROR_RESOURCE_FAILED* = 5038
  ERROR_CLUSTER_INVALID_NODE* = 5039
  ERROR_CLUSTER_NODE_EXISTS* = 5040
  ERROR_CLUSTER_JOIN_IN_PROGRESS* = 5041
  ERROR_CLUSTER_NODE_NOT_FOUND* = 5042
  ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND* = 5043
  ERROR_CLUSTER_NETWORK_EXISTS* = 5044
  ERROR_CLUSTER_NETWORK_NOT_FOUND* = 5045
  ERROR_CLUSTER_NETINTERFACE_EXISTS* = 5046
  ERROR_CLUSTER_NETINTERFACE_NOT_FOUND* = 5047
  ERROR_CLUSTER_INVALID_REQUEST* = 5048
  ERROR_CLUSTER_INVALID_NETWORK_PROVIDER* = 5049
  ERROR_CLUSTER_NODE_DOWN* = 5050
  ERROR_CLUSTER_NODE_UNREACHABLE* = 5051
  ERROR_CLUSTER_NODE_NOT_MEMBER* = 5052
  ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS* = 5053
  ERROR_CLUSTER_INVALID_NETWORK* = 5054
  ERROR_CLUSTER_NODE_UP* = 5056
  ERROR_CLUSTER_IPADDR_IN_USE* = 5057
  ERROR_CLUSTER_NODE_NOT_PAUSED* = 5058
  ERROR_CLUSTER_NO_SECURITY_CONTEXT* = 5059
  ERROR_CLUSTER_NETWORK_NOT_INTERNAL* = 5060
  ERROR_CLUSTER_NODE_ALREADY_UP* = 5061
  ERROR_CLUSTER_NODE_ALREADY_DOWN* = 5062
  ERROR_CLUSTER_NETWORK_ALREADY_ONLINE* = 5063
  ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE* = 5064
  ERROR_CLUSTER_NODE_ALREADY_MEMBER* = 5065
  ERROR_CLUSTER_LAST_INTERNAL_NETWORK* = 5066
  ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS* = 5067
  ERROR_INVALID_OPERATION_ON_QUORUM* = 5068
  ERROR_DEPENDENCY_NOT_ALLOWED* = 5069
  ERROR_CLUSTER_NODE_PAUSED* = 5070
  ERROR_NODE_CANT_HOST_RESOURCE* = 5071
  ERROR_CLUSTER_NODE_NOT_READY* = 5072
  ERROR_CLUSTER_NODE_SHUTTING_DOWN* = 5073
  ERROR_CLUSTER_JOIN_ABORTED* = 5074
  ERROR_CLUSTER_INCOMPATIBLE_VERSIONS* = 5075
  ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED* = 5076
  ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED* = 5077
  ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND* = 5078
  ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED* = 5079
  ERROR_CLUSTER_RESNAME_NOT_FOUND* = 5080
  ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED* = 5081
  ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST* = 5082
  ERROR_CLUSTER_DATABASE_SEQMISMATCH* = 5083
  ERROR_RESMON_INVALID_STATE* = 5084
  ERROR_CLUSTER_GUM_NOT_LOCKER* = 5085
  ERROR_QUORUM_DISK_NOT_FOUND* = 5086
  ERROR_DATABASE_BACKUP_CORRUPT* = 5087
  ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT* = 5088
  ERROR_RESOURCE_PROPERTY_UNCHANGEABLE* = 5089
  ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE* = 5890
  ERROR_CLUSTER_QUORUMLOG_NOT_FOUND* = 5891
  ERROR_CLUSTER_MEMBERSHIP_HALT* = 5892
  ERROR_CLUSTER_INSTANCE_ID_MISMATCH* = 5893
  ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP* = 5894
  ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH* = 5895
  ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP* = 5896
  ERROR_CLUSTER_PARAMETER_MISMATCH* = 5897
  ERROR_NODE_CANNOT_BE_CLUSTERED* = 5898
  ERROR_CLUSTER_WRONG_OS_VERSION* = 5899
  ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME* = 5900
  ERROR_CLUSCFG_ALREADY_COMMITTED* = 5901
  ERROR_CLUSCFG_ROLLBACK_FAILED* = 5902
  ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT* = 5903
  ERROR_CLUSTER_OLD_VERSION* = 5904
  ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME* = 5905
  ERROR_ENCRYPTION_FAILED* = 6000
  ERROR_DECRYPTION_FAILED* = 6001
  ERROR_FILE_ENCRYPTED* = 6002
  ERROR_NO_RECOVERY_POLICY* = 6003
  ERROR_NO_EFS* = 6004
  ERROR_WRONG_EFS* = 6005
  ERROR_NO_USER_KEYS* = 6006
  ERROR_FILE_NOT_ENCRYPTED* = 6007
  ERROR_NOT_EXPORT_FORMAT* = 6008
  ERROR_FILE_READ_ONLY* = 6009
  ERROR_DIR_EFS_DISALLOWED* = 6010
  ERROR_EFS_SERVER_NOT_TRUSTED* = 6011
  ERROR_BAD_RECOVERY_POLICY* = 6012
  ERROR_EFS_ALG_BLOB_TOO_BIG* = 6013
  ERROR_VOLUME_NOT_SUPPORT_EFS* = 6014
  ERROR_EFS_DISABLED* = 6015
  ERROR_EFS_VERSION_NOT_SUPPORT* = 6016
  ERROR_NO_BROWSER_SERVERS_FOUND* = 6118
  SCHED_E_SERVICE_NOT_LOCALSYSTEM* = 6200
  ERROR_CTX_WINSTATION_NAME_INVALID* = 7001
  ERROR_CTX_INVALID_PD* = 7002
  ERROR_CTX_PD_NOT_FOUND* = 7003
  ERROR_CTX_WD_NOT_FOUND* = 7004
  ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY* = 7005
  ERROR_CTX_SERVICE_NAME_COLLISION* = 7006
  ERROR_CTX_CLOSE_PENDING* = 7007
  ERROR_CTX_NO_OUTBUF* = 7008
  ERROR_CTX_MODEM_INF_NOT_FOUND* = 7009
  ERROR_CTX_INVALID_MODEMNAME* = 7010
  ERROR_CTX_MODEM_RESPONSE_ERROR* = 7011
  ERROR_CTX_MODEM_RESPONSE_TIMEOUT* = 7012
  ERROR_CTX_MODEM_RESPONSE_NO_CARRIER* = 7013
  ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE* = 7014
  ERROR_CTX_MODEM_RESPONSE_BUSY* = 7015
  ERROR_CTX_MODEM_RESPONSE_VOICE* = 7016
  ERROR_CTX_TD_ERROR* = 7017
  ERROR_CTX_WINSTATION_NOT_FOUND* = 7022
  ERROR_CTX_WINSTATION_ALREADY_EXISTS* = 7023
  ERROR_CTX_WINSTATION_BUSY* = 7024
  ERROR_CTX_BAD_VIDEO_MODE* = 7025
  ERROR_CTX_GRAPHICS_INVALID* = 7035
  ERROR_CTX_LOGON_DISABLED* = 7037
  ERROR_CTX_NOT_CONSOLE* = 7038
  ERROR_CTX_CLIENT_QUERY_TIMEOUT* = 7040
  ERROR_CTX_CONSOLE_DISCONNECT* = 7041
  ERROR_CTX_CONSOLE_CONNECT* = 7042
  ERROR_CTX_SHADOW_DENIED* = 7044
  ERROR_CTX_WINSTATION_ACCESS_DENIED* = 7045
  ERROR_CTX_INVALID_WD* = 7049
  ERROR_CTX_SHADOW_INVALID* = 7050
  ERROR_CTX_SHADOW_DISABLED* = 7051
  ERROR_CTX_CLIENT_LICENSE_IN_USE* = 7052
  ERROR_CTX_CLIENT_LICENSE_NOT_SET* = 7053
  ERROR_CTX_LICENSE_NOT_AVAILABLE* = 7054
  ERROR_CTX_LICENSE_CLIENT_INVALID* = 7055
  ERROR_CTX_LICENSE_EXPIRED* = 7056
  ERROR_CTX_SHADOW_NOT_RUNNING* = 7057
  ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE* = 7058
  ERROR_ACTIVATION_COUNT_EXCEEDED* = 7059
  FRS_ERR_INVALID_API_SEQUENCE* = 8001
  FRS_ERR_STARTING_SERVICE* = 8002
  FRS_ERR_STOPPING_SERVICE* = 8003
  FRS_ERR_INTERNAL_API* = 8004
  FRS_ERR_INTERNAL* = 8005
  FRS_ERR_SERVICE_COMM* = 8006
  FRS_ERR_INSUFFICIENT_PRIV* = 8007
  FRS_ERR_AUTHENTICATION* = 8008
  FRS_ERR_PARENT_INSUFFICIENT_PRIV* = 8009
  FRS_ERR_PARENT_AUTHENTICATION* = 8010
  FRS_ERR_CHILD_TO_PARENT_COMM* = 8011
  FRS_ERR_PARENT_TO_CHILD_COMM* = 8012
  FRS_ERR_SYSVOL_POPULATE* = 8013
  FRS_ERR_SYSVOL_POPULATE_TIMEOUT* = 8014
  FRS_ERR_SYSVOL_IS_BUSY* = 8015
  FRS_ERR_SYSVOL_DEMOTE* = 8016
  FRS_ERR_INVALID_SERVICE_PARAMETER* = 8017
  DS_S_SUCCESS* = NO_ERROR
  ERROR_DS_NOT_INSTALLED* = 8200
  ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY* = 8201
  ERROR_DS_NO_ATTRIBUTE_OR_VALUE* = 8202
  ERROR_DS_INVALID_ATTRIBUTE_SYNTAX* = 8203
  ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED* = 8204
  ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS* = 8205
  ERROR_DS_BUSY* = 8206
  ERROR_DS_UNAVAILABLE* = 8207
  ERROR_DS_NO_RIDS_ALLOCATED* = 8208
  ERROR_DS_NO_MORE_RIDS* = 8209
  ERROR_DS_INCORRECT_ROLE_OWNER* = 8210
  ERROR_DS_RIDMGR_INIT_ERROR* = 8211
  ERROR_DS_OBJ_CLASS_VIOLATION* = 8212
  ERROR_DS_CANT_ON_NON_LEAF* = 8213
  ERROR_DS_CANT_ON_RDN* = 8214
  ERROR_DS_CANT_MOD_OBJ_CLASS* = 8215
  ERROR_DS_CROSS_DOM_MOVE_ERROR* = 8216
  ERROR_DS_GC_NOT_AVAILABLE* = 8217
  ERROR_SHARED_POLICY* = 8218
  ERROR_POLICY_OBJECT_NOT_FOUND* = 8219
  ERROR_POLICY_ONLY_IN_DS* = 8220
  ERROR_PROMOTION_ACTIVE* = 8221
  ERROR_NO_PROMOTION_ACTIVE* = 8222
  ERROR_DS_OPERATIONS_ERROR* = 8224
  ERROR_DS_PROTOCOL_ERROR* = 8225
  ERROR_DS_TIMELIMIT_EXCEEDED* = 8226
  ERROR_DS_SIZELIMIT_EXCEEDED* = 8227
  ERROR_DS_ADMIN_LIMIT_EXCEEDED* = 8228
  ERROR_DS_COMPARE_FALSE* = 8229
  ERROR_DS_COMPARE_TRUE* = 8230
  ERROR_DS_AUTH_METHOD_NOT_SUPPORTED* = 8231
  ERROR_DS_STRONG_AUTH_REQUIRED* = 8232
  ERROR_DS_INAPPROPRIATE_AUTH* = 8233
  ERROR_DS_AUTH_UNKNOWN* = 8234
  ERROR_DS_REFERRAL* = 8235
  ERROR_DS_UNAVAILABLE_CRIT_EXTENSION* = 8236
  ERROR_DS_CONFIDENTIALITY_REQUIRED* = 8237
  ERROR_DS_INAPPROPRIATE_MATCHING* = 8238
  ERROR_DS_CONSTRAINT_VIOLATION* = 8239
  ERROR_DS_NO_SUCH_OBJECT* = 8240
  ERROR_DS_ALIAS_PROBLEM* = 8241
  ERROR_DS_INVALID_DN_SYNTAX* = 8242
  ERROR_DS_IS_LEAF* = 8243
  ERROR_DS_ALIAS_DEREF_PROBLEM* = 8244
  ERROR_DS_UNWILLING_TO_PERFORM* = 8245
  ERROR_DS_LOOP_DETECT* = 8246
  ERROR_DS_NAMING_VIOLATION* = 8247
  ERROR_DS_OBJECT_RESULTS_TOO_LARGE* = 8248
  ERROR_DS_AFFECTS_MULTIPLE_DSAS* = 8249
  ERROR_DS_SERVER_DOWN* = 8250
  ERROR_DS_LOCAL_ERROR* = 8251
  ERROR_DS_ENCODING_ERROR* = 8252
  ERROR_DS_DECODING_ERROR* = 8253
  ERROR_DS_FILTER_UNKNOWN* = 8254
  ERROR_DS_PARAM_ERROR* = 8255
  ERROR_DS_NOT_SUPPORTED* = 8256
  ERROR_DS_NO_RESULTS_RETURNED* = 8257
  ERROR_DS_CONTROL_NOT_FOUND* = 8258
  ERROR_DS_CLIENT_LOOP* = 8259
  ERROR_DS_REFERRAL_LIMIT_EXCEEDED* = 8260
  ERROR_DS_SORT_CONTROL_MISSING* = 8261
  ERROR_DS_OFFSET_RANGE_ERROR* = 8262
  ERROR_DS_ROOT_MUST_BE_NC* = 8301
  ERROR_DS_ADD_REPLICA_INHIBITED* = 8302
  ERROR_DS_ATT_NOT_DEF_IN_SCHEMA* = 8303
  ERROR_DS_MAX_OBJ_SIZE_EXCEEDED* = 8304
  ERROR_DS_OBJ_STRING_NAME_EXISTS* = 8305
  ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA* = 8306
  ERROR_DS_RDN_DOESNT_MATCH_SCHEMA* = 8307
  ERROR_DS_NO_REQUESTED_ATTS_FOUND* = 8308
  ERROR_DS_USER_BUFFER_TO_SMALL* = 8309
  ERROR_DS_ATT_IS_NOT_ON_OBJ* = 8310
  ERROR_DS_ILLEGAL_MOD_OPERATION* = 8311
  ERROR_DS_OBJ_TOO_LARGE* = 8312
  ERROR_DS_BAD_INSTANCE_TYPE* = 8313
  ERROR_DS_MASTERDSA_REQUIRED* = 8314
  ERROR_DS_OBJECT_CLASS_REQUIRED* = 8315
  ERROR_DS_MISSING_REQUIRED_ATT* = 8316
  ERROR_DS_ATT_NOT_DEF_FOR_CLASS* = 8317
  ERROR_DS_ATT_ALREADY_EXISTS* = 8318
  ERROR_DS_CANT_ADD_ATT_VALUES* = 8320
  ERROR_DS_SINGLE_VALUE_CONSTRAINT* = 8321
  ERROR_DS_RANGE_CONSTRAINT* = 8322
  ERROR_DS_ATT_VAL_ALREADY_EXISTS* = 8323
  ERROR_DS_CANT_REM_MISSING_ATT* = 8324
  ERROR_DS_CANT_REM_MISSING_ATT_VAL* = 8325
  ERROR_DS_ROOT_CANT_BE_SUBREF* = 8326
  ERROR_DS_NO_CHAINING* = 8327
  ERROR_DS_NO_CHAINED_EVAL* = 8328
  ERROR_DS_NO_PARENT_OBJECT* = 8329
  ERROR_DS_PARENT_IS_AN_ALIAS* = 8330
  ERROR_DS_CANT_MIX_MASTER_AND_REPS* = 8331
  ERROR_DS_CHILDREN_EXIST* = 8332
  ERROR_DS_OBJ_NOT_FOUND* = 8333
  ERROR_DS_ALIASED_OBJ_MISSING* = 8334
  ERROR_DS_BAD_NAME_SYNTAX* = 8335
  ERROR_DS_ALIAS_POINTS_TO_ALIAS* = 8336
  ERROR_DS_CANT_DEREF_ALIAS* = 8337
  ERROR_DS_OUT_OF_SCOPE* = 8338
  ERROR_DS_OBJECT_BEING_REMOVED* = 8339
  ERROR_DS_CANT_DELETE_DSA_OBJ* = 8340
  ERROR_DS_GENERIC_ERROR* = 8341
  ERROR_DS_DSA_MUST_BE_INT_MASTER* = 8342
  ERROR_DS_CLASS_NOT_DSA* = 8343
  ERROR_DS_INSUFF_ACCESS_RIGHTS* = 8344
  ERROR_DS_ILLEGAL_SUPERIOR* = 8345
  ERROR_DS_ATTRIBUTE_OWNED_BY_SAM* = 8346
  ERROR_DS_NAME_TOO_MANY_PARTS* = 8347
  ERROR_DS_NAME_TOO_LONG* = 8348
  ERROR_DS_NAME_VALUE_TOO_LONG* = 8349
  ERROR_DS_NAME_UNPARSEABLE* = 8350
  ERROR_DS_NAME_TYPE_UNKNOWN* = 8351
  ERROR_DS_NOT_AN_OBJECT* = 8352
  ERROR_DS_SEC_DESC_TOO_SHORT* = 8353
  ERROR_DS_SEC_DESC_INVALID* = 8354
  ERROR_DS_NO_DELETED_NAME* = 8355
  ERROR_DS_SUBREF_MUST_HAVE_PARENT* = 8356
  ERROR_DS_NCNAME_MUST_BE_NC* = 8357
  ERROR_DS_CANT_ADD_SYSTEM_ONLY* = 8358
  ERROR_DS_CLASS_MUST_BE_CONCRETE* = 8359
  ERROR_DS_INVALID_DMD* = 8360
  ERROR_DS_OBJ_GUID_EXISTS* = 8361
  ERROR_DS_NOT_ON_BACKLINK* = 8362
  ERROR_DS_NO_CROSSREF_FOR_NC* = 8363
  ERROR_DS_SHUTTING_DOWN* = 8364
  ERROR_DS_UNKNOWN_OPERATION* = 8365
  ERROR_DS_INVALID_ROLE_OWNER* = 8366
  ERROR_DS_COULDNT_CONTACT_FSMO* = 8367
  ERROR_DS_CROSS_NC_DN_RENAME* = 8368
  ERROR_DS_CANT_MOD_SYSTEM_ONLY* = 8369
  ERROR_DS_REPLICATOR_ONLY* = 8370
  ERROR_DS_OBJ_CLASS_NOT_DEFINED* = 8371
  ERROR_DS_OBJ_CLASS_NOT_SUBCLASS* = 8372
  ERROR_DS_NAME_REFERENCE_INVALID* = 8373
  ERROR_DS_CROSS_REF_EXISTS* = 8374
  ERROR_DS_CANT_DEL_MASTER_CROSSREF* = 8375
  ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD* = 8376
  ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX* = 8377
  ERROR_DS_DUP_RDN* = 8378
  ERROR_DS_DUP_OID* = 8379
  ERROR_DS_DUP_MAPI_ID* = 8380
  ERROR_DS_DUP_SCHEMA_ID_GUID* = 8381
  ERROR_DS_DUP_LDAP_DISPLAY_NAME* = 8382
  ERROR_DS_SEMANTIC_ATT_TEST* = 8383
  ERROR_DS_SYNTAX_MISMATCH* = 8384
  ERROR_DS_EXISTS_IN_MUST_HAVE* = 8385
  ERROR_DS_EXISTS_IN_MAY_HAVE* = 8386
  ERROR_DS_NONEXISTENT_MAY_HAVE* = 8387
  ERROR_DS_NONEXISTENT_MUST_HAVE* = 8388
  ERROR_DS_AUX_CLS_TEST_FAIL* = 8389
  ERROR_DS_NONEXISTENT_POSS_SUP* = 8390
  ERROR_DS_SUB_CLS_TEST_FAIL* = 8391
  ERROR_DS_BAD_RDN_ATT_ID_SYNTAX* = 8392
  ERROR_DS_EXISTS_IN_AUX_CLS* = 8393
  ERROR_DS_EXISTS_IN_SUB_CLS* = 8394
  ERROR_DS_EXISTS_IN_POSS_SUP* = 8395
  ERROR_DS_RECALCSCHEMA_FAILED* = 8396
  ERROR_DS_TREE_DELETE_NOT_FINISHED* = 8397
  ERROR_DS_CANT_DELETE* = 8398
  ERROR_DS_ATT_SCHEMA_REQ_ID* = 8399
  ERROR_DS_BAD_ATT_SCHEMA_SYNTAX* = 8400
  ERROR_DS_CANT_CACHE_ATT* = 8401
  ERROR_DS_CANT_CACHE_CLASS* = 8402
  ERROR_DS_CANT_REMOVE_ATT_CACHE* = 8403
  ERROR_DS_CANT_REMOVE_CLASS_CACHE* = 8404
  ERROR_DS_CANT_RETRIEVE_DN* = 8405
  ERROR_DS_MISSING_SUPREF* = 8406
  ERROR_DS_CANT_RETRIEVE_INSTANCE* = 8407
  ERROR_DS_CODE_INCONSISTENCY* = 8408
  ERROR_DS_DATABASE_ERROR* = 8409
  ERROR_DS_GOVERNSID_MISSING* = 8410
  ERROR_DS_MISSING_EXPECTED_ATT* = 8411
  ERROR_DS_NCNAME_MISSING_CR_REF* = 8412
  ERROR_DS_SECURITY_CHECKING_ERROR* = 8413
  ERROR_DS_SCHEMA_NOT_LOADED* = 8414
  ERROR_DS_SCHEMA_ALLOC_FAILED* = 8415
  ERROR_DS_ATT_SCHEMA_REQ_SYNTAX* = 8416
  ERROR_DS_GCVERIFY_ERROR* = 8417
  ERROR_DS_DRA_SCHEMA_MISMATCH* = 8418
  ERROR_DS_CANT_FIND_DSA_OBJ* = 8419
  ERROR_DS_CANT_FIND_EXPECTED_NC* = 8420
  ERROR_DS_CANT_FIND_NC_IN_CACHE* = 8421
  ERROR_DS_CANT_RETRIEVE_CHILD* = 8422
  ERROR_DS_SECURITY_ILLEGAL_MODIFY* = 8423
  ERROR_DS_CANT_REPLACE_HIDDEN_REC* = 8424
  ERROR_DS_BAD_HIERARCHY_FILE* = 8425
  ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED* = 8426
  ERROR_DS_CONFIG_PARAM_MISSING* = 8427
  ERROR_DS_COUNTING_AB_INDICES_FAILED* = 8428
  ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED* = 8429
  ERROR_DS_INTERNAL_FAILURE* = 8430
  ERROR_DS_UNKNOWN_ERROR* = 8431
  ERROR_DS_ROOT_REQUIRES_CLASS_TOP* = 8432
  ERROR_DS_REFUSING_FSMO_ROLES* = 8433
  ERROR_DS_MISSING_FSMO_SETTINGS* = 8434
  ERROR_DS_UNABLE_TO_SURRENDER_ROLES* = 8435
  ERROR_DS_DRA_GENERIC* = 8436
  ERROR_DS_DRA_INVALID_PARAMETER* = 8437
  ERROR_DS_DRA_BUSY* = 8438
  ERROR_DS_DRA_BAD_DN* = 8439
  ERROR_DS_DRA_BAD_NC* = 8440
  ERROR_DS_DRA_DN_EXISTS* = 8441
  ERROR_DS_DRA_INTERNAL_ERROR* = 8442
  ERROR_DS_DRA_INCONSISTENT_DIT* = 8443
  ERROR_DS_DRA_CONNECTION_FAILED* = 8444
  ERROR_DS_DRA_BAD_INSTANCE_TYPE* = 8445
  ERROR_DS_DRA_OUT_OF_MEM* = 8446
  ERROR_DS_DRA_MAIL_PROBLEM* = 8447
  ERROR_DS_DRA_REF_ALREADY_EXISTS* = 8448
  ERROR_DS_DRA_REF_NOT_FOUND* = 8449
  ERROR_DS_DRA_OBJ_IS_REP_SOURCE* = 8450
  ERROR_DS_DRA_DB_ERROR* = 8451
  ERROR_DS_DRA_NO_REPLICA* = 8452
  ERROR_DS_DRA_ACCESS_DENIED* = 8453
  ERROR_DS_DRA_NOT_SUPPORTED* = 8454
  ERROR_DS_DRA_RPC_CANCELLED* = 8455
  ERROR_DS_DRA_SOURCE_DISABLED* = 8456
  ERROR_DS_DRA_SINK_DISABLED* = 8457
  ERROR_DS_DRA_NAME_COLLISION* = 8458
  ERROR_DS_DRA_SOURCE_REINSTALLED* = 8459
  ERROR_DS_DRA_MISSING_PARENT* = 8460
  ERROR_DS_DRA_PREEMPTED* = 8461
  ERROR_DS_DRA_ABANDON_SYNC* = 8462
  ERROR_DS_DRA_SHUTDOWN* = 8463
  ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET* = 8464
  ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA* = 8465
  ERROR_DS_DRA_EXTN_CONNECTION_FAILED* = 8466
  ERROR_DS_INSTALL_SCHEMA_MISMATCH* = 8467
  ERROR_DS_DUP_LINK_ID* = 8468
  ERROR_DS_NAME_ERROR_RESOLVING* = 8469
  ERROR_DS_NAME_ERROR_NOT_FOUND* = 8470
  ERROR_DS_NAME_ERROR_NOT_UNIQUE* = 8471
  ERROR_DS_NAME_ERROR_NO_MAPPING* = 8472
  ERROR_DS_NAME_ERROR_DOMAIN_ONLY* = 8473
  ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING* = 8474
  ERROR_DS_CONSTRUCTED_ATT_MOD* = 8475
  ERROR_DS_WRONG_OM_OBJ_CLASS* = 8476
  ERROR_DS_DRA_REPL_PENDING* = 8477
  ERROR_DS_DS_REQUIRED* = 8478
  ERROR_DS_INVALID_LDAP_DISPLAY_NAME* = 8479
  ERROR_DS_NON_BASE_SEARCH* = 8480
  ERROR_DS_CANT_RETRIEVE_ATTS* = 8481
  ERROR_DS_BACKLINK_WITHOUT_LINK* = 8482
  ERROR_DS_EPOCH_MISMATCH* = 8483
  ERROR_DS_SRC_NAME_MISMATCH* = 8484
  ERROR_DS_SRC_AND_DST_NC_IDENTICAL* = 8485
  ERROR_DS_DST_NC_MISMATCH* = 8486
  ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC* = 8487
  ERROR_DS_SRC_GUID_MISMATCH* = 8488
  ERROR_DS_CANT_MOVE_DELETED_OBJECT* = 8489
  ERROR_DS_PDC_OPERATION_IN_PROGRESS* = 8490
  ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD* = 8491
  ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION* = 8492
  ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS* = 8493
  ERROR_DS_NC_MUST_HAVE_NC_PARENT* = 8494
  ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE* = 8495
  ERROR_DS_DST_DOMAIN_NOT_NATIVE* = 8496
  ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER* = 8497
  ERROR_DS_CANT_MOVE_ACCOUNT_GROUP* = 8498
  ERROR_DS_CANT_MOVE_RESOURCE_GROUP* = 8499
  ERROR_DS_INVALID_SEARCH_FLAG* = 8500
  ERROR_DS_NO_TREE_DELETE_ABOVE_NC* = 8501
  ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE* = 8502
  ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE* = 8503
  ERROR_DS_SAM_INIT_FAILURE* = 8504
  ERROR_DS_SENSITIVE_GROUP_VIOLATION* = 8505
  ERROR_DS_CANT_MOD_PRIMARYGROUPID* = 8506
  ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD* = 8507
  ERROR_DS_NONSAFE_SCHEMA_CHANGE* = 8508
  ERROR_DS_SCHEMA_UPDATE_DISALLOWED* = 8509
  ERROR_DS_CANT_CREATE_UNDER_SCHEMA* = 8510
  ERROR_DS_INSTALL_NO_SRC_SCH_VERSION* = 8511
  ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE* = 8512
  ERROR_DS_INVALID_GROUP_TYPE* = 8513
  ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN* = 8514
  ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN* = 8515
  ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER* = 8516
  ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER* = 8517
  ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER* = 8518
  ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER* = 8519
  ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER* = 8520
  ERROR_DS_HAVE_PRIMARY_MEMBERS* = 8521
  ERROR_DS_STRING_SD_CONVERSION_FAILED* = 8522
  ERROR_DS_NAMING_MASTER_GC* = 8523
  ERROR_DS_DNS_LOOKUP_FAILURE* = 8524
  ERROR_DS_COULDNT_UPDATE_SPNS* = 8525
  ERROR_DS_CANT_RETRIEVE_SD* = 8526
  ERROR_DS_KEY_NOT_UNIQUE* = 8527
  ERROR_DS_WRONG_LINKED_ATT_SYNTAX* = 8528
  ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD* = 8529
  ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY* = 8530
  ERROR_DS_CANT_START* = 8531
  ERROR_DS_INIT_FAILURE* = 8532
  ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION* = 8533
  ERROR_DS_SOURCE_DOMAIN_IN_FOREST* = 8534
  ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST* = 8535
  ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED* = 8536
  ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN* = 8537
  ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER* = 8538
  ERROR_DS_SRC_SID_EXISTS_IN_FOREST* = 8539
  ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH* = 8540
  ERROR_SAM_INIT_FAILURE* = 8541
  ERROR_DS_DRA_SCHEMA_INFO_SHIP* = 8542
  ERROR_DS_DRA_SCHEMA_CONFLICT* = 8543
  ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT* = 8544
  ERROR_DS_DRA_OBJ_NC_MISMATCH* = 8545
  ERROR_DS_NC_STILL_HAS_DSAS* = 8546
  ERROR_DS_GC_REQUIRED* = 8547
  ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY* = 8548
  ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS* = 8549
  ERROR_DS_CANT_ADD_TO_GC* = 8550
  ERROR_DS_NO_CHECKPOINT_WITH_PDC* = 8551
  ERROR_DS_SOURCE_AUDITING_NOT_ENABLED* = 8552
  ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC* = 8553
  ERROR_DS_INVALID_NAME_FOR_SPN* = 8554
  ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS* = 8555
  ERROR_DS_UNICODEPWD_NOT_IN_QUOTES* = 8556
  ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED* = 8557
  ERROR_DS_MUST_BE_RUN_ON_DST_DC* = 8558
  ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER* = 8559
  ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ* = 8560
  ERROR_DS_INIT_FAILURE_CONSOLE* = 8561
  ERROR_DS_SAM_INIT_FAILURE_CONSOLE* = 8562
  ERROR_DS_FOREST_VERSION_TOO_HIGH* = 8563
  ERROR_DS_DOMAIN_VERSION_TOO_HIGH* = 8564
  ERROR_DS_FOREST_VERSION_TOO_LOW* = 8565
  ERROR_DS_DOMAIN_VERSION_TOO_LOW* = 8566
  ERROR_DS_INCOMPATIBLE_VERSION* = 8567
  ERROR_DS_LOW_DSA_VERSION* = 8568
  ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN* = 8569
  ERROR_DS_NOT_SUPPORTED_SORT_ORDER* = 8570
  ERROR_DS_NAME_NOT_UNIQUE* = 8571
  ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4* = 8572
  ERROR_DS_OUT_OF_VERSION_STORE* = 8573
  ERROR_DS_INCOMPATIBLE_CONTROLS_USED* = 8574
  ERROR_DS_NO_REF_DOMAIN* = 8575
  ERROR_DS_RESERVED_LINK_ID* = 8576
  ERROR_DS_LINK_ID_NOT_AVAILABLE* = 8577
  ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER* = 8578
  ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE* = 8579
  ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC* = 8580
  ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG* = 8581
  ERROR_DS_MODIFYDN_WRONG_GRANDPARENT* = 8582
  ERROR_DS_NAME_ERROR_TRUST_REFERRAL* = 8583
  ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER* = 8584
  ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD* = 8585
  ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2* = 8586
  ERROR_DS_THREAD_LIMIT_EXCEEDED* = 8587
  ERROR_DS_NOT_CLOSEST* = 8588
  ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF* = 8589
  ERROR_DS_SINGLE_USER_MODE_FAILED* = 8590
  ERROR_DS_NTDSCRIPT_SYNTAX_ERROR* = 8591
  ERROR_DS_NTDSCRIPT_PROCESS_ERROR* = 8592
  ERROR_DS_DIFFERENT_REPL_EPOCHS* = 8593
  ERROR_DS_DRS_EXTENSIONS_CHANGED* = 8594
  ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR* = 8595
  ERROR_DS_NO_MSDS_INTID* = 8596
  ERROR_DS_DUP_MSDS_INTID* = 8597
  ERROR_DS_EXISTS_IN_RDNATTID* = 8598
  ERROR_DS_AUTHORIZATION_FAILED* = 8599
  ERROR_DS_INVALID_SCRIPT* = 8600
  ERROR_DS_REMOTE_CROSSREF_OP_FAILED* = 8601
  ERROR_DS_CROSS_REF_BUSY* = 8602
  ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN* = 8603
  ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC* = 8604
  ERROR_DS_DUPLICATE_ID_FOUND* = 8605
  ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT* = 8606
  ERROR_DS_GROUP_CONVERSION_ERROR* = 8607
  ERROR_DS_CANT_MOVE_APP_BASIC_GROUP* = 8608
  ERROR_DS_CANT_MOVE_APP_QUERY_GROUP* = 8609
  ERROR_DS_ROLE_NOT_VERIFIED* = 8610
  ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL* = 8611
  ERROR_DS_DOMAIN_RENAME_IN_PROGRESS* = 8612
  ERROR_DS_EXISTING_AD_CHILD_NC* = 8613
  ERROR_DS_REPL_LIFETIME_EXCEEDED* = 8614
  ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER* = 8615
  ERROR_DS_LDAP_SEND_QUEUE_FULL* = 8616
  ERROR_DS_DRA_OUT_SCHEDULE_WINDOW* = 8617
  DNS_ERROR_RESPONSE_CODES_BASE* = 9000
  DNS_ERROR_RCODE_NO_ERROR* = NO_ERROR
  DNS_ERROR_MASK* = 0x00002328
  DNS_ERROR_RCODE_FORMAT_ERROR* = 9001
  DNS_ERROR_RCODE_SERVER_FAILURE* = 9002
  DNS_ERROR_RCODE_NAME_ERROR* = 9003
  DNS_ERROR_RCODE_NOT_IMPLEMENTED* = 9004
  DNS_ERROR_RCODE_REFUSED* = 9005
  DNS_ERROR_RCODE_YXDOMAIN* = 9006
  DNS_ERROR_RCODE_YXRRSET* = 9007
  DNS_ERROR_RCODE_NXRRSET* = 9008
  DNS_ERROR_RCODE_NOTAUTH* = 9009
  DNS_ERROR_RCODE_NOTZONE* = 9010
  DNS_ERROR_RCODE_BADSIG* = 9016
  DNS_ERROR_RCODE_BADKEY* = 9017
  DNS_ERROR_RCODE_BADTIME* = 9018
  DNS_ERROR_RCODE_LAST* = DNS_ERROR_RCODE_BADTIME
  DNS_ERROR_PACKET_FMT_BASE* = 9500
  DNS_INFO_NO_RECORDS* = 9501
  DNS_ERROR_BAD_PACKET* = 9502
  DNS_ERROR_NO_PACKET* = 9503
  DNS_ERROR_RCODE* = 9504
  DNS_ERROR_UNSECURE_PACKET* = 9505
  DNS_STATUS_PACKET_UNSECURE* = DNS_ERROR_UNSECURE_PACKET
  DNS_ERROR_NO_MEMORY* = ERROR_OUTOFMEMORY
  DNS_ERROR_INVALID_NAME* = ERROR_INVALID_NAME
  DNS_ERROR_INVALID_DATA* = ERROR_INVALID_DATA
  DNS_ERROR_GENERAL_API_BASE* = 9550
  DNS_ERROR_INVALID_TYPE* = 9551
  DNS_ERROR_INVALID_IP_ADDRESS* = 9552
  DNS_ERROR_INVALID_PROPERTY* = 9553
  DNS_ERROR_TRY_AGAIN_LATER* = 9554
  DNS_ERROR_NOT_UNIQUE* = 9555
  DNS_ERROR_NON_RFC_NAME* = 9556
  DNS_STATUS_FQDN* = 9557
  DNS_STATUS_DOTTED_NAME* = 9558
  DNS_STATUS_SINGLE_PART_NAME* = 9559
  DNS_ERROR_INVALID_NAME_CHAR* = 9560
  DNS_ERROR_NUMERIC_NAME* = 9561
  DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER* = 9562
  DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION* = 9563
  DNS_ERROR_CANNOT_FIND_ROOT_HINTS* = 9564
  DNS_ERROR_INCONSISTENT_ROOT_HINTS* = 9565
  DNS_ERROR_ZONE_BASE* = 9600
  DNS_ERROR_ZONE_DOES_NOT_EXIST* = 9601
  DNS_ERROR_NO_ZONE_INFO* = 9602
  DNS_ERROR_INVALID_ZONE_OPERATION* = 9603
  DNS_ERROR_ZONE_CONFIGURATION_ERROR* = 9604
  DNS_ERROR_ZONE_HAS_NO_SOA_RECORD* = 9605
  DNS_ERROR_ZONE_HAS_NO_NS_RECORDS* = 9606
  DNS_ERROR_ZONE_LOCKED* = 9607
  DNS_ERROR_ZONE_CREATION_FAILED* = 9608
  DNS_ERROR_ZONE_ALREADY_EXISTS* = 9609
  DNS_ERROR_AUTOZONE_ALREADY_EXISTS* = 9610
  DNS_ERROR_INVALID_ZONE_TYPE* = 9611
  DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP* = 9612
  DNS_ERROR_ZONE_NOT_SECONDARY* = 9613
  DNS_ERROR_NEED_SECONDARY_ADDRESSES* = 9614
  DNS_ERROR_WINS_INIT_FAILED* = 9615
  DNS_ERROR_NEED_WINS_SERVERS* = 9616
  DNS_ERROR_NBSTAT_INIT_FAILED* = 9617
  DNS_ERROR_SOA_DELETE_INVALID* = 9618
  DNS_ERROR_FORWARDER_ALREADY_EXISTS* = 9619
  DNS_ERROR_ZONE_REQUIRES_MASTER_IP* = 9620
  DNS_ERROR_ZONE_IS_SHUTDOWN* = 9621
  DNS_ERROR_DATAFILE_BASE* = 9650
  DNS_ERROR_PRIMARY_REQUIRES_DATAFILE* = 9651
  DNS_ERROR_INVALID_DATAFILE_NAME* = 9652
  DNS_ERROR_DATAFILE_OPEN_FAILURE* = 9653
  DNS_ERROR_FILE_WRITEBACK_FAILED* = 9654
  DNS_ERROR_DATAFILE_PARSING* = 9655
  DNS_ERROR_DATABASE_BASE* = 9700
  DNS_ERROR_RECORD_DOES_NOT_EXIST* = 9701
  DNS_ERROR_RECORD_FORMAT* = 9702
  DNS_ERROR_NODE_CREATION_FAILED* = 9703
  DNS_ERROR_UNKNOWN_RECORD_TYPE* = 9704
  DNS_ERROR_RECORD_TIMED_OUT* = 9705
  DNS_ERROR_NAME_NOT_IN_ZONE* = 9706
  DNS_ERROR_CNAME_LOOP* = 9707
  DNS_ERROR_NODE_IS_CNAME* = 9708
  DNS_ERROR_CNAME_COLLISION* = 9709
  DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT* = 9710
  DNS_ERROR_RECORD_ALREADY_EXISTS* = 9711
  DNS_ERROR_SECONDARY_DATA* = 9712
  DNS_ERROR_NO_CREATE_CACHE_DATA* = 9713
  DNS_ERROR_NAME_DOES_NOT_EXIST* = 9714
  DNS_WARNING_PTR_CREATE_FAILED* = 9715
  DNS_WARNING_DOMAIN_UNDELETED* = 9716
  DNS_ERROR_DS_UNAVAILABLE* = 9717
  DNS_ERROR_DS_ZONE_ALREADY_EXISTS* = 9718
  DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE* = 9719
  DNS_ERROR_OPERATION_BASE* = 9750
  DNS_INFO_AXFR_COMPLETE* = 9751
  DNS_ERROR_AXFR* = 9752
  DNS_INFO_ADDED_LOCAL_WINS* = 9753
  DNS_ERROR_SECURE_BASE* = 9800
  DNS_STATUS_CONTINUE_NEEDED* = 9801
  DNS_ERROR_SETUP_BASE* = 9850
  DNS_ERROR_NO_TCPIP* = 9851
  DNS_ERROR_NO_DNS_SERVERS* = 9852
  DNS_ERROR_DP_BASE* = 9900
  DNS_ERROR_DP_DOES_NOT_EXIST* = 9901
  DNS_ERROR_DP_ALREADY_EXISTS* = 9902
  DNS_ERROR_DP_NOT_ENLISTED* = 9903
  DNS_ERROR_DP_ALREADY_ENLISTED* = 9904
  DNS_ERROR_DP_NOT_AVAILABLE* = 9905
  DNS_ERROR_DP_FSMO_ERROR* = 9906
  WSABASEERR* = 10000
  WSAEINTR* = WSABASEERR+4
  WSAEBADF* = WSABASEERR+9
  WSAEACCES* = WSABASEERR+13
  WSAEFAULT* = WSABASEERR+14
  WSAEINVAL* = WSABASEERR+22
  WSAEMFILE* = WSABASEERR+24
  WSAEWOULDBLOCK* = WSABASEERR+35
  WSAEINPROGRESS* = WSABASEERR+36
  WSAEALREADY* = WSABASEERR+37
  WSAENOTSOCK* = WSABASEERR+38
  WSAEDESTADDRREQ* = WSABASEERR+39
  WSAEMSGSIZE* = WSABASEERR+40
  WSAEPROTOTYPE* = WSABASEERR+41
  WSAENOPROTOOPT* = WSABASEERR+42
  WSAEPROTONOSUPPORT* = WSABASEERR+43
  WSAESOCKTNOSUPPORT* = WSABASEERR+44
  WSAEOPNOTSUPP* = WSABASEERR+45
  WSAEPFNOSUPPORT* = WSABASEERR+46
  WSAEAFNOSUPPORT* = WSABASEERR+47
  WSAEADDRINUSE* = WSABASEERR+48
  WSAEADDRNOTAVAIL* = WSABASEERR+49
  WSAENETDOWN* = WSABASEERR+50
  WSAENETUNREACH* = WSABASEERR+51
  WSAENETRESET* = WSABASEERR+52
  WSAECONNABORTED* = WSABASEERR+53
  WSAECONNRESET* = WSABASEERR+54
  WSAENOBUFS* = WSABASEERR+55
  WSAEISCONN* = WSABASEERR+56
  WSAENOTCONN* = WSABASEERR+57
  WSAESHUTDOWN* = WSABASEERR+58
  WSAETOOMANYREFS* = WSABASEERR+59
  WSAETIMEDOUT* = WSABASEERR+60
  WSAECONNREFUSED* = WSABASEERR+61
  WSAELOOP* = WSABASEERR+62
  WSAENAMETOOLONG* = WSABASEERR+63
  WSAEHOSTDOWN* = WSABASEERR+64
  WSAEHOSTUNREACH* = WSABASEERR+65
  WSAENOTEMPTY* = WSABASEERR+66
  WSAEPROCLIM* = WSABASEERR+67
  WSAEUSERS* = WSABASEERR+68
  WSAEDQUOT* = WSABASEERR+69
  WSAESTALE* = WSABASEERR+70
  WSAEREMOTE* = WSABASEERR+71
  WSASYSNOTREADY* = WSABASEERR+91
  WSAVERNOTSUPPORTED* = WSABASEERR+92
  WSANOTINITIALISED* = WSABASEERR+93
  WSAEDISCON* = WSABASEERR+101
  WSAEINVALIDPROCTABLE* = WSABASEERR+104
  WSAEINVALIDPROVIDER* = WSABASEERR+105
  WSAEPROVIDERFAILEDINIT* = WSABASEERR+106
  WSASYSCALLFAILURE* = WSABASEERR+107
  WSASERVICE_NOT_FOUND* = WSABASEERR+108
  WSATYPE_NOT_FOUND* = WSABASEERR+109
  WSA_E_NO_MORE* = WSABASEERR+110
  WSA_E_CANCELLED* = WSABASEERR+111
  WSAEREFUSED* = WSABASEERR+112
  WSAHOST_NOT_FOUND* = WSABASEERR+1001
  WSATRY_AGAIN* = WSABASEERR+1002
  WSANO_RECOVERY* = WSABASEERR+1003
  WSANO_DATA* = WSABASEERR+1004
  WSA_QOS_RECEIVERS* = WSABASEERR+1005
  WSA_QOS_SENDERS* = WSABASEERR+1006
  WSA_QOS_NO_SENDERS* = WSABASEERR+1007
  WSA_QOS_NO_RECEIVERS* = WSABASEERR+1008
  WSA_QOS_REQUEST_CONFIRMED* = WSABASEERR+1009
  WSA_QOS_ADMISSION_FAILURE* = WSABASEERR+1010
  WSA_QOS_POLICY_FAILURE* = WSABASEERR+1011
  WSA_QOS_BAD_STYLE* = WSABASEERR+1012
  WSA_QOS_BAD_OBJECT* = WSABASEERR+1013
  WSA_QOS_TRAFFIC_CTRL_ERROR* = WSABASEERR+1014
  WSA_QOS_GENERIC_ERROR* = WSABASEERR+1015
  WSA_QOS_ESERVICETYPE* = WSABASEERR+1016
  WSA_QOS_EFLOWSPEC* = WSABASEERR+1017
  WSA_QOS_EPROVSPECBUF* = WSABASEERR+1018
  WSA_QOS_EFILTERSTYLE* = WSABASEERR+1019
  WSA_QOS_EFILTERTYPE* = WSABASEERR+1020
  WSA_QOS_EFILTERCOUNT* = WSABASEERR+1021
  WSA_QOS_EOBJLENGTH* = WSABASEERR+1022
  WSA_QOS_EFLOWCOUNT* = WSABASEERR+1023
  WSA_QOS_EUNKNOWNPSOBJ* = WSABASEERR+1024
  WSA_QOS_EUNKOWNPSOBJ* = WSA_QOS_EUNKNOWNPSOBJ
  WSA_QOS_EPOLICYOBJ* = WSABASEERR+1025
  WSA_QOS_EFLOWDESC* = WSABASEERR+1026
  WSA_QOS_EPSFLOWSPEC* = WSABASEERR+1027
  WSA_QOS_EPSFILTERSPEC* = WSABASEERR+1028
  WSA_QOS_ESDMODEOBJ* = WSABASEERR+1029
  WSA_QOS_ESHAPERATEOBJ* = WSABASEERR+1030
  WSA_QOS_RESERVED_PETYPE* = WSABASEERR+1031
  ERROR_SXS_SECTION_NOT_FOUND* = 14000
  ERROR_SXS_CANT_GEN_ACTCTX* = 14001
  ERROR_SXS_INVALID_ACTCTXDATA_FORMAT* = 14002
  ERROR_SXS_ASSEMBLY_NOT_FOUND* = 14003
  ERROR_SXS_MANIFEST_FORMAT_ERROR* = 14004
  ERROR_SXS_MANIFEST_PARSE_ERROR* = 14005
  ERROR_SXS_ACTIVATION_CONTEXT_DISABLED* = 14006
  ERROR_SXS_KEY_NOT_FOUND* = 14007
  ERROR_SXS_VERSION_CONFLICT* = 14008
  ERROR_SXS_WRONG_SECTION_TYPE* = 14009
  ERROR_SXS_THREAD_QUERIES_DISABLED* = 14010
  ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET* = 14011
  ERROR_SXS_UNKNOWN_ENCODING_GROUP* = 14012
  ERROR_SXS_UNKNOWN_ENCODING* = 14013
  ERROR_SXS_INVALID_XML_NAMESPACE_URI* = 14014
  ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED* = 14015
  ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED* = 14016
  ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE* = 14017
  ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE* = 14018
  ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE* = 14019
  ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT* = 14020
  ERROR_SXS_DUPLICATE_DLL_NAME* = 14021
  ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME* = 14022
  ERROR_SXS_DUPLICATE_CLSID* = 14023
  ERROR_SXS_DUPLICATE_IID* = 14024
  ERROR_SXS_DUPLICATE_TLBID* = 14025
  ERROR_SXS_DUPLICATE_PROGID* = 14026
  ERROR_SXS_DUPLICATE_ASSEMBLY_NAME* = 14027
  ERROR_SXS_FILE_HASH_MISMATCH* = 14028
  ERROR_SXS_POLICY_PARSE_ERROR* = 14029
  ERROR_SXS_XML_E_MISSINGQUOTE* = 14030
  ERROR_SXS_XML_E_COMMENTSYNTAX* = 14031
  ERROR_SXS_XML_E_BADSTARTNAMECHAR* = 14032
  ERROR_SXS_XML_E_BADNAMECHAR* = 14033
  ERROR_SXS_XML_E_BADCHARINSTRING* = 14034
  ERROR_SXS_XML_E_XMLDECLSYNTAX* = 14035
  ERROR_SXS_XML_E_BADCHARDATA* = 14036
  ERROR_SXS_XML_E_MISSINGWHITESPACE* = 14037
  ERROR_SXS_XML_E_EXPECTINGTAGEND* = 14038
  ERROR_SXS_XML_E_MISSINGSEMICOLON* = 14039
  ERROR_SXS_XML_E_UNBALANCEDPAREN* = 14040
  ERROR_SXS_XML_E_INTERNALERROR* = 14041
  ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE* = 14042
  ERROR_SXS_XML_E_INCOMPLETE_ENCODING* = 14043
  ERROR_SXS_XML_E_MISSING_PAREN* = 14044
  ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE* = 14045
  ERROR_SXS_XML_E_MULTIPLE_COLONS* = 14046
  ERROR_SXS_XML_E_INVALID_DECIMAL* = 14047
  ERROR_SXS_XML_E_INVALID_HEXIDECIMAL* = 14048
  ERROR_SXS_XML_E_INVALID_UNICODE* = 14049
  ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK* = 14050
  ERROR_SXS_XML_E_UNEXPECTEDENDTAG* = 14051
  ERROR_SXS_XML_E_UNCLOSEDTAG* = 14052
  ERROR_SXS_XML_E_DUPLICATEATTRIBUTE* = 14053
  ERROR_SXS_XML_E_MULTIPLEROOTS* = 14054
  ERROR_SXS_XML_E_INVALIDATROOTLEVEL* = 14055
  ERROR_SXS_XML_E_BADXMLDECL* = 14056
  ERROR_SXS_XML_E_MISSINGROOT* = 14057
  ERROR_SXS_XML_E_UNEXPECTEDEOF* = 14058
  ERROR_SXS_XML_E_BADPEREFINSUBSET* = 14059
  ERROR_SXS_XML_E_UNCLOSEDSTARTTAG* = 14060
  ERROR_SXS_XML_E_UNCLOSEDENDTAG* = 14061
  ERROR_SXS_XML_E_UNCLOSEDSTRING* = 14062
  ERROR_SXS_XML_E_UNCLOSEDCOMMENT* = 14063
  ERROR_SXS_XML_E_UNCLOSEDDECL* = 14064
  ERROR_SXS_XML_E_UNCLOSEDCDATA* = 14065
  ERROR_SXS_XML_E_RESERVEDNAMESPACE* = 14066
  ERROR_SXS_XML_E_INVALIDENCODING* = 14067
  ERROR_SXS_XML_E_INVALIDSWITCH* = 14068
  ERROR_SXS_XML_E_BADXMLCASE* = 14069
  ERROR_SXS_XML_E_INVALID_STANDALONE* = 14070
  ERROR_SXS_XML_E_UNEXPECTED_STANDALONE* = 14071
  ERROR_SXS_XML_E_INVALID_VERSION* = 14072
  ERROR_SXS_XML_E_MISSINGEQUALS* = 14073
  ERROR_SXS_PROTECTION_RECOVERY_FAILED* = 14074
  ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT* = 14075
  ERROR_SXS_PROTECTION_CATALOG_NOT_VALID* = 14076
  ERROR_SXS_UNTRANSLATABLE_HRESULT* = 14077
  ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING* = 14078
  ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE* = 14079
  ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME* = 14080
  ERROR_SXS_ASSEMBLY_MISSING* = 14081
  ERROR_SXS_CORRUPT_ACTIVATION_STACK* = 14082
  ERROR_SXS_CORRUPTION* = 14083
  ERROR_SXS_EARLY_DEACTIVATION* = 14084
  ERROR_SXS_INVALID_DEACTIVATION* = 14085
  ERROR_SXS_MULTIPLE_DEACTIVATION* = 14086
  ERROR_SXS_PROCESS_TERMINATION_REQUESTED* = 14087
  ERROR_SXS_RELEASE_ACTIVATION_CONTEXT* = 14088
  ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY* = 14089
  ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE* = 14090
  ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME* = 14091
  ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE* = 14092
  ERROR_SXS_IDENTITY_PARSE_ERROR* = 14093
  ERROR_MALFORMED_SUBSTITUTION_STRING* = 14094
  ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN* = 14095
  ERROR_UNMAPPED_SUBSTITUTION_STRING* = 14096
  ERROR_SXS_ASSEMBLY_NOT_LOCKED* = 14097
  ERROR_SXS_COMPONENT_STORE_CORRUPT* = 14098
  ERROR_ADVANCED_INSTALLER_FAILED* = 14099
  ERROR_XML_ENCODING_MISMATCH* = 14100
  ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT* = 14101
  ERROR_SXS_IDENTITIES_DIFFERENT* = 14102
  ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT* = 14103
  ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY* = 14104
  ERROR_SXS_MANIFEST_TOO_BIG* = 14105
  ERROR_SXS_SETTING_NOT_REGISTERED* = 14106
  ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE* = 14107
  ERROR_SMI_PRIMITIVE_INSTALLER_FAILED* = 14108
  ERROR_GENERIC_COMMAND_FAILED* = 14109
  ERROR_SXS_FILE_HASH_MISSING* = 14110
  ERROR_IPSEC_QM_POLICY_EXISTS* = 13000
  ERROR_IPSEC_QM_POLICY_NOT_FOUND* = 13001
  ERROR_IPSEC_QM_POLICY_IN_USE* = 13002
  ERROR_IPSEC_MM_POLICY_EXISTS* = 13003
  ERROR_IPSEC_MM_POLICY_NOT_FOUND* = 13004
  ERROR_IPSEC_MM_POLICY_IN_USE* = 13005
  ERROR_IPSEC_MM_FILTER_EXISTS* = 13006
  ERROR_IPSEC_MM_FILTER_NOT_FOUND* = 13007
  ERROR_IPSEC_TRANSPORT_FILTER_EXISTS* = 13008
  ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND* = 13009
  ERROR_IPSEC_MM_AUTH_EXISTS* = 13010
  ERROR_IPSEC_MM_AUTH_NOT_FOUND* = 13011
  ERROR_IPSEC_MM_AUTH_IN_USE* = 13012
  ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND* = 13013
  ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND* = 13014
  ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND* = 13015
  ERROR_IPSEC_TUNNEL_FILTER_EXISTS* = 13016
  ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND* = 13017
  ERROR_IPSEC_MM_FILTER_PENDING_DELETION* = 13018
  ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION* = 13019
  ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION* = 13020
  ERROR_IPSEC_MM_POLICY_PENDING_DELETION* = 13021
  ERROR_IPSEC_MM_AUTH_PENDING_DELETION* = 13022
  ERROR_IPSEC_QM_POLICY_PENDING_DELETION* = 13023
  WARNING_IPSEC_MM_POLICY_PRUNED* = 13024
  WARNING_IPSEC_QM_POLICY_PRUNED* = 13025
  ERROR_IPSEC_IKE_NEG_STATUS_BEGIN* = 13800
  ERROR_IPSEC_IKE_AUTH_FAIL* = 13801
  ERROR_IPSEC_IKE_ATTRIB_FAIL* = 13802
  ERROR_IPSEC_IKE_NEGOTIATION_PENDING* = 13803
  ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR* = 13804
  ERROR_IPSEC_IKE_TIMED_OUT* = 13805
  ERROR_IPSEC_IKE_NO_CERT* = 13806
  ERROR_IPSEC_IKE_SA_DELETED* = 13807
  ERROR_IPSEC_IKE_SA_REAPED* = 13808
  ERROR_IPSEC_IKE_MM_ACQUIRE_DROP* = 13809
  ERROR_IPSEC_IKE_QM_ACQUIRE_DROP* = 13810
  ERROR_IPSEC_IKE_QUEUE_DROP_MM* = 13811
  ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM* = 13812
  ERROR_IPSEC_IKE_DROP_NO_RESPONSE* = 13813
  ERROR_IPSEC_IKE_MM_DELAY_DROP* = 13814
  ERROR_IPSEC_IKE_QM_DELAY_DROP* = 13815
  ERROR_IPSEC_IKE_ERROR* = 13816
  ERROR_IPSEC_IKE_CRL_FAILED* = 13817
  ERROR_IPSEC_IKE_INVALID_KEY_USAGE* = 13818
  ERROR_IPSEC_IKE_INVALID_CERT_TYPE* = 13819
  ERROR_IPSEC_IKE_NO_PRIVATE_KEY* = 13820
  ERROR_IPSEC_IKE_DH_FAIL* = 13822
  ERROR_IPSEC_IKE_INVALID_HEADER* = 13824
  ERROR_IPSEC_IKE_NO_POLICY* = 13825
  ERROR_IPSEC_IKE_INVALID_SIGNATURE* = 13826
  ERROR_IPSEC_IKE_KERBEROS_ERROR* = 13827
  ERROR_IPSEC_IKE_NO_PUBLIC_KEY* = 13828
  ERROR_IPSEC_IKE_PROCESS_ERR* = 13829
  ERROR_IPSEC_IKE_PROCESS_ERR_SA* = 13830
  ERROR_IPSEC_IKE_PROCESS_ERR_PROP* = 13831
  ERROR_IPSEC_IKE_PROCESS_ERR_TRANS* = 13832
  ERROR_IPSEC_IKE_PROCESS_ERR_KE* = 13833
  ERROR_IPSEC_IKE_PROCESS_ERR_ID* = 13834
  ERROR_IPSEC_IKE_PROCESS_ERR_CERT* = 13835
  ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ* = 13836
  ERROR_IPSEC_IKE_PROCESS_ERR_HASH* = 13837
  ERROR_IPSEC_IKE_PROCESS_ERR_SIG* = 13838
  ERROR_IPSEC_IKE_PROCESS_ERR_NONCE* = 13839
  ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY* = 13840
  ERROR_IPSEC_IKE_PROCESS_ERR_DELETE* = 13841
  ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR* = 13842
  ERROR_IPSEC_IKE_INVALID_PAYLOAD* = 13843
  ERROR_IPSEC_IKE_LOAD_SOFT_SA* = 13844
  ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN* = 13845
  ERROR_IPSEC_IKE_INVALID_COOKIE* = 13846
  ERROR_IPSEC_IKE_NO_PEER_CERT* = 13847
  ERROR_IPSEC_IKE_PEER_CRL_FAILED* = 13848
  ERROR_IPSEC_IKE_POLICY_CHANGE* = 13849
  ERROR_IPSEC_IKE_NO_MM_POLICY* = 13850
  ERROR_IPSEC_IKE_NOTCBPRIV* = 13851
  ERROR_IPSEC_IKE_SECLOADFAIL* = 13852
  ERROR_IPSEC_IKE_FAILSSPINIT* = 13853
  ERROR_IPSEC_IKE_FAILQUERYSSP* = 13854
  ERROR_IPSEC_IKE_SRVACQFAIL* = 13855
  ERROR_IPSEC_IKE_SRVQUERYCRED* = 13856
  ERROR_IPSEC_IKE_GETSPIFAIL* = 13857
  ERROR_IPSEC_IKE_INVALID_FILTER* = 13858
  ERROR_IPSEC_IKE_OUT_OF_MEMORY* = 13859
  ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED* = 13860
  ERROR_IPSEC_IKE_INVALID_POLICY* = 13861
  ERROR_IPSEC_IKE_UNKNOWN_DOI* = 13862
  ERROR_IPSEC_IKE_INVALID_SITUATION* = 13863
  ERROR_IPSEC_IKE_DH_FAILURE* = 13864
  ERROR_IPSEC_IKE_INVALID_GROUP* = 13865
  ERROR_IPSEC_IKE_ENCRYPT* = 13866
  ERROR_IPSEC_IKE_DECRYPT* = 13867
  ERROR_IPSEC_IKE_POLICY_MATCH* = 13868
  ERROR_IPSEC_IKE_UNSUPPORTED_ID* = 13869
  ERROR_IPSEC_IKE_INVALID_HASH* = 13870
  ERROR_IPSEC_IKE_INVALID_HASH_ALG* = 13871
  ERROR_IPSEC_IKE_INVALID_HASH_SIZE* = 13872
  ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG* = 13873
  ERROR_IPSEC_IKE_INVALID_AUTH_ALG* = 13874
  ERROR_IPSEC_IKE_INVALID_SIG* = 13875
  ERROR_IPSEC_IKE_LOAD_FAILED* = 13876
  ERROR_IPSEC_IKE_RPC_DELETE* = 13877
  ERROR_IPSEC_IKE_BENIGN_REINIT* = 13878
  ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY* = 13879
  ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN* = 13881
  ERROR_IPSEC_IKE_MM_LIMIT* = 13882
  ERROR_IPSEC_IKE_NEGOTIATION_DISABLED* = 13883
  ERROR_IPSEC_IKE_QM_LIMIT* = 13884
  ERROR_IPSEC_IKE_MM_EXPIRED* = 13885
  ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID* = 13886
  ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH* = 13887
  ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID* = 13888
  ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD* = 13889
  ERROR_IPSEC_IKE_DOS_COOKIE_SENT* = 13890
  ERROR_IPSEC_IKE_SHUTTING_DOWN* = 13891
  ERROR_IPSEC_IKE_CGA_AUTH_FAILED* = 13892
  ERROR_IPSEC_IKE_PROCESS_ERR_NATOA* = 13893
  ERROR_IPSEC_IKE_INVALID_MM_FOR_QM* = 13894
  ERROR_IPSEC_IKE_QM_EXPIRED* = 13895
  ERROR_IPSEC_IKE_TOO_MANY_FILTERS* = 13896
  ERROR_IPSEC_IKE_NEG_STATUS_END* = 13897
  ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL* = 13898
  ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE* = 13899
  ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING* = 13900
  ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING* = 13901
  ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS* = 13902
  ERROR_IPSEC_IKE_RATELIMIT_DROP* = 13903
  ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE* = 13904
  ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE* = 13905
  ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE* = 13906
  ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY* = 13907
  ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE* = 13908
  ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END* = 13909
  ERROR_IPSEC_BAD_SPI* = 13910
  ERROR_IPSEC_SA_LIFETIME_EXPIRED* = 13911
  ERROR_IPSEC_WRONG_SA* = 13912
  ERROR_IPSEC_REPLAY_CHECK_FAILED* = 13913
  ERROR_IPSEC_INVALID_PACKET* = 13914
  ERROR_IPSEC_INTEGRITY_CHECK_FAILED* = 13915
  ERROR_IPSEC_CLEAR_TEXT_DROP* = 13916
  ERROR_IPSEC_AUTH_FIREWALL_DROP* = 13917
  ERROR_IPSEC_THROTTLE_DROP* = 13918
  ERROR_IPSEC_DOSP_BLOCK* = 13925
  ERROR_IPSEC_DOSP_RECEIVED_MULTICAST* = 13926
  ERROR_IPSEC_DOSP_INVALID_PACKET* = 13927
  ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED* = 13928
  ERROR_IPSEC_DOSP_MAX_ENTRIES* = 13929
  ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED* = 13930
  ERROR_IPSEC_DOSP_NOT_INSTALLED* = 13931
  ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES* = 13932
  ERROR_EVT_INVALID_CHANNEL_PATH* = 15000
  ERROR_EVT_INVALID_QUERY* = 15001
  ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND* = 15002
  ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND* = 15003
  ERROR_EVT_INVALID_PUBLISHER_NAME* = 15004
  ERROR_EVT_INVALID_EVENT_DATA* = 15005
  ERROR_EVT_CHANNEL_NOT_FOUND* = 15007
  ERROR_EVT_MALFORMED_XML_TEXT* = 15008
  ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL* = 15009
  ERROR_EVT_CONFIGURATION_ERROR* = 15010
  ERROR_EVT_QUERY_RESULT_STALE* = 15011
  ERROR_EVT_QUERY_RESULT_INVALID_POSITION* = 15012
  ERROR_EVT_NON_VALIDATING_MSXML* = 15013
  ERROR_EVT_FILTER_ALREADYSCOPED* = 15014
  ERROR_EVT_FILTER_NOTELTSET* = 15015
  ERROR_EVT_FILTER_INVARG* = 15016
  ERROR_EVT_FILTER_INVTEST* = 15017
  ERROR_EVT_FILTER_INVTYPE* = 15018
  ERROR_EVT_FILTER_PARSEERR* = 15019
  ERROR_EVT_FILTER_UNSUPPORTEDOP* = 15020
  ERROR_EVT_FILTER_UNEXPECTEDTOKEN* = 15021
  ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL* = 15022
  ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE* = 15023
  ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE* = 15024
  ERROR_EVT_CHANNEL_CANNOT_ACTIVATE* = 15025
  ERROR_EVT_FILTER_TOO_COMPLEX* = 15026
  ERROR_EVT_MESSAGE_NOT_FOUND* = 15027
  ERROR_EVT_MESSAGE_ID_NOT_FOUND* = 15028
  ERROR_EVT_UNRESOLVED_VALUE_INSERT* = 15029
  ERROR_EVT_UNRESOLVED_PARAMETER_INSERT* = 15030
  ERROR_EVT_MAX_INSERTS_REACHED* = 15031
  ERROR_EVT_EVENT_DEFINITION_NOT_FOUND* = 15032
  ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND* = 15033
  ERROR_EVT_VERSION_TOO_OLD* = 15034
  ERROR_EVT_VERSION_TOO_NEW* = 15035
  ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY* = 15036
  ERROR_EVT_PUBLISHER_DISABLED* = 15037
  ERROR_EVT_FILTER_OUT_OF_RANGE* = 15038
  ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE* = 15080
  ERROR_EC_LOG_DISABLED* = 15081
  ERROR_EC_CIRCULAR_FORWARDING* = 15082
  ERROR_EC_CREDSTORE_FULL* = 15083
  ERROR_EC_CRED_NOT_FOUND* = 15084
  ERROR_EC_NO_ACTIVE_CHANNEL* = 15085
  ERROR_MUI_FILE_NOT_FOUND* = 15100
  ERROR_MUI_INVALID_FILE* = 15101
  ERROR_MUI_INVALID_RC_CONFIG* = 15102
  ERROR_MUI_INVALID_LOCALE_NAME* = 15103
  ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME* = 15104
  ERROR_MUI_FILE_NOT_LOADED* = 15105
  ERROR_RESOURCE_ENUM_USER_STOP* = 15106
  ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED* = 15107
  ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME* = 15108
  ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE* = 15110
  ERROR_MRM_INVALID_PRICONFIG* = 15111
  ERROR_MRM_INVALID_FILE_TYPE* = 15112
  ERROR_MRM_UNKNOWN_QUALIFIER* = 15113
  ERROR_MRM_INVALID_QUALIFIER_VALUE* = 15114
  ERROR_MRM_NO_CANDIDATE* = 15115
  ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE* = 15116
  ERROR_MRM_RESOURCE_TYPE_MISMATCH* = 15117
  ERROR_MRM_DUPLICATE_MAP_NAME* = 15118
  ERROR_MRM_DUPLICATE_ENTRY* = 15119
  ERROR_MRM_INVALID_RESOURCE_IDENTIFIER* = 15120
  ERROR_MRM_FILEPATH_TOO_LONG* = 15121
  ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE* = 15122
  ERROR_MRM_INVALID_PRI_FILE* = 15126
  ERROR_MRM_NAMED_RESOURCE_NOT_FOUND* = 15127
  ERROR_MRM_MAP_NOT_FOUND* = 15135
  ERROR_MRM_UNSUPPORTED_PROFILE_TYPE* = 15136
  ERROR_MRM_INVALID_QUALIFIER_OPERATOR* = 15137
  ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE* = 15138
  ERROR_MRM_AUTOMERGE_ENABLED* = 15139
  ERROR_MRM_TOO_MANY_RESOURCES* = 15140
  ERROR_MCA_INVALID_CAPABILITIES_STRING* = 15200
  ERROR_MCA_INVALID_VCP_VERSION* = 15201
  ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION* = 15202
  ERROR_MCA_MCCS_VERSION_MISMATCH* = 15203
  ERROR_MCA_UNSUPPORTED_MCCS_VERSION* = 15204
  ERROR_MCA_INTERNAL_ERROR* = 15205
  ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED* = 15206
  ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE* = 15207
  ERROR_AMBIGUOUS_SYSTEM_DEVICE* = 15250
  ERROR_SYSTEM_DEVICE_NOT_FOUND* = 15299
  ERROR_HASH_NOT_SUPPORTED* = 15300
  ERROR_HASH_NOT_PRESENT* = 15301
  ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED* = 15321
  ERROR_GPIO_CLIENT_INFORMATION_INVALID* = 15322
  ERROR_GPIO_VERSION_NOT_SUPPORTED* = 15323
  ERROR_GPIO_INVALID_REGISTRATION_PACKET* = 15324
  ERROR_GPIO_OPERATION_DENIED* = 15325
  ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE* = 15326
  ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED* = 15327
  ERROR_CANNOT_SWITCH_RUNLEVEL* = 15400
  ERROR_INVALID_RUNLEVEL_SETTING* = 15401
  ERROR_RUNLEVEL_SWITCH_TIMEOUT* = 15402
  ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT* = 15403
  ERROR_RUNLEVEL_SWITCH_IN_PROGRESS* = 15404
  ERROR_SERVICES_FAILED_AUTOSTART* = 15405
  ERROR_COM_TASK_STOP_PENDING* = 15501
  ERROR_INSTALL_OPEN_PACKAGE_FAILED* = 15600
  ERROR_INSTALL_PACKAGE_NOT_FOUND* = 15601
  ERROR_INSTALL_INVALID_PACKAGE* = 15602
  ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED* = 15603
  ERROR_INSTALL_OUT_OF_DISK_SPACE* = 15604
  ERROR_INSTALL_NETWORK_FAILURE* = 15605
  ERROR_INSTALL_REGISTRATION_FAILURE* = 15606
  ERROR_INSTALL_DEREGISTRATION_FAILURE* = 15607
  ERROR_INSTALL_CANCEL* = 15608
  ERROR_INSTALL_FAILED* = 15609
  ERROR_REMOVE_FAILED* = 15610
  ERROR_PACKAGE_ALREADY_EXISTS* = 15611
  ERROR_NEEDS_REMEDIATION* = 15612
  ERROR_INSTALL_PREREQUISITE_FAILED* = 15613
  ERROR_PACKAGE_REPOSITORY_CORRUPTED* = 15614
  ERROR_INSTALL_POLICY_FAILURE* = 15615
  ERROR_PACKAGE_UPDATING* = 15616
  ERROR_DEPLOYMENT_BLOCKED_BY_POLICY* = 15617
  ERROR_PACKAGES_IN_USE* = 15618
  ERROR_RECOVERY_FILE_CORRUPT* = 15619
  ERROR_INVALID_STAGED_SIGNATURE* = 15620
  ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED* = 15621
  ERROR_INSTALL_PACKAGE_DOWNGRADE* = 15622
  ERROR_SYSTEM_NEEDS_REMEDIATION* = 15623
  ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN* = 15624
  ERROR_RESILIENCY_FILE_CORRUPT* = 15625
  ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING* = 15626
  APPMODEL_ERROR_NO_PACKAGE* = 15700
  APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT* = 15701
  APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT* = 15702
  APPMODEL_ERROR_NO_APPLICATION* = 15703
  ERROR_STATE_LOAD_STORE_FAILED* = 15800
  ERROR_STATE_GET_VERSION_FAILED* = 15801
  ERROR_STATE_SET_VERSION_FAILED* = 15802
  ERROR_STATE_STRUCTURED_RESET_FAILED* = 15803
  ERROR_STATE_OPEN_CONTAINER_FAILED* = 15804
  ERROR_STATE_CREATE_CONTAINER_FAILED* = 15805
  ERROR_STATE_DELETE_CONTAINER_FAILED* = 15806
  ERROR_STATE_READ_SETTING_FAILED* = 15807
  ERROR_STATE_WRITE_SETTING_FAILED* = 15808
  ERROR_STATE_DELETE_SETTING_FAILED* = 15809
  ERROR_STATE_QUERY_SETTING_FAILED* = 15810
  ERROR_STATE_READ_COMPOSITE_SETTING_FAILED* = 15811
  ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED* = 15812
  ERROR_STATE_ENUMERATE_CONTAINER_FAILED* = 15813
  ERROR_STATE_ENUMERATE_SETTINGS_FAILED* = 15814
  ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED* = 15815
  ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED* = 15816
  ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED* = 15817
  ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED* = 15818
  ERROR_API_UNAVAILABLE* = 15841
  SEVERITY_SUCCESS* = 0
  SEVERITY_ERROR* = 1
  FACILITY_NT_BIT* = 0x10000000
  E_UNEXPECTED* = HRESULT 0x8000FFFF'i32
  E_NOTIMPL* = HRESULT 0x80004001'i32
  E_OUTOFMEMORY* = HRESULT 0x8007000E'i32
  E_INVALIDARG* = HRESULT 0x80070057'i32
  E_NOINTERFACE* = HRESULT 0x80004002'i32
  E_POINTER* = HRESULT 0x80004003'i32
  E_HANDLE* = HRESULT 0x80070006'i32
  E_ABORT* = HRESULT 0x80004004'i32
  E_FAIL* = HRESULT 0x80004005'i32
  E_ACCESSDENIED* = HRESULT 0x80070005'i32
  E_PENDING* = HRESULT 0x8000000A'i32
template HRESULT_FROM_WIN32*(x: untyped): HRESULT = (if x <= 0: HRESULT x else: HRESULT(x and 0x0000ffff) or HRESULT(FACILITY_WIN32 shl 16) or HRESULT(0x80000000'i32))
const
  E_NOT_SUFFICIENT_BUFFER* = HRESULT_FROM_WIN32(ERROR_INSUFFICIENT_BUFFER)
  CO_E_INIT_TLS* = HRESULT 0x80004006'i32
  CO_E_INIT_SHARED_ALLOCATOR* = HRESULT 0x80004007'i32
  CO_E_INIT_MEMORY_ALLOCATOR* = HRESULT 0x80004008'i32
  CO_E_INIT_CLASS_CACHE* = HRESULT 0x80004009'i32
  CO_E_INIT_RPC_CHANNEL* = HRESULT 0x8000400A'i32
  CO_E_INIT_TLS_SET_CHANNEL_CONTROL* = HRESULT 0x8000400B'i32
  CO_E_INIT_TLS_CHANNEL_CONTROL* = HRESULT 0x8000400C'i32
  CO_E_INIT_UNACCEPTED_USER_ALLOCATOR* = HRESULT 0x8000400D'i32
  CO_E_INIT_SCM_MUTEX_EXISTS* = HRESULT 0x8000400E'i32
  CO_E_INIT_SCM_FILE_MAPPING_EXISTS* = HRESULT 0x8000400F'i32
  CO_E_INIT_SCM_MAP_VIEW_OF_FILE* = HRESULT 0x80004010'i32
  CO_E_INIT_SCM_EXEC_FAILURE* = HRESULT 0x80004011'i32
  CO_E_INIT_ONLY_SINGLE_THREADED* = HRESULT 0x80004012'i32
  CO_E_CANT_REMOTE* = HRESULT 0x80004013'i32
  CO_E_BAD_SERVER_NAME* = HRESULT 0x80004014'i32
  CO_E_WRONG_SERVER_IDENTITY* = HRESULT 0x80004015'i32
  CO_E_OLE1DDE_DISABLED* = HRESULT 0x80004016'i32
  CO_E_RUNAS_SYNTAX* = HRESULT 0x80004017'i32
  CO_E_CREATEPROCESS_FAILURE* = HRESULT 0x80004018'i32
  CO_E_RUNAS_CREATEPROCESS_FAILURE* = HRESULT 0x80004019'i32
  CO_E_RUNAS_LOGON_FAILURE* = HRESULT 0x8000401A'i32
  CO_E_LAUNCH_PERMSSION_DENIED* = HRESULT 0x8000401B'i32
  CO_E_START_SERVICE_FAILURE* = HRESULT 0x8000401C'i32
  CO_E_REMOTE_COMMUNICATION_FAILURE* = HRESULT 0x8000401D'i32
  CO_E_SERVER_START_TIMEOUT* = HRESULT 0x8000401E'i32
  CO_E_CLSREG_INCONSISTENT* = HRESULT 0x8000401F'i32
  CO_E_IIDREG_INCONSISTENT* = HRESULT 0x80004020'i32
  CO_E_NOT_SUPPORTED* = HRESULT 0x80004021'i32
  CO_E_RELOAD_DLL* = HRESULT 0x80004022'i32
  CO_E_MSI_ERROR* = HRESULT 0x80004023'i32
  CO_E_ATTEMPT_TO_CREATE_OUTSIDE_CLIENT_CONTEXT* = HRESULT 0x80004024'i32
  CO_E_SERVER_PAUSED* = HRESULT 0x80004025'i32
  CO_E_SERVER_NOT_PAUSED* = HRESULT 0x80004026'i32
  CO_E_CLASS_DISABLED* = HRESULT 0x80004027'i32
  CO_E_CLRNOTAVAILABLE* = HRESULT 0x80004028'i32
  CO_E_ASYNC_WORK_REJECTED* = HRESULT 0x80004029'i32
  CO_E_SERVER_INIT_TIMEOUT* = HRESULT 0x8000402A'i32
  CO_E_NO_SECCTX_IN_ACTIVATE* = HRESULT 0x8000402B'i32
  CO_E_TRACKER_CONFIG* = HRESULT 0x80004030'i32
  CO_E_THREADPOOL_CONFIG* = HRESULT 0x80004031'i32
  CO_E_SXS_CONFIG* = HRESULT 0x80004032'i32
  CO_E_MALFORMED_SPN* = HRESULT 0x80004033'i32
  S_OK* = HRESULT 0x00000000
  S_FALSE* = HRESULT 0x00000001
  OLE_E_FIRST* = HRESULT 0x80040000'i32
  OLE_E_LAST* = HRESULT 0x800400FF'i32
  OLE_S_FIRST* = HRESULT 0x00040000
  OLE_S_LAST* = HRESULT 0x000400FF
  OLE_E_OLEVERB* = HRESULT 0x80040000'i32
  OLE_E_ADVF* = HRESULT 0x80040001'i32
  OLE_E_ENUM_NOMORE* = HRESULT 0x80040002'i32
  OLE_E_ADVISENOTSUPPORTED* = HRESULT 0x80040003'i32
  OLE_E_NOCONNECTION* = HRESULT 0x80040004'i32
  OLE_E_NOTRUNNING* = HRESULT 0x80040005'i32
  OLE_E_NOCACHE* = HRESULT 0x80040006'i32
  OLE_E_BLANK* = HRESULT 0x80040007'i32
  OLE_E_CLASSDIFF* = HRESULT 0x80040008'i32
  OLE_E_CANT_GETMONIKER* = HRESULT 0x80040009'i32
  OLE_E_CANT_BINDTOSOURCE* = HRESULT 0x8004000A'i32
  OLE_E_STATIC* = HRESULT 0x8004000B'i32
  OLE_E_PROMPTSAVECANCELLED* = HRESULT 0x8004000C'i32
  OLE_E_INVALIDRECT* = HRESULT 0x8004000D'i32
  OLE_E_WRONGCOMPOBJ* = HRESULT 0x8004000E'i32
  OLE_E_INVALIDHWND* = HRESULT 0x8004000F'i32
  OLE_E_NOT_INPLACEACTIVE* = HRESULT 0x80040010'i32
  OLE_E_CANTCONVERT* = HRESULT 0x80040011'i32
  OLE_E_NOSTORAGE* = HRESULT 0x80040012'i32
  DV_E_FORMATETC* = HRESULT 0x80040064'i32
  DV_E_DVTARGETDEVICE* = HRESULT 0x80040065'i32
  DV_E_STGMEDIUM* = HRESULT 0x80040066'i32
  DV_E_STATDATA* = HRESULT 0x80040067'i32
  DV_E_LINDEX* = HRESULT 0x80040068'i32
  DV_E_TYMED* = HRESULT 0x80040069'i32
  DV_E_CLIPFORMAT* = HRESULT 0x8004006A'i32
  DV_E_DVASPECT* = HRESULT 0x8004006B'i32
  DV_E_DVTARGETDEVICE_SIZE* = HRESULT 0x8004006C'i32
  DV_E_NOIVIEWOBJECT* = HRESULT 0x8004006D'i32
  DRAGDROP_E_FIRST* = 0x80040100'i32
  DRAGDROP_E_LAST* = 0x8004010F'i32
  DRAGDROP_S_FIRST* = 0x00040100
  DRAGDROP_S_LAST* = 0x0004010F
  DRAGDROP_E_NOTREGISTERED* = HRESULT 0x80040100'i32
  DRAGDROP_E_ALREADYREGISTERED* = HRESULT 0x80040101'i32
  DRAGDROP_E_INVALIDHWND* = HRESULT 0x80040102'i32
  CLASSFACTORY_E_FIRST* = 0x80040110'i32
  CLASSFACTORY_E_LAST* = 0x8004011F'i32
  CLASSFACTORY_S_FIRST* = 0x00040110
  CLASSFACTORY_S_LAST* = 0x0004011F
  CLASS_E_NOAGGREGATION* = HRESULT 0x80040110'i32
  CLASS_E_CLASSNOTAVAILABLE* = HRESULT 0x80040111'i32
  CLASS_E_NOTLICENSED* = HRESULT 0x80040112'i32
  MARSHAL_E_FIRST* = 0x80040120'i32
  MARSHAL_E_LAST* = 0x8004012F'i32
  MARSHAL_S_FIRST* = 0x00040120
  MARSHAL_S_LAST* = 0x0004012F
  DATA_E_FIRST* = 0x80040130'i32
  DATA_E_LAST* = 0x8004013F'i32
  DATA_S_FIRST* = 0x00040130
  DATA_S_LAST* = 0x0004013F
  VIEW_E_FIRST* = 0x80040140'i32
  VIEW_E_LAST* = 0x8004014F'i32
  VIEW_S_FIRST* = 0x00040140
  VIEW_S_LAST* = 0x0004014F
  VIEW_E_DRAW* = HRESULT 0x80040140'i32
  REGDB_E_FIRST* = 0x80040150'i32
  REGDB_E_LAST* = 0x8004015F'i32
  REGDB_S_FIRST* = 0x00040150
  REGDB_S_LAST* = 0x0004015F
  REGDB_E_READREGDB* = HRESULT 0x80040150'i32
  REGDB_E_WRITEREGDB* = HRESULT 0x80040151'i32
  REGDB_E_KEYMISSING* = HRESULT 0x80040152'i32
  REGDB_E_INVALIDVALUE* = HRESULT 0x80040153'i32
  REGDB_E_CLASSNOTREG* = HRESULT 0x80040154'i32
  REGDB_E_IIDNOTREG* = HRESULT 0x80040155'i32
  REGDB_E_BADTHREADINGMODEL* = HRESULT 0x80040156'i32
  CAT_E_FIRST* = 0x80040160'i32
  CAT_E_LAST* = 0x80040161'i32
  CAT_E_CATIDNOEXIST* = HRESULT 0x80040160'i32
  CAT_E_NODESCRIPTION* = HRESULT 0x80040161'i32
  CS_E_FIRST* = 0x80040164'i32
  CS_E_LAST* = 0x8004016F'i32
  CS_E_PACKAGE_NOTFOUND* = HRESULT 0x80040164'i32
  CS_E_NOT_DELETABLE* = HRESULT 0x80040165'i32
  CS_E_CLASS_NOTFOUND* = HRESULT 0x80040166'i32
  CS_E_INVALID_VERSION* = HRESULT 0x80040167'i32
  CS_E_NO_CLASSSTORE* = HRESULT 0x80040168'i32
  CS_E_OBJECT_NOTFOUND* = HRESULT 0x80040169'i32
  CS_E_OBJECT_ALREADY_EXISTS* = HRESULT 0x8004016A'i32
  CS_E_INVALID_PATH* = HRESULT 0x8004016B'i32
  CS_E_NETWORK_ERROR* = HRESULT 0x8004016C'i32
  CS_E_ADMIN_LIMIT_EXCEEDED* = HRESULT 0x8004016D'i32
  CS_E_SCHEMA_MISMATCH* = HRESULT 0x8004016E'i32
  CS_E_INTERNAL_ERROR* = HRESULT 0x8004016F'i32
  CACHE_E_FIRST* = 0x80040170'i32
  CACHE_E_LAST* = 0x8004017F'i32
  CACHE_S_FIRST* = 0x00040170
  CACHE_S_LAST* = 0x0004017F
  CACHE_E_NOCACHE_UPDATED* = HRESULT 0x80040170'i32
  OLEOBJ_E_FIRST* = 0x80040180'i32
  OLEOBJ_E_LAST* = 0x8004018F'i32
  OLEOBJ_S_FIRST* = 0x00040180
  OLEOBJ_S_LAST* = 0x0004018F
  OLEOBJ_E_NOVERBS* = HRESULT 0x80040180'i32
  OLEOBJ_E_INVALIDVERB* = HRESULT 0x80040181'i32
  CLIENTSITE_E_FIRST* = 0x80040190'i32
  CLIENTSITE_E_LAST* = 0x8004019F'i32
  CLIENTSITE_S_FIRST* = 0x00040190
  CLIENTSITE_S_LAST* = 0x0004019F
  INPLACE_E_NOTUNDOABLE* = HRESULT 0x800401A0'i32
  INPLACE_E_NOTOOLSPACE* = HRESULT 0x800401A1'i32
  INPLACE_E_FIRST* = 0x800401A0'i32
  INPLACE_E_LAST* = 0x800401AF'i32
  INPLACE_S_FIRST* = 0x000401A0
  INPLACE_S_LAST* = 0x000401AF
  ENUM_E_FIRST* = 0x800401B0'i32
  ENUM_E_LAST* = 0x800401BF'i32
  ENUM_S_FIRST* = 0x000401B0
  ENUM_S_LAST* = 0x000401BF
  CONVERT10_E_FIRST* = 0x800401C0'i32
  CONVERT10_E_LAST* = 0x800401CF'i32
  CONVERT10_S_FIRST* = 0x000401C0
  CONVERT10_S_LAST* = 0x000401CF
  CONVERT10_E_OLESTREAM_GET* = HRESULT 0x800401C0'i32
  CONVERT10_E_OLESTREAM_PUT* = HRESULT 0x800401C1'i32
  CONVERT10_E_OLESTREAM_FMT* = HRESULT 0x800401C2'i32
  CONVERT10_E_OLESTREAM_BITMAP_TO_DIB* = HRESULT 0x800401C3'i32
  CONVERT10_E_STG_FMT* = HRESULT 0x800401C4'i32
  CONVERT10_E_STG_NO_STD_STREAM* = HRESULT 0x800401C5'i32
  CONVERT10_E_STG_DIB_TO_BITMAP* = HRESULT 0x800401C6'i32
  CLIPBRD_E_FIRST* = 0x800401D0'i32
  CLIPBRD_E_LAST* = 0x800401DF'i32
  CLIPBRD_S_FIRST* = 0x000401D0
  CLIPBRD_S_LAST* = 0x000401DF
  CLIPBRD_E_CANT_OPEN* = HRESULT 0x800401D0'i32
  CLIPBRD_E_CANT_EMPTY* = HRESULT 0x800401D1'i32
  CLIPBRD_E_CANT_SET* = HRESULT 0x800401D2'i32
  CLIPBRD_E_BAD_DATA* = HRESULT 0x800401D3'i32
  CLIPBRD_E_CANT_CLOSE* = HRESULT 0x800401D4'i32
  MK_E_FIRST* = 0x800401E0'i32
  MK_E_LAST* = 0x800401EF'i32
  MK_S_FIRST* = 0x000401E0
  MK_S_LAST* = 0x000401EF
  MK_E_CONNECTMANUALLY* = HRESULT 0x800401E0'i32
  MK_E_EXCEEDEDDEADLINE* = HRESULT 0x800401E1'i32
  MK_E_NEEDGENERIC* = HRESULT 0x800401E2'i32
  MK_E_UNAVAILABLE* = HRESULT 0x800401E3'i32
  MK_E_SYNTAX* = HRESULT 0x800401E4'i32
  MK_E_NOOBJECT* = HRESULT 0x800401E5'i32
  MK_E_INVALIDEXTENSION* = HRESULT 0x800401E6'i32
  MK_E_INTERMEDIATEINTERFACENOTSUPPORTED* = HRESULT 0x800401E7'i32
  MK_E_NOTBINDABLE* = HRESULT 0x800401E8'i32
  MK_E_NOTBOUND* = HRESULT 0x800401E9'i32
  MK_E_CANTOPENFILE* = HRESULT 0x800401EA'i32
  MK_E_MUSTBOTHERUSER* = HRESULT 0x800401EB'i32
  MK_E_NOINVERSE* = HRESULT 0x800401EC'i32
  MK_E_NOSTORAGE* = HRESULT 0x800401ED'i32
  MK_E_NOPREFIX* = HRESULT 0x800401EE'i32
  MK_E_ENUMERATION_FAILED* = HRESULT 0x800401EF'i32
  CO_E_FIRST* = 0x800401F0'i32
  CO_E_LAST* = 0x800401FF'i32
  CO_S_FIRST* = 0x000401F0
  CO_S_LAST* = 0x000401FF
  CO_E_NOTINITIALIZED* = HRESULT 0x800401F0'i32
  CO_E_ALREADYINITIALIZED* = HRESULT 0x800401F1'i32
  CO_E_CANTDETERMINECLASS* = HRESULT 0x800401F2'i32
  CO_E_CLASSSTRING* = HRESULT 0x800401F3'i32
  CO_E_IIDSTRING* = HRESULT 0x800401F4'i32
  CO_E_APPNOTFOUND* = HRESULT 0x800401F5'i32
  CO_E_APPSINGLEUSE* = HRESULT 0x800401F6'i32
  CO_E_ERRORINAPP* = HRESULT 0x800401F7'i32
  CO_E_DLLNOTFOUND* = HRESULT 0x800401F8'i32
  CO_E_ERRORINDLL* = HRESULT 0x800401F9'i32
  CO_E_WRONGOSFORAPP* = HRESULT 0x800401FA'i32
  CO_E_OBJNOTREG* = HRESULT 0x800401FB'i32
  CO_E_OBJISREG* = HRESULT 0x800401FC'i32
  CO_E_OBJNOTCONNECTED* = HRESULT 0x800401FD'i32
  CO_E_APPDIDNTREG* = HRESULT 0x800401FE'i32
  CO_E_RELEASED* = HRESULT 0x800401FF'i32
  EVENT_E_FIRST* = 0x80040200'i32
  EVENT_E_LAST* = 0x8004021F'i32
  EVENT_S_FIRST* = 0x00040200
  EVENT_S_LAST* = 0x0004021F
  EVENT_S_SOME_SUBSCRIBERS_FAILED* = HRESULT 0x00040200
  EVENT_E_ALL_SUBSCRIBERS_FAILED* = HRESULT 0x80040201'i32
  EVENT_S_NOSUBSCRIBERS* = HRESULT 0x00040202
  EVENT_E_QUERYSYNTAX* = HRESULT 0x80040203'i32
  EVENT_E_QUERYFIELD* = HRESULT 0x80040204'i32
  EVENT_E_INTERNALEXCEPTION* = HRESULT 0x80040205'i32
  EVENT_E_INTERNALERROR* = HRESULT 0x80040206'i32
  EVENT_E_INVALID_PER_USER_SID* = HRESULT 0x80040207'i32
  EVENT_E_USER_EXCEPTION* = HRESULT 0x80040208'i32
  EVENT_E_TOO_MANY_METHODS* = HRESULT 0x80040209'i32
  EVENT_E_MISSING_EVENTCLASS* = HRESULT 0x8004020A'i32
  EVENT_E_NOT_ALL_REMOVED* = HRESULT 0x8004020B'i32
  EVENT_E_COMPLUS_NOT_INSTALLED* = HRESULT 0x8004020C'i32
  EVENT_E_CANT_MODIFY_OR_DELETE_UNCONFIGURED_OBJECT* = HRESULT 0x8004020D'i32
  EVENT_E_CANT_MODIFY_OR_DELETE_CONFIGURED_OBJECT* = HRESULT 0x8004020E'i32
  EVENT_E_INVALID_EVENT_CLASS_PARTITION* = HRESULT 0x8004020F'i32
  EVENT_E_PER_USER_SID_NOT_LOGGED_ON* = HRESULT 0x80040210'i32
  XACT_E_FIRST* = 0x8004D000'i32
  XACT_E_LAST* = 0x8004D029'i32
  XACT_S_FIRST* = 0x0004D000
  XACT_S_LAST* = 0x0004D010
  XACT_E_ALREADYOTHERSINGLEPHASE* = HRESULT 0x8004D000'i32
  XACT_E_CANTRETAIN* = HRESULT 0x8004D001'i32
  XACT_E_COMMITFAILED* = HRESULT 0x8004D002'i32
  XACT_E_COMMITPREVENTED* = HRESULT 0x8004D003'i32
  XACT_E_HEURISTICABORT* = HRESULT 0x8004D004'i32
  XACT_E_HEURISTICCOMMIT* = HRESULT 0x8004D005'i32
  XACT_E_HEURISTICDAMAGE* = HRESULT 0x8004D006'i32
  XACT_E_HEURISTICDANGER* = HRESULT 0x8004D007'i32
  XACT_E_ISOLATIONLEVEL* = HRESULT 0x8004D008'i32
  XACT_E_NOASYNC* = HRESULT 0x8004D009'i32
  XACT_E_NOENLIST* = HRESULT 0x8004D00A'i32
  XACT_E_NOISORETAIN* = HRESULT 0x8004D00B'i32
  XACT_E_NORESOURCE* = HRESULT 0x8004D00C'i32
  XACT_E_NOTCURRENT* = HRESULT 0x8004D00D'i32
  XACT_E_NOTRANSACTION* = HRESULT 0x8004D00E'i32
  XACT_E_NOTSUPPORTED* = HRESULT 0x8004D00F'i32
  XACT_E_UNKNOWNRMGRID* = HRESULT 0x8004D010'i32
  XACT_E_WRONGSTATE* = HRESULT 0x8004D011'i32
  XACT_E_WRONGUOW* = HRESULT 0x8004D012'i32
  XACT_E_XTIONEXISTS* = HRESULT 0x8004D013'i32
  XACT_E_NOIMPORTOBJECT* = HRESULT 0x8004D014'i32
  XACT_E_INVALIDCOOKIE* = HRESULT 0x8004D015'i32
  XACT_E_INDOUBT* = HRESULT 0x8004D016'i32
  XACT_E_NOTIMEOUT* = HRESULT 0x8004D017'i32
  XACT_E_ALREADYINPROGRESS* = HRESULT 0x8004D018'i32
  XACT_E_ABORTED* = HRESULT 0x8004D019'i32
  XACT_E_LOGFULL* = HRESULT 0x8004D01A'i32
  XACT_E_TMNOTAVAILABLE* = HRESULT 0x8004D01B'i32
  XACT_E_CONNECTION_DOWN* = HRESULT 0x8004D01C'i32
  XACT_E_CONNECTION_DENIED* = HRESULT 0x8004D01D'i32
  XACT_E_REENLISTTIMEOUT* = HRESULT 0x8004D01E'i32
  XACT_E_TIP_CONNECT_FAILED* = HRESULT 0x8004D01F'i32
  XACT_E_TIP_PROTOCOL_ERROR* = HRESULT 0x8004D020'i32
  XACT_E_TIP_PULL_FAILED* = HRESULT 0x8004D021'i32
  XACT_E_DEST_TMNOTAVAILABLE* = HRESULT 0x8004D022'i32
  XACT_E_TIP_DISABLED* = HRESULT 0x8004D023'i32
  XACT_E_NETWORK_TX_DISABLED* = HRESULT 0x8004D024'i32
  XACT_E_PARTNER_NETWORK_TX_DISABLED* = HRESULT 0x8004D025'i32
  XACT_E_XA_TX_DISABLED* = HRESULT 0x8004D026'i32
  XACT_E_UNABLE_TO_READ_DTC_CONFIG* = HRESULT 0x8004D027'i32
  XACT_E_UNABLE_TO_LOAD_DTC_PROXY* = HRESULT 0x8004D028'i32
  XACT_E_ABORTING* = HRESULT 0x8004D029'i32
  XACT_E_CLERKNOTFOUND* = HRESULT 0x8004D080'i32
  XACT_E_CLERKEXISTS* = HRESULT 0x8004D081'i32
  XACT_E_RECOVERYINPROGRESS* = HRESULT 0x8004D082'i32
  XACT_E_TRANSACTIONCLOSED* = HRESULT 0x8004D083'i32
  XACT_E_INVALIDLSN* = HRESULT 0x8004D084'i32
  XACT_E_REPLAYREQUEST* = HRESULT 0x8004D085'i32
  XACT_S_ASYNC* = HRESULT 0x0004D000
  XACT_S_DEFECT* = HRESULT 0x0004D001
  XACT_S_READONLY* = HRESULT 0x0004D002
  XACT_S_SOMENORETAIN* = HRESULT 0x0004D003
  XACT_S_OKINFORM* = HRESULT 0x0004D004
  XACT_S_MADECHANGESCONTENT* = HRESULT 0x0004D005
  XACT_S_MADECHANGESINFORM* = HRESULT 0x0004D006
  XACT_S_ALLNORETAIN* = HRESULT 0x0004D007
  XACT_S_ABORTING* = HRESULT 0x0004D008
  XACT_S_SINGLEPHASE* = HRESULT 0x0004D009
  XACT_S_LOCALLY_OK* = HRESULT 0x0004D00A
  XACT_S_LASTRESOURCEMANAGER* = HRESULT 0x0004D010
  CONTEXT_E_FIRST* = 0x8004E000'i32
  CONTEXT_E_LAST* = 0x8004E02F'i32
  CONTEXT_S_FIRST* = 0x0004E000
  CONTEXT_S_LAST* = 0x0004E02F
  CONTEXT_E_ABORTED* = HRESULT 0x8004E002'i32
  CONTEXT_E_ABORTING* = HRESULT 0x8004E003'i32
  CONTEXT_E_NOCONTEXT* = HRESULT 0x8004E004'i32
  CONTEXT_E_WOULD_DEADLOCK* = HRESULT 0x8004E005'i32
  CONTEXT_E_SYNCH_TIMEOUT* = HRESULT 0x8004E006'i32
  CONTEXT_E_OLDREF* = HRESULT 0x8004E007'i32
  CONTEXT_E_ROLENOTFOUND* = HRESULT 0x8004E00C'i32
  CONTEXT_E_TMNOTAVAILABLE* = HRESULT 0x8004E00F'i32
  CO_E_ACTIVATIONFAILED* = HRESULT 0x8004E021'i32
  CO_E_ACTIVATIONFAILED_EVENTLOGGED* = HRESULT 0x8004E022'i32
  CO_E_ACTIVATIONFAILED_CATALOGERROR* = HRESULT 0x8004E023'i32
  CO_E_ACTIVATIONFAILED_TIMEOUT* = HRESULT 0x8004E024'i32
  CO_E_INITIALIZATIONFAILED* = HRESULT 0x8004E025'i32
  CONTEXT_E_NOJIT* = HRESULT 0x8004E026'i32
  CONTEXT_E_NOTRANSACTION* = HRESULT 0x8004E027'i32
  CO_E_THREADINGMODEL_CHANGED* = HRESULT 0x8004E028'i32
  CO_E_NOIISINTRINSICS* = HRESULT 0x8004E029'i32
  CO_E_NOCOOKIES* = HRESULT 0x8004E02A'i32
  CO_E_DBERROR* = HRESULT 0x8004E02B'i32
  CO_E_NOTPOOLED* = HRESULT 0x8004E02C'i32
  CO_E_NOTCONSTRUCTED* = HRESULT 0x8004E02D'i32
  CO_E_NOSYNCHRONIZATION* = HRESULT 0x8004E02E'i32
  CO_E_ISOLEVELMISMATCH* = HRESULT 0x8004E02F'i32
  OLE_S_USEREG* = HRESULT 0x00040000
  OLE_S_STATIC* = HRESULT 0x00040001
  OLE_S_MAC_CLIPFORMAT* = HRESULT 0x00040002
  DRAGDROP_S_DROP* = HRESULT 0x00040100
  DRAGDROP_S_CANCEL* = HRESULT 0x00040101
  DRAGDROP_S_USEDEFAULTCURSORS* = HRESULT 0x00040102
  DATA_S_SAMEFORMATETC* = HRESULT 0x00040130
  VIEW_S_ALREADY_FROZEN* = HRESULT 0x00040140
  CACHE_S_FORMATETC_NOTSUPPORTED* = HRESULT 0x00040170
  CACHE_S_SAMECACHE* = HRESULT 0x00040171
  CACHE_S_SOMECACHES_NOTUPDATED* = HRESULT 0x00040172
  OLEOBJ_S_INVALIDVERB* = HRESULT 0x00040180
  OLEOBJ_S_CANNOT_DOVERB_NOW* = HRESULT 0x00040181
  OLEOBJ_S_INVALIDHWND* = HRESULT 0x00040182
  INPLACE_S_TRUNCATED* = HRESULT 0x000401A0
  CONVERT10_S_NO_PRESENTATION* = HRESULT 0x000401C0
  MK_S_REDUCED_TO_SELF* = HRESULT 0x000401E2
  MK_S_ME* = HRESULT 0x000401E4
  MK_S_HIM* = HRESULT 0x000401E5
  MK_S_US* = HRESULT 0x000401E6
  MK_S_MONIKERALREADYREGISTERED* = HRESULT 0x000401E7
  SCHED_S_TASK_READY* = HRESULT 0x00041300
  SCHED_S_TASK_RUNNING* = HRESULT 0x00041301
  SCHED_S_TASK_DISABLED* = HRESULT 0x00041302
  SCHED_S_TASK_HAS_NOT_RUN* = HRESULT 0x00041303
  SCHED_S_TASK_NO_MORE_RUNS* = HRESULT 0x00041304
  SCHED_S_TASK_NOT_SCHEDULED* = HRESULT 0x00041305
  SCHED_S_TASK_TERMINATED* = HRESULT 0x00041306
  SCHED_S_TASK_NO_VALID_TRIGGERS* = HRESULT 0x00041307
  SCHED_S_EVENT_TRIGGER* = HRESULT 0x00041308
  SCHED_E_TRIGGER_NOT_FOUND* = HRESULT 0x80041309'i32
  SCHED_E_TASK_NOT_READY* = HRESULT 0x8004130A'i32
  SCHED_E_TASK_NOT_RUNNING* = HRESULT 0x8004130B'i32
  SCHED_E_SERVICE_NOT_INSTALLED* = HRESULT 0x8004130C'i32
  SCHED_E_CANNOT_OPEN_TASK* = HRESULT 0x8004130D'i32
  SCHED_E_INVALID_TASK* = HRESULT 0x8004130E'i32
  SCHED_E_ACCOUNT_INFORMATION_NOT_SET* = HRESULT 0x8004130F'i32
  SCHED_E_ACCOUNT_NAME_NOT_FOUND* = HRESULT 0x80041310'i32
  SCHED_E_ACCOUNT_DBASE_CORRUPT* = HRESULT 0x80041311'i32
  SCHED_E_NO_SECURITY_SERVICES* = HRESULT 0x80041312'i32
  SCHED_E_UNKNOWN_OBJECT_VERSION* = HRESULT 0x80041313'i32
  SCHED_E_UNSUPPORTED_ACCOUNT_OPTION* = HRESULT 0x80041314'i32
  SCHED_E_SERVICE_NOT_RUNNING* = HRESULT 0x80041315'i32
  CO_E_CLASS_CREATE_FAILED* = HRESULT 0x80080001'i32
  CO_E_SCM_ERROR* = HRESULT 0x80080002'i32
  CO_E_SCM_RPC_FAILURE* = HRESULT 0x80080003'i32
  CO_E_BAD_PATH* = HRESULT 0x80080004'i32
  CO_E_SERVER_EXEC_FAILURE* = HRESULT 0x80080005'i32
  CO_E_OBJSRV_RPC_FAILURE* = HRESULT 0x80080006'i32
  MK_E_NO_NORMALIZED* = HRESULT 0x80080007'i32
  CO_E_SERVER_STOPPING* = HRESULT 0x80080008'i32
  MEM_E_INVALID_ROOT* = HRESULT 0x80080009'i32
  MEM_E_INVALID_LINK* = HRESULT 0x80080010'i32
  MEM_E_INVALID_SIZE* = HRESULT 0x80080011'i32
  CO_S_NOTALLINTERFACES* = HRESULT 0x00080012
  CO_S_MACHINENAMENOTFOUND* = HRESULT 0x00080013
  DISP_E_UNKNOWNINTERFACE* = HRESULT 0x80020001'i32
  DISP_E_MEMBERNOTFOUND* = HRESULT 0x80020003'i32
  DISP_E_PARAMNOTFOUND* = HRESULT 0x80020004'i32
  DISP_E_TYPEMISMATCH* = HRESULT 0x80020005'i32
  DISP_E_UNKNOWNNAME* = HRESULT 0x80020006'i32
  DISP_E_NONAMEDARGS* = HRESULT 0x80020007'i32
  DISP_E_BADVARTYPE* = HRESULT 0x80020008'i32
  DISP_E_EXCEPTION* = HRESULT 0x80020009'i32
  DISP_E_OVERFLOW* = HRESULT 0x8002000A'i32
  DISP_E_BADINDEX* = HRESULT 0x8002000B'i32
  DISP_E_UNKNOWNLCID* = HRESULT 0x8002000C'i32
  DISP_E_ARRAYISLOCKED* = HRESULT 0x8002000D'i32
  DISP_E_BADPARAMCOUNT* = HRESULT 0x8002000E'i32
  DISP_E_PARAMNOTOPTIONAL* = HRESULT 0x8002000F'i32
  DISP_E_BADCALLEE* = HRESULT 0x80020010'i32
  DISP_E_NOTACOLLECTION* = HRESULT 0x80020011'i32
  DISP_E_DIVBYZERO* = HRESULT 0x80020012'i32
  DISP_E_BUFFERTOOSMALL* = HRESULT 0x80020013'i32
  TYPE_E_BUFFERTOOSMALL* = HRESULT 0x80028016'i32
  TYPE_E_FIELDNOTFOUND* = HRESULT 0x80028017'i32
  TYPE_E_INVDATAREAD* = HRESULT 0x80028018'i32
  TYPE_E_UNSUPFORMAT* = HRESULT 0x80028019'i32
  TYPE_E_REGISTRYACCESS* = HRESULT 0x8002801C'i32
  TYPE_E_LIBNOTREGISTERED* = HRESULT 0x8002801D'i32
  TYPE_E_UNDEFINEDTYPE* = HRESULT 0x80028027'i32
  TYPE_E_QUALIFIEDNAMEDISALLOWED* = HRESULT 0x80028028'i32
  TYPE_E_INVALIDSTATE* = HRESULT 0x80028029'i32
  TYPE_E_WRONGTYPEKIND* = HRESULT 0x8002802A'i32
  TYPE_E_ELEMENTNOTFOUND* = HRESULT 0x8002802B'i32
  TYPE_E_AMBIGUOUSNAME* = HRESULT 0x8002802C'i32
  TYPE_E_NAMECONFLICT* = HRESULT 0x8002802D'i32
  TYPE_E_UNKNOWNLCID* = HRESULT 0x8002802E'i32
  TYPE_E_DLLFUNCTIONNOTFOUND* = HRESULT 0x8002802F'i32
  TYPE_E_BADMODULEKIND* = HRESULT 0x800288BD'i32
  TYPE_E_SIZETOOBIG* = HRESULT 0x800288C5'i32
  TYPE_E_DUPLICATEID* = HRESULT 0x800288C6'i32
  TYPE_E_INVALIDID* = HRESULT 0x800288CF'i32
  TYPE_E_TYPEMISMATCH* = HRESULT 0x80028CA0'i32
  TYPE_E_OUTOFBOUNDS* = HRESULT 0x80028CA1'i32
  TYPE_E_IOERROR* = HRESULT 0x80028CA2'i32
  TYPE_E_CANTCREATETMPFILE* = HRESULT 0x80028CA3'i32
  TYPE_E_CANTLOADLIBRARY* = HRESULT 0x80029C4A'i32
  TYPE_E_INCONSISTENTPROPFUNCS* = HRESULT 0x80029C83'i32
  TYPE_E_CIRCULARTYPE* = HRESULT 0x80029C84'i32
  STG_E_INVALIDFUNCTION* = HRESULT 0x80030001'i32
  STG_E_FILENOTFOUND* = HRESULT 0x80030002'i32
  STG_E_PATHNOTFOUND* = HRESULT 0x80030003'i32
  STG_E_TOOMANYOPENFILES* = HRESULT 0x80030004'i32
  STG_E_ACCESSDENIED* = HRESULT 0x80030005'i32
  STG_E_INVALIDHANDLE* = HRESULT 0x80030006'i32
  STG_E_INSUFFICIENTMEMORY* = HRESULT 0x80030008'i32
  STG_E_INVALIDPOINTER* = HRESULT 0x80030009'i32
  STG_E_NOMOREFILES* = HRESULT 0x80030012'i32
  STG_E_DISKISWRITEPROTECTED* = HRESULT 0x80030013'i32
  STG_E_SEEKERROR* = HRESULT 0x80030019'i32
  STG_E_WRITEFAULT* = HRESULT 0x8003001D'i32
  STG_E_READFAULT* = HRESULT 0x8003001E'i32
  STG_E_SHAREVIOLATION* = HRESULT 0x80030020'i32
  STG_E_LOCKVIOLATION* = HRESULT 0x80030021'i32
  STG_E_FILEALREADYEXISTS* = HRESULT 0x80030050'i32
  STG_E_INVALIDPARAMETER* = HRESULT 0x80030057'i32
  STG_E_MEDIUMFULL* = HRESULT 0x80030070'i32
  STG_E_PROPSETMISMATCHED* = HRESULT 0x800300F0'i32
  STG_E_ABNORMALAPIEXIT* = HRESULT 0x800300FA'i32
  STG_E_INVALIDHEADER* = HRESULT 0x800300FB'i32
  STG_E_INVALIDNAME* = HRESULT 0x800300FC'i32
  STG_E_UNKNOWN* = HRESULT 0x800300FD'i32
  STG_E_UNIMPLEMENTEDFUNCTION* = HRESULT 0x800300FE'i32
  STG_E_INVALIDFLAG* = HRESULT 0x800300FF'i32
  STG_E_INUSE* = HRESULT 0x80030100'i32
  STG_E_NOTCURRENT* = HRESULT 0x80030101'i32
  STG_E_REVERTED* = HRESULT 0x80030102'i32
  STG_E_CANTSAVE* = HRESULT 0x80030103'i32
  STG_E_OLDFORMAT* = HRESULT 0x80030104'i32
  STG_E_OLDDLL* = HRESULT 0x80030105'i32
  STG_E_SHAREREQUIRED* = HRESULT 0x80030106'i32
  STG_E_NOTFILEBASEDSTORAGE* = HRESULT 0x80030107'i32
  STG_E_EXTANTMARSHALLINGS* = HRESULT 0x80030108'i32
  STG_E_DOCFILECORRUPT* = HRESULT 0x80030109'i32
  STG_E_BADBASEADDRESS* = HRESULT 0x80030110'i32
  STG_E_DOCFILETOOLARGE* = HRESULT 0x80030111'i32
  STG_E_NOTSIMPLEFORMAT* = HRESULT 0x80030112'i32
  STG_E_INCOMPLETE* = HRESULT 0x80030201'i32
  STG_E_TERMINATED* = HRESULT 0x80030202'i32
  STG_S_CONVERTED* = HRESULT 0x00030200
  STG_S_BLOCK* = HRESULT 0x00030201
  STG_S_RETRYNOW* = HRESULT 0x00030202
  STG_S_MONITORING* = HRESULT 0x00030203
  STG_S_MULTIPLEOPENS* = HRESULT 0x00030204
  STG_S_CONSOLIDATIONFAILED* = HRESULT 0x00030205
  STG_S_CANNOTCONSOLIDATE* = HRESULT 0x00030206
  STG_E_STATUS_COPY_PROTECTION_FAILURE* = HRESULT 0x80030305'i32
  STG_E_CSS_AUTHENTICATION_FAILURE* = HRESULT 0x80030306'i32
  STG_E_CSS_KEY_NOT_PRESENT* = HRESULT 0x80030307'i32
  STG_E_CSS_KEY_NOT_ESTABLISHED* = HRESULT 0x80030308'i32
  STG_E_CSS_SCRAMBLED_SECTOR* = HRESULT 0x80030309'i32
  STG_E_CSS_REGION_MISMATCH* = HRESULT 0x8003030A'i32
  STG_E_RESETS_EXHAUSTED* = HRESULT 0x8003030B'i32
  RPC_E_CALL_REJECTED* = HRESULT 0x80010001'i32
  RPC_E_CALL_CANCELED* = HRESULT 0x80010002'i32
  RPC_E_CANTPOST_INSENDCALL* = HRESULT 0x80010003'i32
  RPC_E_CANTCALLOUT_INASYNCCALL* = HRESULT 0x80010004'i32
  RPC_E_CANTCALLOUT_INEXTERNALCALL* = HRESULT 0x80010005'i32
  RPC_E_CONNECTION_TERMINATED* = HRESULT 0x80010006'i32
  RPC_E_SERVER_DIED* = HRESULT 0x80010007'i32
  RPC_E_CLIENT_DIED* = HRESULT 0x80010008'i32
  RPC_E_INVALID_DATAPACKET* = HRESULT 0x80010009'i32
  RPC_E_CANTTRANSMIT_CALL* = HRESULT 0x8001000A'i32
  RPC_E_CLIENT_CANTMARSHAL_DATA* = HRESULT 0x8001000B'i32
  RPC_E_CLIENT_CANTUNMARSHAL_DATA* = HRESULT 0x8001000C'i32
  RPC_E_SERVER_CANTMARSHAL_DATA* = HRESULT 0x8001000D'i32
  RPC_E_SERVER_CANTUNMARSHAL_DATA* = HRESULT 0x8001000E'i32
  RPC_E_INVALID_DATA* = HRESULT 0x8001000F'i32
  RPC_E_INVALID_PARAMETER* = HRESULT 0x80010010'i32
  RPC_E_CANTCALLOUT_AGAIN* = HRESULT 0x80010011'i32
  RPC_E_SERVER_DIED_DNE* = HRESULT 0x80010012'i32
  RPC_E_SYS_CALL_FAILED* = HRESULT 0x80010100'i32
  RPC_E_OUT_OF_RESOURCES* = HRESULT 0x80010101'i32
  RPC_E_ATTEMPTED_MULTITHREAD* = HRESULT 0x80010102'i32
  RPC_E_NOT_REGISTERED* = HRESULT 0x80010103'i32
  RPC_E_FAULT* = HRESULT 0x80010104'i32
  RPC_E_SERVERFAULT* = HRESULT 0x80010105'i32
  RPC_E_CHANGED_MODE* = HRESULT 0x80010106'i32
  RPC_E_INVALIDMETHOD* = HRESULT 0x80010107'i32
  RPC_E_DISCONNECTED* = HRESULT 0x80010108'i32
  RPC_E_RETRY* = HRESULT 0x80010109'i32
  RPC_E_SERVERCALL_RETRYLATER* = HRESULT 0x8001010A'i32
  RPC_E_SERVERCALL_REJECTED* = HRESULT 0x8001010B'i32
  RPC_E_INVALID_CALLDATA* = HRESULT 0x8001010C'i32
  RPC_E_CANTCALLOUT_ININPUTSYNCCALL* = HRESULT 0x8001010D'i32
  RPC_E_WRONG_THREAD* = HRESULT 0x8001010E'i32
  RPC_E_THREAD_NOT_INIT* = HRESULT 0x8001010F'i32
  RPC_E_VERSION_MISMATCH* = HRESULT 0x80010110'i32
  RPC_E_INVALID_HEADER* = HRESULT 0x80010111'i32
  RPC_E_INVALID_EXTENSION* = HRESULT 0x80010112'i32
  RPC_E_INVALID_IPID* = HRESULT 0x80010113'i32
  RPC_E_INVALID_OBJECT* = HRESULT 0x80010114'i32
  RPC_S_CALLPENDING* = HRESULT 0x80010115'i32
  RPC_S_WAITONTIMER* = HRESULT 0x80010116'i32
  RPC_E_CALL_COMPLETE* = HRESULT 0x80010117'i32
  RPC_E_UNSECURE_CALL* = HRESULT 0x80010118'i32
  RPC_E_TOO_LATE* = HRESULT 0x80010119'i32
  RPC_E_NO_GOOD_SECURITY_PACKAGES* = HRESULT 0x8001011A'i32
  RPC_E_ACCESS_DENIED* = HRESULT 0x8001011B'i32
  RPC_E_REMOTE_DISABLED* = HRESULT 0x8001011C'i32
  RPC_E_INVALID_OBJREF* = HRESULT 0x8001011D'i32
  RPC_E_NO_CONTEXT* = HRESULT 0x8001011E'i32
  RPC_E_TIMEOUT* = HRESULT 0x8001011F'i32
  RPC_E_NO_SYNC* = HRESULT 0x80010120'i32
  RPC_E_FULLSIC_REQUIRED* = HRESULT 0x80010121'i32
  RPC_E_INVALID_STD_NAME* = HRESULT 0x80010122'i32
  CO_E_FAILEDTOIMPERSONATE* = HRESULT 0x80010123'i32
  CO_E_FAILEDTOGETSECCTX* = HRESULT 0x80010124'i32
  CO_E_FAILEDTOOPENTHREADTOKEN* = HRESULT 0x80010125'i32
  CO_E_FAILEDTOGETTOKENINFO* = HRESULT 0x80010126'i32
  CO_E_TRUSTEEDOESNTMATCHCLIENT* = HRESULT 0x80010127'i32
  CO_E_FAILEDTOQUERYCLIENTBLANKET* = HRESULT 0x80010128'i32
  CO_E_FAILEDTOSETDACL* = HRESULT 0x80010129'i32
  CO_E_ACCESSCHECKFAILED* = HRESULT 0x8001012A'i32
  CO_E_NETACCESSAPIFAILED* = HRESULT 0x8001012B'i32
  CO_E_WRONGTRUSTEENAMESYNTAX* = HRESULT 0x8001012C'i32
  CO_E_INVALIDSID* = HRESULT 0x8001012D'i32
  CO_E_CONVERSIONFAILED* = HRESULT 0x8001012E'i32
  CO_E_NOMATCHINGSIDFOUND* = HRESULT 0x8001012F'i32
  CO_E_LOOKUPACCSIDFAILED* = HRESULT 0x80010130'i32
  CO_E_NOMATCHINGNAMEFOUND* = HRESULT 0x80010131'i32
  CO_E_LOOKUPACCNAMEFAILED* = HRESULT 0x80010132'i32
  CO_E_SETSERLHNDLFAILED* = HRESULT 0x80010133'i32
  CO_E_FAILEDTOGETWINDIR* = HRESULT 0x80010134'i32
  CO_E_PATHTOOLONG* = HRESULT 0x80010135'i32
  CO_E_FAILEDTOGENUUID* = HRESULT 0x80010136'i32
  CO_E_FAILEDTOCREATEFILE* = HRESULT 0x80010137'i32
  CO_E_FAILEDTOCLOSEHANDLE* = HRESULT 0x80010138'i32
  CO_E_EXCEEDSYSACLLIMIT* = HRESULT 0x80010139'i32
  CO_E_ACESINWRONGORDER* = HRESULT 0x8001013A'i32
  CO_E_INCOMPATIBLESTREAMVERSION* = HRESULT 0x8001013B'i32
  CO_E_FAILEDTOOPENPROCESSTOKEN* = HRESULT 0x8001013C'i32
  CO_E_DECODEFAILED* = HRESULT 0x8001013D'i32
  CO_E_ACNOTINITIALIZED* = HRESULT 0x8001013F'i32
  CO_E_CANCEL_DISABLED* = HRESULT 0x80010140'i32
  RPC_E_UNEXPECTED* = HRESULT 0x8001FFFF'i32
  ERROR_AUDITING_DISABLED* = HRESULT 0xC0090001'i32
  ERROR_ALL_SIDS_FILTERED* = HRESULT 0xC0090002'i32
  NTE_BAD_UID* = HRESULT 0x80090001'i32
  NTE_BAD_HASH* = HRESULT 0x80090002'i32
  NTE_BAD_KEY* = HRESULT 0x80090003'i32
  NTE_BAD_LEN* = HRESULT 0x80090004'i32
  NTE_BAD_DATA* = HRESULT 0x80090005'i32
  NTE_BAD_SIGNATURE* = HRESULT 0x80090006'i32
  NTE_BAD_VER* = HRESULT 0x80090007'i32
  NTE_BAD_ALGID* = HRESULT 0x80090008'i32
  NTE_BAD_FLAGS* = HRESULT 0x80090009'i32
  NTE_BAD_TYPE* = HRESULT 0x8009000A'i32
  NTE_BAD_KEY_STATE* = HRESULT 0x8009000B'i32
  NTE_BAD_HASH_STATE* = HRESULT 0x8009000C'i32
  NTE_NO_KEY* = HRESULT 0x8009000D'i32
  NTE_NO_MEMORY* = HRESULT 0x8009000E'i32
  NTE_EXISTS* = HRESULT 0x8009000F'i32
  NTE_PERM* = HRESULT 0x80090010'i32
  NTE_NOT_FOUND* = HRESULT 0x80090011'i32
  NTE_DOUBLE_ENCRYPT* = HRESULT 0x80090012'i32
  NTE_BAD_PROVIDER* = HRESULT 0x80090013'i32
  NTE_BAD_PROV_TYPE* = HRESULT 0x80090014'i32
  NTE_BAD_PUBLIC_KEY* = HRESULT 0x80090015'i32
  NTE_BAD_KEYSET* = HRESULT 0x80090016'i32
  NTE_PROV_TYPE_NOT_DEF* = HRESULT 0x80090017'i32
  NTE_PROV_TYPE_ENTRY_BAD* = HRESULT 0x80090018'i32
  NTE_KEYSET_NOT_DEF* = HRESULT 0x80090019'i32
  NTE_KEYSET_ENTRY_BAD* = HRESULT 0x8009001A'i32
  NTE_PROV_TYPE_NO_MATCH* = HRESULT 0x8009001B'i32
  NTE_SIGNATURE_FILE_BAD* = HRESULT 0x8009001C'i32
  NTE_PROVIDER_DLL_FAIL* = HRESULT 0x8009001D'i32
  NTE_PROV_DLL_NOT_FOUND* = HRESULT 0x8009001E'i32
  NTE_BAD_KEYSET_PARAM* = HRESULT 0x8009001F'i32
  NTE_FAIL* = HRESULT 0x80090020'i32
  NTE_SYS_ERR* = HRESULT 0x80090021'i32
  NTE_SILENT_CONTEXT* = HRESULT 0x80090022'i32
  NTE_TOKEN_KEYSET_STORAGE_FULL* = HRESULT 0x80090023'i32
  NTE_TEMPORARY_PROFILE* = HRESULT 0x80090024'i32
  NTE_FIXEDPARAMETER* = HRESULT 0x80090025'i32
  SEC_E_INSUFFICIENT_MEMORY* = HRESULT 0x80090300'i32
  SEC_E_INVALID_HANDLE* = HRESULT 0x80090301'i32
  SEC_E_UNSUPPORTED_FUNCTION* = HRESULT 0x80090302'i32
  SEC_E_TARGET_UNKNOWN* = HRESULT 0x80090303'i32
  SEC_E_INTERNAL_ERROR* = HRESULT 0x80090304'i32
  SEC_E_SECPKG_NOT_FOUND* = HRESULT 0x80090305'i32
  SEC_E_NOT_OWNER* = HRESULT 0x80090306'i32
  SEC_E_CANNOT_INSTALL* = HRESULT 0x80090307'i32
  SEC_E_INVALID_TOKEN* = HRESULT 0x80090308'i32
  SEC_E_CANNOT_PACK* = HRESULT 0x80090309'i32
  SEC_E_QOP_NOT_SUPPORTED* = HRESULT 0x8009030A'i32
  SEC_E_NO_IMPERSONATION* = HRESULT 0x8009030B'i32
  SEC_E_LOGON_DENIED* = HRESULT 0x8009030C'i32
  SEC_E_UNKNOWN_CREDENTIALS* = HRESULT 0x8009030D'i32
  SEC_E_NO_CREDENTIALS* = HRESULT 0x8009030E'i32
  SEC_E_MESSAGE_ALTERED* = HRESULT 0x8009030F'i32
  SEC_E_OUT_OF_SEQUENCE* = HRESULT 0x80090310'i32
  SEC_E_NO_AUTHENTICATING_AUTHORITY* = HRESULT 0x80090311'i32
  SEC_I_CONTINUE_NEEDED* = HRESULT 0x00090312
  SEC_I_COMPLETE_NEEDED* = HRESULT 0x00090313
  SEC_I_COMPLETE_AND_CONTINUE* = HRESULT 0x00090314
  SEC_I_LOCAL_LOGON* = HRESULT 0x00090315
  SEC_E_BAD_PKGID* = HRESULT 0x80090316'i32
  SEC_E_CONTEXT_EXPIRED* = HRESULT 0x80090317'i32
  SEC_I_CONTEXT_EXPIRED* = HRESULT 0x00090317
  SEC_E_INCOMPLETE_MESSAGE* = HRESULT 0x80090318'i32
  SEC_E_INCOMPLETE_CREDENTIALS* = HRESULT 0x80090320'i32
  SEC_E_BUFFER_TOO_SMALL* = HRESULT 0x80090321'i32
  SEC_I_INCOMPLETE_CREDENTIALS* = HRESULT 0x00090320
  SEC_I_RENEGOTIATE* = HRESULT 0x00090321
  SEC_E_WRONG_PRINCIPAL* = HRESULT 0x80090322'i32
  SEC_I_NO_LSA_CONTEXT* = HRESULT 0x00090323
  SEC_E_TIME_SKEW* = HRESULT 0x80090324'i32
  SEC_E_UNTRUSTED_ROOT* = HRESULT 0x80090325'i32
  SEC_E_ILLEGAL_MESSAGE* = HRESULT 0x80090326'i32
  SEC_E_CERT_UNKNOWN* = HRESULT 0x80090327'i32
  SEC_E_CERT_EXPIRED* = HRESULT 0x80090328'i32
  SEC_E_ENCRYPT_FAILURE* = HRESULT 0x80090329'i32
  SEC_E_DECRYPT_FAILURE* = HRESULT 0x80090330'i32
  SEC_E_ALGORITHM_MISMATCH* = HRESULT 0x80090331'i32
  SEC_E_SECURITY_QOS_FAILED* = HRESULT 0x80090332'i32
  SEC_E_UNFINISHED_CONTEXT_DELETED* = HRESULT 0x80090333'i32
  SEC_E_NO_TGT_REPLY* = HRESULT 0x80090334'i32
  SEC_E_NO_IP_ADDRESSES* = HRESULT 0x80090335'i32
  SEC_E_WRONG_CREDENTIAL_HANDLE* = HRESULT 0x80090336'i32
  SEC_E_CRYPTO_SYSTEM_INVALID* = HRESULT 0x80090337'i32
  SEC_E_MAX_REFERRALS_EXCEEDED* = HRESULT 0x80090338'i32
  SEC_E_MUST_BE_KDC* = HRESULT 0x80090339'i32
  SEC_E_STRONG_CRYPTO_NOT_SUPPORTED* = HRESULT 0x8009033A'i32
  SEC_E_TOO_MANY_PRINCIPALS* = HRESULT 0x8009033B'i32
  SEC_E_NO_PA_DATA* = HRESULT 0x8009033C'i32
  SEC_E_PKINIT_NAME_MISMATCH* = HRESULT 0x8009033D'i32
  SEC_E_SMARTCARD_LOGON_REQUIRED* = HRESULT 0x8009033E'i32
  SEC_E_SHUTDOWN_IN_PROGRESS* = HRESULT 0x8009033F'i32
  SEC_E_KDC_INVALID_REQUEST* = HRESULT 0x80090340'i32
  SEC_E_KDC_UNABLE_TO_REFER* = HRESULT 0x80090341'i32
  SEC_E_KDC_UNKNOWN_ETYPE* = HRESULT 0x80090342'i32
  SEC_E_UNSUPPORTED_PREAUTH* = HRESULT 0x80090343'i32
  SEC_E_DELEGATION_REQUIRED* = HRESULT 0x80090345'i32
  SEC_E_BAD_BINDINGS* = HRESULT 0x80090346'i32
  SEC_E_MULTIPLE_ACCOUNTS* = HRESULT 0x80090347'i32
  SEC_E_NO_KERB_KEY* = HRESULT 0x80090348'i32
  SEC_E_CERT_WRONG_USAGE* = HRESULT 0x80090349'i32
  SEC_E_DOWNGRADE_DETECTED* = HRESULT 0x80090350'i32
  SEC_E_SMARTCARD_CERT_REVOKED* = HRESULT 0x80090351'i32
  SEC_E_ISSUING_CA_UNTRUSTED* = HRESULT 0x80090352'i32
  SEC_E_REVOCATION_OFFLINE_C* = HRESULT 0x80090353'i32
  SEC_E_PKINIT_CLIENT_FAILURE* = HRESULT 0x80090354'i32
  SEC_E_SMARTCARD_CERT_EXPIRED* = HRESULT 0x80090355'i32
  SEC_E_NO_S4U_PROT_SUPPORT* = HRESULT 0x80090356'i32
  SEC_E_CROSSREALM_DELEGATION_FAILURE* = HRESULT 0x80090357'i32
  SEC_E_REVOCATION_OFFLINE_KDC* = HRESULT 0x80090358'i32
  SEC_E_ISSUING_CA_UNTRUSTED_KDC* = HRESULT 0x80090359'i32
  SEC_E_KDC_CERT_EXPIRED* = HRESULT 0x8009035A'i32
  SEC_E_KDC_CERT_REVOKED* = HRESULT 0x8009035B'i32
  SEC_E_NO_SPM* = SEC_E_INTERNAL_ERROR
  SEC_E_NOT_SUPPORTED* = SEC_E_UNSUPPORTED_FUNCTION
  CRYPT_E_MSG_ERROR* = HRESULT 0x80091001'i32
  CRYPT_E_UNKNOWN_ALGO* = HRESULT 0x80091002'i32
  CRYPT_E_OID_FORMAT* = HRESULT 0x80091003'i32
  CRYPT_E_INVALID_MSG_TYPE* = HRESULT 0x80091004'i32
  CRYPT_E_UNEXPECTED_ENCODING* = HRESULT 0x80091005'i32
  CRYPT_E_AUTH_ATTR_MISSING* = HRESULT 0x80091006'i32
  CRYPT_E_HASH_VALUE* = HRESULT 0x80091007'i32
  CRYPT_E_INVALID_INDEX* = HRESULT 0x80091008'i32
  CRYPT_E_ALREADY_DECRYPTED* = HRESULT 0x80091009'i32
  CRYPT_E_NOT_DECRYPTED* = HRESULT 0x8009100A'i32
  CRYPT_E_RECIPIENT_NOT_FOUND* = HRESULT 0x8009100B'i32
  CRYPT_E_CONTROL_TYPE* = HRESULT 0x8009100C'i32
  CRYPT_E_ISSUER_SERIALNUMBER* = HRESULT 0x8009100D'i32
  CRYPT_E_SIGNER_NOT_FOUND* = HRESULT 0x8009100E'i32
  CRYPT_E_ATTRIBUTES_MISSING* = HRESULT 0x8009100F'i32
  CRYPT_E_STREAM_MSG_NOT_READY* = HRESULT 0x80091010'i32
  CRYPT_E_STREAM_INSUFFICIENT_DATA* = HRESULT 0x80091011'i32
  CRYPT_I_NEW_PROTECTION_REQUIRED* = HRESULT 0x00091012
  CRYPT_E_BAD_LEN* = HRESULT 0x80092001'i32
  CRYPT_E_BAD_ENCODE* = HRESULT 0x80092002'i32
  CRYPT_E_FILE_ERROR* = HRESULT 0x80092003'i32
  CRYPT_E_NOT_FOUND* = HRESULT 0x80092004'i32
  CRYPT_E_EXISTS* = HRESULT 0x80092005'i32
  CRYPT_E_NO_PROVIDER* = HRESULT 0x80092006'i32
  CRYPT_E_SELF_SIGNED* = HRESULT 0x80092007'i32
  CRYPT_E_DELETED_PREV* = HRESULT 0x80092008'i32
  CRYPT_E_NO_MATCH* = HRESULT 0x80092009'i32
  CRYPT_E_UNEXPECTED_MSG_TYPE* = HRESULT 0x8009200A'i32
  CRYPT_E_NO_KEY_PROPERTY* = HRESULT 0x8009200B'i32
  CRYPT_E_NO_DECRYPT_CERT* = HRESULT 0x8009200C'i32
  CRYPT_E_BAD_MSG* = HRESULT 0x8009200D'i32
  CRYPT_E_NO_SIGNER* = HRESULT 0x8009200E'i32
  CRYPT_E_PENDING_CLOSE* = HRESULT 0x8009200F'i32
  CRYPT_E_REVOKED* = HRESULT 0x80092010'i32
  CRYPT_E_NO_REVOCATION_DLL* = HRESULT 0x80092011'i32
  CRYPT_E_NO_REVOCATION_CHECK* = HRESULT 0x80092012'i32
  CRYPT_E_REVOCATION_OFFLINE* = HRESULT 0x80092013'i32
  CRYPT_E_NOT_IN_REVOCATION_DATABASE* = HRESULT 0x80092014'i32
  CRYPT_E_INVALID_NUMERIC_STRING* = HRESULT 0x80092020'i32
  CRYPT_E_INVALID_PRINTABLE_STRING* = HRESULT 0x80092021'i32
  CRYPT_E_INVALID_IA5_STRING* = HRESULT 0x80092022'i32
  CRYPT_E_INVALID_X500_STRING* = HRESULT 0x80092023'i32
  CRYPT_E_NOT_CHAR_STRING* = HRESULT 0x80092024'i32
  CRYPT_E_FILERESIZED* = HRESULT 0x80092025'i32
  CRYPT_E_SECURITY_SETTINGS* = HRESULT 0x80092026'i32
  CRYPT_E_NO_VERIFY_USAGE_DLL* = HRESULT 0x80092027'i32
  CRYPT_E_NO_VERIFY_USAGE_CHECK* = HRESULT 0x80092028'i32
  CRYPT_E_VERIFY_USAGE_OFFLINE* = HRESULT 0x80092029'i32
  CRYPT_E_NOT_IN_CTL* = HRESULT 0x8009202A'i32
  CRYPT_E_NO_TRUSTED_SIGNER* = HRESULT 0x8009202B'i32
  CRYPT_E_MISSING_PUBKEY_PARA* = HRESULT 0x8009202C'i32
  CRYPT_E_OSS_ERROR* = HRESULT 0x80093000'i32
  OSS_MORE_BUF* = HRESULT 0x80093001'i32
  OSS_NEGATIVE_UINTEGER* = HRESULT 0x80093002'i32
  OSS_PDU_RANGE* = HRESULT 0x80093003'i32
  OSS_MORE_INPUT* = HRESULT 0x80093004'i32
  OSS_DATA_ERROR* = HRESULT 0x80093005'i32
  OSS_BAD_ARG* = HRESULT 0x80093006'i32
  OSS_BAD_VERSION* = HRESULT 0x80093007'i32
  OSS_OUT_MEMORY* = HRESULT 0x80093008'i32
  OSS_PDU_MISMATCH* = HRESULT 0x80093009'i32
  OSS_LIMITED* = HRESULT 0x8009300A'i32
  OSS_BAD_PTR* = HRESULT 0x8009300B'i32
  OSS_BAD_TIME* = HRESULT 0x8009300C'i32
  OSS_INDEFINITE_NOT_SUPPORTED* = HRESULT 0x8009300D'i32
  OSS_MEM_ERROR* = HRESULT 0x8009300E'i32
  OSS_BAD_TABLE* = HRESULT 0x8009300F'i32
  OSS_TOO_LONG* = HRESULT 0x80093010'i32
  OSS_CONSTRAINT_VIOLATED* = HRESULT 0x80093011'i32
  OSS_FATAL_ERROR* = HRESULT 0x80093012'i32
  OSS_ACCESS_SERIALIZATION_ERROR* = HRESULT 0x80093013'i32
  OSS_NULL_TBL* = HRESULT 0x80093014'i32
  OSS_NULL_FCN* = HRESULT 0x80093015'i32
  OSS_BAD_ENCRULES* = HRESULT 0x80093016'i32
  OSS_UNAVAIL_ENCRULES* = HRESULT 0x80093017'i32
  OSS_CANT_OPEN_TRACE_WINDOW* = HRESULT 0x80093018'i32
  OSS_UNIMPLEMENTED* = HRESULT 0x80093019'i32
  OSS_OID_DLL_NOT_LINKED* = HRESULT 0x8009301A'i32
  OSS_CANT_OPEN_TRACE_FILE* = HRESULT 0x8009301B'i32
  OSS_TRACE_FILE_ALREADY_OPEN* = HRESULT 0x8009301C'i32
  OSS_TABLE_MISMATCH* = HRESULT 0x8009301D'i32
  OSS_TYPE_NOT_SUPPORTED* = HRESULT 0x8009301E'i32
  OSS_REAL_DLL_NOT_LINKED* = HRESULT 0x8009301F'i32
  OSS_REAL_CODE_NOT_LINKED* = HRESULT 0x80093020'i32
  OSS_OUT_OF_RANGE* = HRESULT 0x80093021'i32
  OSS_COPIER_DLL_NOT_LINKED* = HRESULT 0x80093022'i32
  OSS_CONSTRAINT_DLL_NOT_LINKED* = HRESULT 0x80093023'i32
  OSS_COMPARATOR_DLL_NOT_LINKED* = HRESULT 0x80093024'i32
  OSS_COMPARATOR_CODE_NOT_LINKED* = HRESULT 0x80093025'i32
  OSS_MEM_MGR_DLL_NOT_LINKED* = HRESULT 0x80093026'i32
  OSS_PDV_DLL_NOT_LINKED* = HRESULT 0x80093027'i32
  OSS_PDV_CODE_NOT_LINKED* = HRESULT 0x80093028'i32
  OSS_API_DLL_NOT_LINKED* = HRESULT 0x80093029'i32
  OSS_BERDER_DLL_NOT_LINKED* = HRESULT 0x8009302A'i32
  OSS_PER_DLL_NOT_LINKED* = HRESULT 0x8009302B'i32
  OSS_OPEN_TYPE_ERROR* = HRESULT 0x8009302C'i32
  OSS_MUTEX_NOT_CREATED* = HRESULT 0x8009302D'i32
  OSS_CANT_CLOSE_TRACE_FILE* = HRESULT 0x8009302E'i32
  CRYPT_E_ASN1_ERROR* = HRESULT 0x80093100'i32
  CRYPT_E_ASN1_INTERNAL* = HRESULT 0x80093101'i32
  CRYPT_E_ASN1_EOD* = HRESULT 0x80093102'i32
  CRYPT_E_ASN1_CORRUPT* = HRESULT 0x80093103'i32
  CRYPT_E_ASN1_LARGE* = HRESULT 0x80093104'i32
  CRYPT_E_ASN1_CONSTRAINT* = HRESULT 0x80093105'i32
  CRYPT_E_ASN1_MEMORY* = HRESULT 0x80093106'i32
  CRYPT_E_ASN1_OVERFLOW* = HRESULT 0x80093107'i32
  CRYPT_E_ASN1_BADPDU* = HRESULT 0x80093108'i32
  CRYPT_E_ASN1_BADARGS* = HRESULT 0x80093109'i32
  CRYPT_E_ASN1_BADREAL* = HRESULT 0x8009310A'i32
  CRYPT_E_ASN1_BADTAG* = HRESULT 0x8009310B'i32
  CRYPT_E_ASN1_CHOICE* = HRESULT 0x8009310C'i32
  CRYPT_E_ASN1_RULE* = HRESULT 0x8009310D'i32
  CRYPT_E_ASN1_UTF8* = HRESULT 0x8009310E'i32
  CRYPT_E_ASN1_PDU_TYPE* = HRESULT 0x80093133'i32
  CRYPT_E_ASN1_NYI* = HRESULT 0x80093134'i32
  CRYPT_E_ASN1_EXTENDED* = HRESULT 0x80093201'i32
  CRYPT_E_ASN1_NOEOD* = HRESULT 0x80093202'i32
  CERTSRV_E_BAD_REQUESTSUBJECT* = HRESULT 0x80094001'i32
  CERTSRV_E_NO_REQUEST* = HRESULT 0x80094002'i32
  CERTSRV_E_BAD_REQUESTSTATUS* = HRESULT 0x80094003'i32
  CERTSRV_E_PROPERTY_EMPTY* = HRESULT 0x80094004'i32
  CERTSRV_E_INVALID_CA_CERTIFICATE* = HRESULT 0x80094005'i32
  CERTSRV_E_SERVER_SUSPENDED* = HRESULT 0x80094006'i32
  CERTSRV_E_ENCODING_LENGTH* = HRESULT 0x80094007'i32
  CERTSRV_E_ROLECONFLICT* = HRESULT 0x80094008'i32
  CERTSRV_E_RESTRICTEDOFFICER* = HRESULT 0x80094009'i32
  CERTSRV_E_KEY_ARCHIVAL_NOT_CONFIGURED* = HRESULT 0x8009400A'i32
  CERTSRV_E_NO_VALID_KRA* = HRESULT 0x8009400B'i32
  CERTSRV_E_BAD_REQUEST_KEY_ARCHIVAL* = HRESULT 0x8009400C'i32
  CERTSRV_E_NO_CAADMIN_DEFINED* = HRESULT 0x8009400D'i32
  CERTSRV_E_BAD_RENEWAL_CERT_ATTRIBUTE* = HRESULT 0x8009400E'i32
  CERTSRV_E_NO_DB_SESSIONS* = HRESULT 0x8009400F'i32
  CERTSRV_E_ALIGNMENT_FAULT* = HRESULT 0x80094010'i32
  CERTSRV_E_ENROLL_DENIED* = HRESULT 0x80094011'i32
  CERTSRV_E_TEMPLATE_DENIED* = HRESULT 0x80094012'i32
  CERTSRV_E_DOWNLEVEL_DC_SSL_OR_UPGRADE* = HRESULT 0x80094013'i32
  CERTSRV_E_UNSUPPORTED_CERT_TYPE* = HRESULT 0x80094800'i32
  CERTSRV_E_NO_CERT_TYPE* = HRESULT 0x80094801'i32
  CERTSRV_E_TEMPLATE_CONFLICT* = HRESULT 0x80094802'i32
  CERTSRV_E_SUBJECT_ALT_NAME_REQUIRED* = HRESULT 0x80094803'i32
  CERTSRV_E_ARCHIVED_KEY_REQUIRED* = HRESULT 0x80094804'i32
  CERTSRV_E_SMIME_REQUIRED* = HRESULT 0x80094805'i32
  CERTSRV_E_BAD_RENEWAL_SUBJECT* = HRESULT 0x80094806'i32
  CERTSRV_E_BAD_TEMPLATE_VERSION* = HRESULT 0x80094807'i32
  CERTSRV_E_TEMPLATE_POLICY_REQUIRED* = HRESULT 0x80094808'i32
  CERTSRV_E_SIGNATURE_POLICY_REQUIRED* = HRESULT 0x80094809'i32
  CERTSRV_E_SIGNATURE_COUNT* = HRESULT 0x8009480A'i32
  CERTSRV_E_SIGNATURE_REJECTED* = HRESULT 0x8009480B'i32
  CERTSRV_E_ISSUANCE_POLICY_REQUIRED* = HRESULT 0x8009480C'i32
  CERTSRV_E_SUBJECT_UPN_REQUIRED* = HRESULT 0x8009480D'i32
  CERTSRV_E_SUBJECT_DIRECTORY_GUID_REQUIRED* = HRESULT 0x8009480E'i32
  CERTSRV_E_SUBJECT_DNS_REQUIRED* = HRESULT 0x8009480F'i32
  CERTSRV_E_ARCHIVED_KEY_UNEXPECTED* = HRESULT 0x80094810'i32
  CERTSRV_E_KEY_LENGTH* = HRESULT 0x80094811'i32
  CERTSRV_E_SUBJECT_EMAIL_REQUIRED* = HRESULT 0x80094812'i32
  CERTSRV_E_UNKNOWN_CERT_TYPE* = HRESULT 0x80094813'i32
  CERTSRV_E_CERT_TYPE_OVERLAP* = HRESULT 0x80094814'i32
  XENROLL_E_KEY_NOT_EXPORTABLE* = HRESULT 0x80095000'i32
  XENROLL_E_CANNOT_ADD_ROOT_CERT* = HRESULT 0x80095001'i32
  XENROLL_E_RESPONSE_KA_HASH_NOT_FOUND* = HRESULT 0x80095002'i32
  XENROLL_E_RESPONSE_UNEXPECTED_KA_HASH* = HRESULT 0x80095003'i32
  XENROLL_E_RESPONSE_KA_HASH_MISMATCH* = HRESULT 0x80095004'i32
  XENROLL_E_KEYSPEC_SMIME_MISMATCH* = HRESULT 0x80095005'i32
  TRUST_E_SYSTEM_ERROR* = HRESULT 0x80096001'i32
  TRUST_E_NO_SIGNER_CERT* = HRESULT 0x80096002'i32
  TRUST_E_COUNTER_SIGNER* = HRESULT 0x80096003'i32
  TRUST_E_CERT_SIGNATURE* = HRESULT 0x80096004'i32
  TRUST_E_TIME_STAMP* = HRESULT 0x80096005'i32
  TRUST_E_BAD_DIGEST* = HRESULT 0x80096010'i32
  TRUST_E_BASIC_CONSTRAINTS* = HRESULT 0x80096019'i32
  TRUST_E_FINANCIAL_CRITERIA* = HRESULT 0x8009601E'i32
  MSSIPOTF_E_OUTOFMEMRANGE* = HRESULT 0x80097001'i32
  MSSIPOTF_E_CANTGETOBJECT* = HRESULT 0x80097002'i32
  MSSIPOTF_E_NOHEADTABLE* = HRESULT 0x80097003'i32
  MSSIPOTF_E_BAD_MAGICNUMBER* = HRESULT 0x80097004'i32
  MSSIPOTF_E_BAD_OFFSET_TABLE* = HRESULT 0x80097005'i32
  MSSIPOTF_E_TABLE_TAGORDER* = HRESULT 0x80097006'i32
  MSSIPOTF_E_TABLE_LONGWORD* = HRESULT 0x80097007'i32
  MSSIPOTF_E_BAD_FIRST_TABLE_PLACEMENT* = HRESULT 0x80097008'i32
  MSSIPOTF_E_TABLES_OVERLAP* = HRESULT 0x80097009'i32
  MSSIPOTF_E_TABLE_PADBYTES* = HRESULT 0x8009700A'i32
  MSSIPOTF_E_FILETOOSMALL* = HRESULT 0x8009700B'i32
  MSSIPOTF_E_TABLE_CHECKSUM* = HRESULT 0x8009700C'i32
  MSSIPOTF_E_FILE_CHECKSUM* = HRESULT 0x8009700D'i32
  MSSIPOTF_E_FAILED_POLICY* = HRESULT 0x80097010'i32
  MSSIPOTF_E_FAILED_HINTS_CHECK* = HRESULT 0x80097011'i32
  MSSIPOTF_E_NOT_OPENTYPE* = HRESULT 0x80097012'i32
  MSSIPOTF_E_FILE* = HRESULT 0x80097013'i32
  MSSIPOTF_E_CRYPT* = HRESULT 0x80097014'i32
  MSSIPOTF_E_BADVERSION* = HRESULT 0x80097015'i32
  MSSIPOTF_E_DSIG_STRUCTURE* = HRESULT 0x80097016'i32
  MSSIPOTF_E_PCONST_CHECK* = HRESULT 0x80097017'i32
  MSSIPOTF_E_STRUCTURE* = HRESULT 0x80097018'i32
  NTE_OP_OK* = 0
  TRUST_E_PROVIDER_UNKNOWN* = HRESULT 0x800B0001'i32
  TRUST_E_ACTION_UNKNOWN* = HRESULT 0x800B0002'i32
  TRUST_E_SUBJECT_FORM_UNKNOWN* = HRESULT 0x800B0003'i32
  TRUST_E_SUBJECT_NOT_TRUSTED* = HRESULT 0x800B0004'i32
  DIGSIG_E_ENCODE* = HRESULT 0x800B0005'i32
  DIGSIG_E_DECODE* = HRESULT 0x800B0006'i32
  DIGSIG_E_EXTENSIBILITY* = HRESULT 0x800B0007'i32
  DIGSIG_E_CRYPTO* = HRESULT 0x800B0008'i32
  PERSIST_E_SIZEDEFINITE* = HRESULT 0x800B0009'i32
  PERSIST_E_SIZEINDEFINITE* = HRESULT 0x800B000A'i32
  PERSIST_E_NOTSELFSIZING* = HRESULT 0x800B000B'i32
  TRUST_E_NOSIGNATURE* = HRESULT 0x800B0100'i32
  CERT_E_EXPIRED* = HRESULT 0x800B0101'i32
  CERT_E_VALIDITYPERIODNESTING* = HRESULT 0x800B0102'i32
  CERT_E_ROLE* = HRESULT 0x800B0103'i32
  CERT_E_PATHLENCONST* = HRESULT 0x800B0104'i32
  CERT_E_CRITICAL* = HRESULT 0x800B0105'i32
  CERT_E_PURPOSE* = HRESULT 0x800B0106'i32
  CERT_E_ISSUERCHAINING* = HRESULT 0x800B0107'i32
  CERT_E_MALFORMED* = HRESULT 0x800B0108'i32
  CERT_E_UNTRUSTEDROOT* = HRESULT 0x800B0109'i32
  CERT_E_CHAINING* = HRESULT 0x800B010A'i32
  TRUST_E_FAIL* = HRESULT 0x800B010B'i32
  CERT_E_REVOKED* = HRESULT 0x800B010C'i32
  CERT_E_UNTRUSTEDTESTROOT* = HRESULT 0x800B010D'i32
  CERT_E_REVOCATION_FAILURE* = HRESULT 0x800B010E'i32
  CERT_E_CN_NO_MATCH* = HRESULT 0x800B010F'i32
  CERT_E_WRONG_USAGE* = HRESULT 0x800B0110'i32
  TRUST_E_EXPLICIT_DISTRUST* = HRESULT 0x800B0111'i32
  CERT_E_UNTRUSTEDCA* = HRESULT 0x800B0112'i32
  CERT_E_INVALID_POLICY* = HRESULT 0x800B0113'i32
  CERT_E_INVALID_NAME* = HRESULT 0x800B0114'i32
  SPAPI_E_EXPECTED_SECTION_NAME* = HRESULT 0x800F0000'i32
  SPAPI_E_BAD_SECTION_NAME_LINE* = HRESULT 0x800F0001'i32
  SPAPI_E_SECTION_NAME_TOO_LONG* = HRESULT 0x800F0002'i32
  SPAPI_E_GENERAL_SYNTAX* = HRESULT 0x800F0003'i32
  SPAPI_E_WRONG_INF_STYLE* = HRESULT 0x800F0100'i32
  SPAPI_E_SECTION_NOT_FOUND* = HRESULT 0x800F0101'i32
  SPAPI_E_LINE_NOT_FOUND* = HRESULT 0x800F0102'i32
  SPAPI_E_NO_BACKUP* = HRESULT 0x800F0103'i32
  SPAPI_E_NO_ASSOCIATED_CLASS* = HRESULT 0x800F0200'i32
  SPAPI_E_CLASS_MISMATCH* = HRESULT 0x800F0201'i32
  SPAPI_E_DUPLICATE_FOUND* = HRESULT 0x800F0202'i32
  SPAPI_E_NO_DRIVER_SELECTED* = HRESULT 0x800F0203'i32
  SPAPI_E_KEY_DOES_NOT_EXIST* = HRESULT 0x800F0204'i32
  SPAPI_E_INVALID_DEVINST_NAME* = HRESULT 0x800F0205'i32
  SPAPI_E_INVALID_CLASS* = HRESULT 0x800F0206'i32
  SPAPI_E_DEVINST_ALREADY_EXISTS* = HRESULT 0x800F0207'i32
  SPAPI_E_DEVINFO_NOT_REGISTERED* = HRESULT 0x800F0208'i32
  SPAPI_E_INVALID_REG_PROPERTY* = HRESULT 0x800F0209'i32
  SPAPI_E_NO_INF* = HRESULT 0x800F020A'i32
  SPAPI_E_NO_SUCH_DEVINST* = HRESULT 0x800F020B'i32
  SPAPI_E_CANT_LOAD_CLASS_ICON* = HRESULT 0x800F020C'i32
  SPAPI_E_INVALID_CLASS_INSTALLER* = HRESULT 0x800F020D'i32
  SPAPI_E_DI_DO_DEFAULT* = HRESULT 0x800F020E'i32
  SPAPI_E_DI_NOFILECOPY* = HRESULT 0x800F020F'i32
  SPAPI_E_INVALID_HWPROFILE* = HRESULT 0x800F0210'i32
  SPAPI_E_NO_DEVICE_SELECTED* = HRESULT 0x800F0211'i32
  SPAPI_E_DEVINFO_LIST_LOCKED* = HRESULT 0x800F0212'i32
  SPAPI_E_DEVINFO_DATA_LOCKED* = HRESULT 0x800F0213'i32
  SPAPI_E_DI_BAD_PATH* = HRESULT 0x800F0214'i32
  SPAPI_E_NO_CLASSINSTALL_PARAMS* = HRESULT 0x800F0215'i32
  SPAPI_E_FILEQUEUE_LOCKED* = HRESULT 0x800F0216'i32
  SPAPI_E_BAD_SERVICE_INSTALLSECT* = HRESULT 0x800F0217'i32
  SPAPI_E_NO_CLASS_DRIVER_LIST* = HRESULT 0x800F0218'i32
  SPAPI_E_NO_ASSOCIATED_SERVICE* = HRESULT 0x800F0219'i32
  SPAPI_E_NO_DEFAULT_DEVICE_INTERFACE* = HRESULT 0x800F021A'i32
  SPAPI_E_DEVICE_INTERFACE_ACTIVE* = HRESULT 0x800F021B'i32
  SPAPI_E_DEVICE_INTERFACE_REMOVED* = HRESULT 0x800F021C'i32
  SPAPI_E_BAD_INTERFACE_INSTALLSECT* = HRESULT 0x800F021D'i32
  SPAPI_E_NO_SUCH_INTERFACE_CLASS* = HRESULT 0x800F021E'i32
  SPAPI_E_INVALID_REFERENCE_STRING* = HRESULT 0x800F021F'i32
  SPAPI_E_INVALID_MACHINENAME* = HRESULT 0x800F0220'i32
  SPAPI_E_REMOTE_COMM_FAILURE* = HRESULT 0x800F0221'i32
  SPAPI_E_MACHINE_UNAVAILABLE* = HRESULT 0x800F0222'i32
  SPAPI_E_NO_CONFIGMGR_SERVICES* = HRESULT 0x800F0223'i32
  SPAPI_E_INVALID_PROPPAGE_PROVIDER* = HRESULT 0x800F0224'i32
  SPAPI_E_NO_SUCH_DEVICE_INTERFACE* = HRESULT 0x800F0225'i32
  SPAPI_E_DI_POSTPROCESSING_REQUIRED* = HRESULT 0x800F0226'i32
  SPAPI_E_INVALID_COINSTALLER* = HRESULT 0x800F0227'i32
  SPAPI_E_NO_COMPAT_DRIVERS* = HRESULT 0x800F0228'i32
  SPAPI_E_NO_DEVICE_ICON* = HRESULT 0x800F0229'i32
  SPAPI_E_INVALID_INF_LOGCONFIG* = HRESULT 0x800F022A'i32
  SPAPI_E_DI_DONT_INSTALL* = HRESULT 0x800F022B'i32
  SPAPI_E_INVALID_FILTER_DRIVER* = HRESULT 0x800F022C'i32
  SPAPI_E_NON_WINDOWS_NT_DRIVER* = HRESULT 0x800F022D'i32
  SPAPI_E_NON_WINDOWS_DRIVER* = HRESULT 0x800F022E'i32
  SPAPI_E_NO_CATALOG_FOR_OEM_INF* = HRESULT 0x800F022F'i32
  SPAPI_E_DEVINSTALL_QUEUE_NONNATIVE* = HRESULT 0x800F0230'i32
  SPAPI_E_NOT_DISABLEABLE* = HRESULT 0x800F0231'i32
  SPAPI_E_CANT_REMOVE_DEVINST* = HRESULT 0x800F0232'i32
  SPAPI_E_INVALID_TARGET* = HRESULT 0x800F0233'i32
  SPAPI_E_DRIVER_NONNATIVE* = HRESULT 0x800F0234'i32
  SPAPI_E_IN_WOW64* = HRESULT 0x800F0235'i32
  SPAPI_E_SET_SYSTEM_RESTORE_POINT* = HRESULT 0x800F0236'i32
  SPAPI_E_INCORRECTLY_COPIED_INF* = HRESULT 0x800F0237'i32
  SPAPI_E_SCE_DISABLED* = HRESULT 0x800F0238'i32
  SPAPI_E_UNKNOWN_EXCEPTION* = HRESULT 0x800F0239'i32
  SPAPI_E_PNP_REGISTRY_ERROR* = HRESULT 0x800F023A'i32
  SPAPI_E_REMOTE_REQUEST_UNSUPPORTED* = HRESULT 0x800F023B'i32
  SPAPI_E_NOT_AN_INSTALLED_OEM_INF* = HRESULT 0x800F023C'i32
  SPAPI_E_INF_IN_USE_BY_DEVICES* = HRESULT 0x800F023D'i32
  SPAPI_E_DI_FUNCTION_OBSOLETE* = HRESULT 0x800F023E'i32
  SPAPI_E_NO_AUTHENTICODE_CATALOG* = HRESULT 0x800F023F'i32
  SPAPI_E_AUTHENTICODE_DISALLOWED* = HRESULT 0x800F0240'i32
  SPAPI_E_AUTHENTICODE_TRUSTED_PUBLISHER* = HRESULT 0x800F0241'i32
  SPAPI_E_AUTHENTICODE_TRUST_NOT_ESTABLISHED* = HRESULT 0x800F0242'i32
  SPAPI_E_AUTHENTICODE_PUBLISHER_NOT_TRUSTED* = HRESULT 0x800F0243'i32
  SPAPI_E_SIGNATURE_OSATTRIBUTE_MISMATCH* = HRESULT 0x800F0244'i32
  SPAPI_E_ONLY_VALIDATE_VIA_AUTHENTICODE* = HRESULT 0x800F0245'i32
  SPAPI_E_UNRECOVERABLE_STACK_OVERFLOW* = HRESULT 0x800F0300'i32
  SPAPI_E_ERROR_NOT_INSTALLED* = HRESULT 0x800F1000'i32
  SCARD_S_SUCCESS* = NO_ERROR
  SCARD_F_INTERNAL_ERROR* = HRESULT 0x80100001'i32
  SCARD_E_CANCELLED* = HRESULT 0x80100002'i32
  SCARD_E_INVALID_HANDLE* = HRESULT 0x80100003'i32
  SCARD_E_INVALID_PARAMETER* = HRESULT 0x80100004'i32
  SCARD_E_INVALID_TARGET* = HRESULT 0x80100005'i32
  SCARD_E_NO_MEMORY* = HRESULT 0x80100006'i32
  SCARD_F_WAITED_TOO_LONG* = HRESULT 0x80100007'i32
  SCARD_E_INSUFFICIENT_BUFFER* = HRESULT 0x80100008'i32
  SCARD_E_UNKNOWN_READER* = HRESULT 0x80100009'i32
  SCARD_E_TIMEOUT* = HRESULT 0x8010000A'i32
  SCARD_E_SHARING_VIOLATION* = HRESULT 0x8010000B'i32
  SCARD_E_NO_SMARTCARD* = HRESULT 0x8010000C'i32
  SCARD_E_UNKNOWN_CARD* = HRESULT 0x8010000D'i32
  SCARD_E_CANT_DISPOSE* = HRESULT 0x8010000E'i32
  SCARD_E_PROTO_MISMATCH* = HRESULT 0x8010000F'i32
  SCARD_E_NOT_READY* = HRESULT 0x80100010'i32
  SCARD_E_INVALID_VALUE* = HRESULT 0x80100011'i32
  SCARD_E_SYSTEM_CANCELLED* = HRESULT 0x80100012'i32
  SCARD_F_COMM_ERROR* = HRESULT 0x80100013'i32
  SCARD_F_UNKNOWN_ERROR* = HRESULT 0x80100014'i32
  SCARD_E_INVALID_ATR* = HRESULT 0x80100015'i32
  SCARD_E_NOT_TRANSACTED* = HRESULT 0x80100016'i32
  SCARD_E_READER_UNAVAILABLE* = HRESULT 0x80100017'i32
  SCARD_P_SHUTDOWN* = HRESULT 0x80100018'i32
  SCARD_E_PCI_TOO_SMALL* = HRESULT 0x80100019'i32
  SCARD_E_READER_UNSUPPORTED* = HRESULT 0x8010001A'i32
  SCARD_E_DUPLICATE_READER* = HRESULT 0x8010001B'i32
  SCARD_E_CARD_UNSUPPORTED* = HRESULT 0x8010001C'i32
  SCARD_E_NO_SERVICE* = HRESULT 0x8010001D'i32
  SCARD_E_SERVICE_STOPPED* = HRESULT 0x8010001E'i32
  SCARD_E_UNEXPECTED* = HRESULT 0x8010001F'i32
  SCARD_E_ICC_INSTALLATION* = HRESULT 0x80100020'i32
  SCARD_E_ICC_CREATEORDER* = HRESULT 0x80100021'i32
  SCARD_E_UNSUPPORTED_FEATURE* = HRESULT 0x80100022'i32
  SCARD_E_DIR_NOT_FOUND* = HRESULT 0x80100023'i32
  SCARD_E_FILE_NOT_FOUND* = HRESULT 0x80100024'i32
  SCARD_E_NO_DIR* = HRESULT 0x80100025'i32
  SCARD_E_NO_FILE* = HRESULT 0x80100026'i32
  SCARD_E_NO_ACCESS* = HRESULT 0x80100027'i32
  SCARD_E_WRITE_TOO_MANY* = HRESULT 0x80100028'i32
  SCARD_E_BAD_SEEK* = HRESULT 0x80100029'i32
  SCARD_E_INVALID_CHV* = HRESULT 0x8010002A'i32
  SCARD_E_UNKNOWN_RES_MNG* = HRESULT 0x8010002B'i32
  SCARD_E_NO_SUCH_CERTIFICATE* = HRESULT 0x8010002C'i32
  SCARD_E_CERTIFICATE_UNAVAILABLE* = HRESULT 0x8010002D'i32
  SCARD_E_NO_READERS_AVAILABLE* = HRESULT 0x8010002E'i32
  SCARD_E_COMM_DATA_LOST* = HRESULT 0x8010002F'i32
  SCARD_E_NO_KEY_CONTAINER* = HRESULT 0x80100030'i32
  SCARD_E_SERVER_TOO_BUSY* = HRESULT 0x80100031'i32
  SCARD_W_UNSUPPORTED_CARD* = HRESULT 0x80100065'i32
  SCARD_W_UNRESPONSIVE_CARD* = HRESULT 0x80100066'i32
  SCARD_W_UNPOWERED_CARD* = HRESULT 0x80100067'i32
  SCARD_W_RESET_CARD* = HRESULT 0x80100068'i32
  SCARD_W_REMOVED_CARD* = HRESULT 0x80100069'i32
  SCARD_W_SECURITY_VIOLATION* = HRESULT 0x8010006A'i32
  SCARD_W_WRONG_CHV* = HRESULT 0x8010006B'i32
  SCARD_W_CHV_BLOCKED* = HRESULT 0x8010006C'i32
  SCARD_W_EOF* = HRESULT 0x8010006D'i32
  SCARD_W_CANCELLED_BY_USER* = HRESULT 0x8010006E'i32
  SCARD_W_CARD_NOT_AUTHENTICATED* = HRESULT 0x8010006F'i32
  SCARD_W_CACHE_ITEM_NOT_FOUND* = HRESULT 0x80100070'i32
  SCARD_W_CACHE_ITEM_STALE* = HRESULT 0x80100071'i32
  COMADMIN_E_OBJECTERRORS* = HRESULT 0x80110401'i32
  COMADMIN_E_OBJECTINVALID* = HRESULT 0x80110402'i32
  COMADMIN_E_KEYMISSING* = HRESULT 0x80110403'i32
  COMADMIN_E_ALREADYINSTALLED* = HRESULT 0x80110404'i32
  COMADMIN_E_APP_FILE_WRITEFAIL* = HRESULT 0x80110407'i32
  COMADMIN_E_APP_FILE_READFAIL* = HRESULT 0x80110408'i32
  COMADMIN_E_APP_FILE_VERSION* = HRESULT 0x80110409'i32
  COMADMIN_E_BADPATH* = HRESULT 0x8011040A'i32
  COMADMIN_E_APPLICATIONEXISTS* = HRESULT 0x8011040B'i32
  COMADMIN_E_ROLEEXISTS* = HRESULT 0x8011040C'i32
  COMADMIN_E_CANTCOPYFILE* = HRESULT 0x8011040D'i32
  COMADMIN_E_NOUSER* = HRESULT 0x8011040F'i32
  COMADMIN_E_INVALIDUSERIDS* = HRESULT 0x80110410'i32
  COMADMIN_E_NOREGISTRYCLSID* = HRESULT 0x80110411'i32
  COMADMIN_E_BADREGISTRYPROGID* = HRESULT 0x80110412'i32
  COMADMIN_E_AUTHENTICATIONLEVEL* = HRESULT 0x80110413'i32
  COMADMIN_E_USERPASSWDNOTVALID* = HRESULT 0x80110414'i32
  COMADMIN_E_CLSIDORIIDMISMATCH* = HRESULT 0x80110418'i32
  COMADMIN_E_REMOTEINTERFACE* = HRESULT 0x80110419'i32
  COMADMIN_E_DLLREGISTERSERVER* = HRESULT 0x8011041A'i32
  COMADMIN_E_NOSERVERSHARE* = HRESULT 0x8011041B'i32
  COMADMIN_E_DLLLOADFAILED* = HRESULT 0x8011041D'i32
  COMADMIN_E_BADREGISTRYLIBID* = HRESULT 0x8011041E'i32
  COMADMIN_E_APPDIRNOTFOUND* = HRESULT 0x8011041F'i32
  COMADMIN_E_REGISTRARFAILED* = HRESULT 0x80110423'i32
  COMADMIN_E_COMPFILE_DOESNOTEXIST* = HRESULT 0x80110424'i32
  COMADMIN_E_COMPFILE_LOADDLLFAIL* = HRESULT 0x80110425'i32
  COMADMIN_E_COMPFILE_GETCLASSOBJ* = HRESULT 0x80110426'i32
  COMADMIN_E_COMPFILE_CLASSNOTAVAIL* = HRESULT 0x80110427'i32
  COMADMIN_E_COMPFILE_BADTLB* = HRESULT 0x80110428'i32
  COMADMIN_E_COMPFILE_NOTINSTALLABLE* = HRESULT 0x80110429'i32
  COMADMIN_E_NOTCHANGEABLE* = HRESULT 0x8011042A'i32
  COMADMIN_E_NOTDELETEABLE* = HRESULT 0x8011042B'i32
  COMADMIN_E_SESSION* = HRESULT 0x8011042C'i32
  COMADMIN_E_COMP_MOVE_LOCKED* = HRESULT 0x8011042D'i32
  COMADMIN_E_COMP_MOVE_BAD_DEST* = HRESULT 0x8011042E'i32
  COMADMIN_E_REGISTERTLB* = HRESULT 0x80110430'i32
  COMADMIN_E_SYSTEMAPP* = HRESULT 0x80110433'i32
  COMADMIN_E_COMPFILE_NOREGISTRAR* = HRESULT 0x80110434'i32
  COMADMIN_E_COREQCOMPINSTALLED* = HRESULT 0x80110435'i32
  COMADMIN_E_SERVICENOTINSTALLED* = HRESULT 0x80110436'i32
  COMADMIN_E_PROPERTYSAVEFAILED* = HRESULT 0x80110437'i32
  COMADMIN_E_OBJECTEXISTS* = HRESULT 0x80110438'i32
  COMADMIN_E_COMPONENTEXISTS* = HRESULT 0x80110439'i32
  COMADMIN_E_REGFILE_CORRUPT* = HRESULT 0x8011043B'i32
  COMADMIN_E_PROPERTY_OVERFLOW* = HRESULT 0x8011043C'i32
  COMADMIN_E_NOTINREGISTRY* = HRESULT 0x8011043E'i32
  COMADMIN_E_OBJECTNOTPOOLABLE* = HRESULT 0x8011043F'i32
  COMADMIN_E_APPLID_MATCHES_CLSID* = HRESULT 0x80110446'i32
  COMADMIN_E_ROLE_DOES_NOT_EXIST* = HRESULT 0x80110447'i32
  COMADMIN_E_START_APP_NEEDS_COMPONENTS* = HRESULT 0x80110448'i32
  COMADMIN_E_REQUIRES_DIFFERENT_PLATFORM* = HRESULT 0x80110449'i32
  COMADMIN_E_CAN_NOT_EXPORT_APP_PROXY* = HRESULT 0x8011044A'i32
  COMADMIN_E_CAN_NOT_START_APP* = HRESULT 0x8011044B'i32
  COMADMIN_E_CAN_NOT_EXPORT_SYS_APP* = HRESULT 0x8011044C'i32
  COMADMIN_E_CANT_SUBSCRIBE_TO_COMPONENT* = HRESULT 0x8011044D'i32
  COMADMIN_E_EVENTCLASS_CANT_BE_SUBSCRIBER* = HRESULT 0x8011044E'i32
  COMADMIN_E_LIB_APP_PROXY_INCOMPATIBLE* = HRESULT 0x8011044F'i32
  COMADMIN_E_BASE_PARTITION_ONLY* = HRESULT 0x80110450'i32
  COMADMIN_E_START_APP_DISABLED* = HRESULT 0x80110451'i32
  COMADMIN_E_CAT_DUPLICATE_PARTITION_NAME* = HRESULT 0x80110457'i32
  COMADMIN_E_CAT_INVALID_PARTITION_NAME* = HRESULT 0x80110458'i32
  COMADMIN_E_CAT_PARTITION_IN_USE* = HRESULT 0x80110459'i32
  COMADMIN_E_FILE_PARTITION_DUPLICATE_FILES* = HRESULT 0x8011045A'i32
  COMADMIN_E_CAT_IMPORTED_COMPONENTS_NOT_ALLOWED* = HRESULT 0x8011045B'i32
  COMADMIN_E_AMBIGUOUS_APPLICATION_NAME* = HRESULT 0x8011045C'i32
  COMADMIN_E_AMBIGUOUS_PARTITION_NAME* = HRESULT 0x8011045D'i32
  COMADMIN_E_REGDB_NOTINITIALIZED* = HRESULT 0x80110472'i32
  COMADMIN_E_REGDB_NOTOPEN* = HRESULT 0x80110473'i32
  COMADMIN_E_REGDB_SYSTEMERR* = HRESULT 0x80110474'i32
  COMADMIN_E_REGDB_ALREADYRUNNING* = HRESULT 0x80110475'i32
  COMADMIN_E_MIG_VERSIONNOTSUPPORTED* = HRESULT 0x80110480'i32
  COMADMIN_E_MIG_SCHEMANOTFOUND* = HRESULT 0x80110481'i32
  COMADMIN_E_CAT_BITNESSMISMATCH* = HRESULT 0x80110482'i32
  COMADMIN_E_CAT_UNACCEPTABLEBITNESS* = HRESULT 0x80110483'i32
  COMADMIN_E_CAT_WRONGAPPBITNESS* = HRESULT 0x80110484'i32
  COMADMIN_E_CAT_PAUSE_RESUME_NOT_SUPPORTED* = HRESULT 0x80110485'i32
  COMADMIN_E_CAT_SERVERFAULT* = HRESULT 0x80110486'i32
  COMQC_E_APPLICATION_NOT_QUEUED* = HRESULT 0x80110600'i32
  COMQC_E_NO_QUEUEABLE_INTERFACES* = HRESULT 0x80110601'i32
  COMQC_E_QUEUING_SERVICE_NOT_AVAILABLE* = HRESULT 0x80110602'i32
  COMQC_E_NO_IPERSISTSTREAM* = HRESULT 0x80110603'i32
  COMQC_E_BAD_MESSAGE* = HRESULT 0x80110604'i32
  COMQC_E_UNAUTHENTICATED* = HRESULT 0x80110605'i32
  COMQC_E_UNTRUSTED_ENQUEUER* = HRESULT 0x80110606'i32
  MSDTC_E_DUPLICATE_RESOURCE* = HRESULT 0x80110701'i32
  COMADMIN_E_OBJECT_PARENT_MISSING* = HRESULT 0x80110808'i32
  COMADMIN_E_OBJECT_DOES_NOT_EXIST* = HRESULT 0x80110809'i32
  COMADMIN_E_APP_NOT_RUNNING* = HRESULT 0x8011080A'i32
  COMADMIN_E_INVALID_PARTITION* = HRESULT 0x8011080B'i32
  COMADMIN_E_SVCAPP_NOT_POOLABLE_OR_RECYCLABLE* = HRESULT 0x8011080D'i32
  COMADMIN_E_USER_IN_SET* = HRESULT 0x8011080E'i32
  COMADMIN_E_CANTRECYCLELIBRARYAPPS* = HRESULT 0x8011080F'i32
  COMADMIN_E_CANTRECYCLESERVICEAPPS* = HRESULT 0x80110811'i32
  COMADMIN_E_PROCESSALREADYRECYCLED* = HRESULT 0x80110812'i32
  COMADMIN_E_PAUSEDPROCESSMAYNOTBERECYCLED* = HRESULT 0x80110813'i32
  COMADMIN_E_CANTMAKEINPROCSERVICE* = HRESULT 0x80110814'i32
  COMADMIN_E_PROGIDINUSEBYCLSID* = HRESULT 0x80110815'i32
  COMADMIN_E_DEFAULT_PARTITION_NOT_IN_SET* = HRESULT 0x80110816'i32
  COMADMIN_E_RECYCLEDPROCESSMAYNOTBEPAUSED* = HRESULT 0x80110817'i32
  COMADMIN_E_PARTITION_ACCESSDENIED* = HRESULT 0x80110818'i32
  COMADMIN_E_PARTITION_MSI_ONLY* = HRESULT 0x80110819'i32
  COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_1_0_FORMAT* = HRESULT 0x8011081A'i32
  COMADMIN_E_LEGACYCOMPS_NOT_ALLOWED_IN_NONBASE_PARTITIONS* = HRESULT 0x8011081B'i32
  COMADMIN_E_COMP_MOVE_SOURCE* = HRESULT 0x8011081C'i32
  COMADMIN_E_COMP_MOVE_DEST* = HRESULT 0x8011081D'i32
  COMADMIN_E_COMP_MOVE_PRIVATE* = HRESULT 0x8011081E'i32
  COMADMIN_E_BASEPARTITION_REQUIRED_IN_SET* = HRESULT 0x8011081F'i32
  COMADMIN_E_CANNOT_ALIAS_EVENTCLASS* = HRESULT 0x80110820'i32
  COMADMIN_E_PRIVATE_ACCESSDENIED* = HRESULT 0x80110821'i32
  COMADMIN_E_SAFERINVALID* = HRESULT 0x80110822'i32
  COMADMIN_E_REGISTRY_ACCESSDENIED* = HRESULT 0x80110823'i32
  COMADMIN_E_PARTITIONS_DISABLED* = HRESULT 0x80110824'i32
  VSS_E_BAD_STATE* = HRESULT 0x80042301'i32
  VSS_E_LEGACY_PROVIDER* = HRESULT 0x800423F7'i32
  VSS_E_RESYNC_IN_PROGRESS* = HRESULT 0x800423FF'i32
  VSS_E_SNAPSHOT_NOT_IN_SET* = HRESULT 0x8004232B'i32
  VSS_E_MAXIMUM_NUMBER_OF_VOLUMES_REACHED* = HRESULT 0x80042312'i32
  VSS_E_MAXIMUM_NUMBER_OF_SNAPSHOTS_REACHED* = HRESULT 0x80042317'i32
  VSS_E_NESTED_VOLUME_LIMIT* = HRESULT 0x8004232C'i32
  VSS_E_OBJECT_NOT_FOUND* = HRESULT 0x80042308'i32
  VSS_E_PROVIDER_NOT_REGISTERED* = HRESULT 0x80042304'i32
  VSS_E_PROVIDER_VETO* = HRESULT 0x80042306'i32
  VSS_E_VOLUME_NOT_SUPPORTED* = HRESULT 0x8004230C'i32
  VSS_E_VOLUME_NOT_SUPPORTED_BY_PROVIDER* = HRESULT 0x8004230E'i32
  VSS_E_UNEXPECTED* = HRESULT 0x80042302'i32
  VSS_E_UNEXPECTED_PROVIDER_ERROR* = HRESULT 0x8004230F'i32
  VSS_E_UNSELECTED_VOLUME* = HRESULT 0x8004232A'i32
  VSS_E_CANNOT_REVERT_DISKID* = HRESULT 0x800423FE'i32
  VSS_E_INVALID_XML_DOCUMENT* = HRESULT 0x80042311'i32
  VSS_E_OBJECT_ALREADY_EXISTS* = HRESULT 0x8004230D'i32
  DXGI_ERROR_INVALID_CALL* = HRESULT 0x887A0001'i32
  DXGI_ERROR_NOT_FOUND* = HRESULT 0x887A0002'i32
  DXGI_ERROR_MORE_DATA* = HRESULT 0x887A0003'i32
  DXGI_ERROR_UNSUPPORTED* = HRESULT 0x887A0004'i32
  DXGI_ERROR_DEVICE_REMOVED* = HRESULT 0x887A0005'i32
  DXGI_ERROR_DEVICE_HUNG* = HRESULT 0x887A0006'i32
  DXGI_ERROR_DEVICE_RESET* = HRESULT 0x887A0007'i32
  DXGI_ERROR_WAS_STILL_DRAWING* = HRESULT 0x887A000A'i32
  DXGI_ERROR_FRAME_STATISTICS_DISJOINT* = HRESULT 0x887A000B'i32
  DXGI_ERROR_GRAPHICS_VIDPN_SOURCE_IN_USE* = HRESULT 0x887A000C'i32
  DXGI_ERROR_DRIVER_INTERNAL_ERROR* = HRESULT 0x887A0020'i32
  DXGI_ERROR_NONEXCLUSIVE* = HRESULT 0x887A0021'i32
  DXGI_ERROR_NOT_CURRENTLY_AVAILABLE* = HRESULT 0x887A0022'i32
  DXGI_ERROR_REMOTE_CLIENT_DISCONNECTED* = HRESULT 0x887A0023'i32
  DXGI_ERROR_REMOTE_OUTOFMEMORY* = HRESULT 0x887A0024'i32
  DXGI_ERROR_ACCESS_LOST* = HRESULT 0x887A0026'i32
  DXGI_ERROR_WAIT_TIMEOUT* = HRESULT 0x887A0027'i32
  DXGI_ERROR_SESSION_DISCONNECTED* = HRESULT 0x887A0028'i32
  DXGI_ERROR_RESTRICT_TO_OUTPUT_STALE* = HRESULT 0x887A0029'i32
  DXGI_ERROR_CANNOT_PROTECT_CONTENT* = HRESULT 0x887A002A'i32
  DXGI_ERROR_ACCESS_DENIED* = HRESULT 0x887A002B'i32
  DXGI_ERROR_NAME_ALREADY_EXISTS* = HRESULT 0x887A002C'i32
  DXGI_ERROR_SDK_COMPONENT_MISSING* = HRESULT 0x887A002D'i32
  TBS_SUCCESS* = 0
  TBS_E_INTERNAL_ERROR* = HRESULT 0x80284001'i32
  TBS_E_BAD_PARAMETER* = HRESULT 0x80284002'i32
  TBS_E_INVALID_OUTPUT_POINTER* = HRESULT 0x80284003'i32
  TBS_E_INSUFFICIENT_BUFFER* = HRESULT 0x80284005'i32
  TBS_E_IOERROR* = HRESULT 0x80284006'i32
  TBS_E_INVALID_CONTEXT_PARAM* = HRESULT 0x80284007'i32
  TBS_E_SERVICE_NOT_RUNNING* = HRESULT 0x80284008'i32
  TBS_E_TOO_MANY_TBS_CONTEXTS* = HRESULT 0x80284009'i32
  TBS_E_SERVICE_START_PENDING* = HRESULT 0x8028400B'i32
  TBS_E_BUFFER_TOO_LARGE* = HRESULT 0x8028400E'i32
  TBS_E_TPM_NOT_FOUND* = HRESULT 0x8028400F'i32
  TBS_E_SERVICE_DISABLED* = HRESULT 0x80284010'i32
  TBS_E_DEACTIVATED* = HRESULT 0x80284016'i32
  FWP_E_CALLOUT_NOT_FOUND* = HRESULT 0x80320001'i32
  FWP_E_CONDITION_NOT_FOUND* = HRESULT 0x80320002'i32
  FWP_E_FILTER_NOT_FOUND* = HRESULT 0x80320003'i32
  FWP_E_LAYER_NOT_FOUND* = HRESULT 0x80320004'i32
  FWP_E_PROVIDER_NOT_FOUND* = HRESULT 0x80320005'i32
  FWP_E_PROVIDER_CONTEXT_NOT_FOUND* = HRESULT 0x80320006'i32
  FWP_E_SUBLAYER_NOT_FOUND* = HRESULT 0x80320007'i32
  FWP_E_NOT_FOUND* = HRESULT 0x80320008'i32
  FWP_E_ALREADY_EXISTS* = HRESULT 0x80320009'i32
  FWP_E_IN_USE* = HRESULT 0x8032000A'i32
  FWP_E_DYNAMIC_SESSION_IN_PROGRESS* = HRESULT 0x8032000B'i32
  FWP_E_WRONG_SESSION* = HRESULT 0x8032000C'i32
  FWP_E_NO_TXN_IN_PROGRESS* = HRESULT 0x8032000D'i32
  FWP_E_TXN_IN_PROGRESS* = HRESULT 0x8032000E'i32
  FWP_E_TXN_ABORTED* = HRESULT 0x8032000F'i32
  FWP_E_SESSION_ABORTED* = HRESULT 0x80320010'i32
  FWP_E_INCOMPATIBLE_TXN* = HRESULT 0x80320011'i32
  FWP_E_TIMEOUT* = HRESULT 0x80320012'i32
  FWP_E_NET_EVENTS_DISABLED* = HRESULT 0x80320013'i32
  FWP_E_INCOMPATIBLE_LAYER* = HRESULT 0x80320014'i32
  FWP_E_KM_CLIENTS_ONLY* = HRESULT 0x80320015'i32
  FWP_E_LIFETIME_MISMATCH* = HRESULT 0x80320016'i32
  FWP_E_BUILTIN_OBJECT* = HRESULT 0x80320017'i32
  FWP_E_TOO_MANY_CALLOUTS* = HRESULT 0x80320018'i32
  FWP_E_NOTIFICATION_DROPPED* = HRESULT 0x80320019'i32
  FWP_E_TRAFFIC_MISMATCH* = HRESULT 0x8032001A'i32
  FWP_E_INCOMPATIBLE_SA_STATE* = HRESULT 0x8032001B'i32
  FWP_E_NULL_POINTER* = HRESULT 0x8032001C'i32
  FWP_E_INVALID_ENUMERATOR* = HRESULT 0x8032001D'i32
  FWP_E_INVALID_FLAGS* = HRESULT 0x8032001E'i32
  FWP_E_INVALID_NET_MASK* = HRESULT 0x8032001F'i32
  FWP_E_INVALID_RANGE* = HRESULT 0x80320020'i32
  FWP_E_INVALID_INTERVAL* = HRESULT 0x80320021'i32
  FWP_E_ZERO_LENGTH_ARRAY* = HRESULT 0x80320022'i32
  FWP_E_NULL_DISPLAY_NAME* = HRESULT 0x80320023'i32
  FWP_E_INVALID_ACTION_TYPE* = HRESULT 0x80320024'i32
  FWP_E_INVALID_WEIGHT* = HRESULT 0x80320025'i32
  FWP_E_MATCH_TYPE_MISMATCH* = HRESULT 0x80320026'i32
  FWP_E_TYPE_MISMATCH* = HRESULT 0x80320027'i32
  FWP_E_OUT_OF_BOUNDS* = HRESULT 0x80320028'i32
  FWP_E_RESERVED* = HRESULT 0x80320029'i32
  FWP_E_DUPLICATE_CONDITION* = HRESULT 0x8032002A'i32
  FWP_E_DUPLICATE_KEYMOD* = HRESULT 0x8032002B'i32
  FWP_E_ACTION_INCOMPATIBLE_WITH_LAYER* = HRESULT 0x8032002C'i32
  FWP_E_ACTION_INCOMPATIBLE_WITH_SUBLAYER* = HRESULT 0x8032002D'i32
  FWP_E_CONTEXT_INCOMPATIBLE_WITH_LAYER* = HRESULT 0x8032002E'i32
  FWP_E_CONTEXT_INCOMPATIBLE_WITH_CALLOUT* = HRESULT 0x8032002F'i32
  FWP_E_INCOMPATIBLE_AUTH_METHOD* = HRESULT 0x80320030'i32
  FWP_E_INCOMPATIBLE_DH_GROUP* = HRESULT 0x80320031'i32
  FWP_E_EM_NOT_SUPPORTED* = HRESULT 0x80320032'i32
  FWP_E_NEVER_MATCH* = HRESULT 0x80320033'i32
  FWP_E_PROVIDER_CONTEXT_MISMATCH* = HRESULT 0x80320034'i32
  FWP_E_INVALID_PARAMETER* = HRESULT 0x80320035'i32
  FWP_E_TOO_MANY_SUBLAYERS* = HRESULT 0x80320036'i32
  FWP_E_CALLOUT_NOTIFICATION_FAILED* = HRESULT 0x80320037'i32
  FWP_E_INVALID_AUTH_TRANSFORM* = HRESULT 0x80320038'i32
  FWP_E_INVALID_CIPHER_TRANSFORM* = HRESULT 0x80320039'i32
  NAP_E_INVALID_PACKET* = HRESULT 0x80270001'i32
  NAP_E_MISSING_SOH* = HRESULT 0x80270002'i32
  NAP_E_CONFLICTING_ID* = HRESULT 0x80270003'i32
  NAP_E_NO_CACHED_SOH* = HRESULT 0x80270004'i32
  NAP_E_STILL_BOUND* = HRESULT 0x80270005'i32
  NAP_E_NOT_REGISTERED* = HRESULT 0x80270006'i32
  NAP_E_NOT_INITIALIZED* = HRESULT 0x80270007'i32
  NAP_E_MISMATCHED_ID* = HRESULT 0x80270008'i32
  NAP_E_NOT_PENDING* = HRESULT 0x80270009'i32
  NAP_E_ID_NOT_FOUND* = HRESULT 0x8027000A'i32
  NAP_E_MAXSIZE_TOO_SMALL* = HRESULT 0x8027000B'i32
  NAP_E_SERVICE_NOT_RUNNING* = HRESULT 0x8027000C'i32
  NAP_S_CERT_ALREADY_PRESENT* = HRESULT 0x0027000D
  NAP_E_ENTITY_DISABLED* = HRESULT 0x8027000E'i32
  NAP_E_NETSH_GROUPPOLICY_ERROR* = HRESULT 0x8027000F'i32
  NAP_E_TOO_MANY_CALLS* = HRESULT 0x80270010'i32
  NAP_E_SHV_CONFIG_EXISTED* = HRESULT 0x80270011'i32
  NAP_E_SHV_CONFIG_NOT_FOUND* = HRESULT 0x80270012'i32
  NAP_E_SHV_TIMEOUT* = HRESULT 0x80270013'i32
  FACILITY_USERMODE_FILTER_MANAGER* = 0x1f
  ERROR_FLT_IO_COMPLETE* = HRESULT 0x001f0001
  ERROR_FLT_NO_HANDLER_DEFINED* = HRESULT 0x801f0001'i32
  ERROR_FLT_CONTEXT_ALREADY_DEFINED* = HRESULT 0x801f0002'i32
  ERROR_FLT_INVALID_ASYNCHRONOUS_REQUEST* = HRESULT 0x801f0003'i32
  ERROR_FLT_DISALLOW_FAST_IO* = HRESULT 0x801f0004'i32
  ERROR_FLT_INVALID_NAME_REQUEST* = HRESULT 0x801f0005'i32
  ERROR_FLT_NOT_SAFE_TO_POST_OPERATION* = HRESULT 0x801f0006'i32
  ERROR_FLT_NOT_INITIALIZED* = HRESULT 0x801f0007'i32
  ERROR_FLT_FILTER_NOT_READY* = HRESULT 0x801f0008'i32
  ERROR_FLT_POST_OPERATION_CLEANUP* = HRESULT 0x801f0009'i32
  ERROR_FLT_INTERNAL_ERROR* = HRESULT 0x801f000a'i32
  ERROR_FLT_DELETING_OBJECT* = HRESULT 0x801f000b'i32
  ERROR_FLT_MUST_BE_NONPAGED_POOL* = HRESULT 0x801f000c'i32
  ERROR_FLT_DUPLICATE_ENTRY* = HRESULT 0x801f000d'i32
  ERROR_FLT_CBDQ_DISABLED* = HRESULT 0x801f000e'i32
  ERROR_FLT_DO_NOT_ATTACH* = HRESULT 0x801f000f'i32
  ERROR_FLT_DO_NOT_DETACH* = HRESULT 0x801f0010'i32
  ERROR_FLT_INSTANCE_ALTITUDE_COLLISION* = HRESULT 0x801f0011'i32
  ERROR_FLT_INSTANCE_NAME_COLLISION* = HRESULT 0x801f0012'i32
  ERROR_FLT_FILTER_NOT_FOUND* = HRESULT 0x801f0013'i32
  ERROR_FLT_VOLUME_NOT_FOUND* = HRESULT 0x801f0014'i32
  ERROR_FLT_INSTANCE_NOT_FOUND* = HRESULT 0x801f0015'i32
  ERROR_FLT_CONTEXT_ALLOCATION_NOT_FOUND* = HRESULT 0x801f0016'i32
  ERROR_FLT_INVALID_CONTEXT_REGISTRATION* = HRESULT 0x801f0017'i32
  ERROR_FLT_NAME_CACHE_MISS* = HRESULT 0x801f0018'i32
  ERROR_FLT_NO_DEVICE_OBJECT* = HRESULT 0x801f0019'i32
  ERROR_FLT_VOLUME_ALREADY_MOUNTED* = HRESULT 0x801f001a'i32
  ERROR_FLT_ALREADY_ENLISTED* = HRESULT 0x801f001b'i32
  ERROR_FLT_CONTEXT_ALREADY_LINKED* = HRESULT 0x801F001c'i32
  ERROR_FLT_NO_WAITER_FOR_REPLY* = HRESULT 0x801f0020'i32
  ERROR_FLT_REGISTRATION_BUSY* = HRESULT 0x801F0023'i32
template SUCCEEDED*(hr: untyped): bool = hr.HRESULT >= 0
template FAILED*(hr: untyped): bool = hr.HRESULT < 0
template IS_ERROR*(Status: untyped): bool = Status shr 31 == SEVERITY_ERROR
template HRESULT_CODE*(hr: untyped): WORD = WORD(hr and 0xFFFF)
template SCODE_CODE*(sc: untyped): WORD = WORD(sc and 0xFFFF)
template HRESULT_FACILITY*(hr: untyped): WORD = WORD((hr shr 16) and 0x1fff)
template SCODE_FACILITY*(sc: untyped): WORD = WORD((sc shr 16) and 0x1fff)
template HRESULT_SEVERITY*(hr: untyped): DWORD = DWORD((hr shr 31) and 0x1)
template SCODE_SEVERITY*(sc: untyped): DWORD = DWORD((hr shr 31) and 0x1)
template MAKE_HRESULT*(sev: untyped, fac: untyped, code: untyped): HRESULT = (sev.HRESULT shl 31) or (fac.HRESULT shl 16) or (code.HRESULT)
template MAKE_SCODE*(sev: untyped, fac: untyped, code: untyped): HRESULT = (sev.HRESULT shl 31) or (fac.HRESULT shl 16) or (code.HRESULT)
template HRESULT_FROM_NT*(x: untyped): HRESULT = HRESULT(x or FACILITY_NT_BIT)
